/* FavoritesTimeline.c generated by valac 0.54.3, the Vala compiler
 * generated from FavoritesTimeline.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include "CbMessageReceiver.h"
#include <glib-object.h>
#include "CbUserStream.h"
#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include "CbTweetModel.h"
#include "CbTweet.h"
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

#define TYPE_FAVORITES_TIMELINE (favorites_timeline_get_type ())
#define FAVORITES_TIMELINE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FAVORITES_TIMELINE, FavoritesTimeline))
#define FAVORITES_TIMELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FAVORITES_TIMELINE, FavoritesTimelineClass))
#define IS_FAVORITES_TIMELINE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FAVORITES_TIMELINE))
#define IS_FAVORITES_TIMELINE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FAVORITES_TIMELINE))
#define FAVORITES_TIMELINE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FAVORITES_TIMELINE, FavoritesTimelineClass))

typedef struct _FavoritesTimeline FavoritesTimeline;
typedef struct _FavoritesTimelineClass FavoritesTimelineClass;
typedef struct _FavoritesTimelinePrivate FavoritesTimelinePrivate;
enum  {
	FAVORITES_TIMELINE_0_PROPERTY,
	FAVORITES_TIMELINE_FUNCTION_PROPERTY,
	FAVORITES_TIMELINE_ACCESSIBILITY_NAME_PROPERTY,
	FAVORITES_TIMELINE_NUM_PROPERTIES
};
static GParamSpec* favorites_timeline_properties[FAVORITES_TIMELINE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _FavoritesTimeline {
	DefaultTimeline parent_instance;
	FavoritesTimelinePrivate * priv;
};

struct _FavoritesTimelineClass {
	DefaultTimelineClass parent_class;
};

static gpointer favorites_timeline_parent_class = NULL;
static CbMessageReceiverInterface * favorites_timeline_cb_message_receiver_parent_iface = NULL;

VALA_EXTERN GType favorites_timeline_get_type (void) G_GNUC_CONST ;
VALA_EXTERN FavoritesTimeline* favorites_timeline_new (gint id,
                                           Account* account);
VALA_EXTERN FavoritesTimeline* favorites_timeline_construct (GType object_type,
                                                 gint id,
                                                 Account* account);
static void favorites_timeline_real_stream_message_received (CbMessageReceiver* base,
                                                      CbStreamMessageType type,
                                                      JsonNode* root);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static void favorites_timeline_real_on_leave (DefaultTimeline* base);
static gchar* favorites_timeline_real_get_title (DefaultTimeline* base);
static void favorites_timeline_real_create_radio_button (DefaultTimeline* base,
                                                  GtkRadioButton* group);
static GType favorites_timeline_get_type_once (void);
static void _vala_favorites_timeline_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

FavoritesTimeline*
favorites_timeline_construct (GType object_type,
                              gint id,
                              Account* account)
{
	FavoritesTimeline * self = NULL;
	TweetListBox* _tmp0_;
	g_return_val_if_fail (account != NULL, NULL);
	self = (FavoritesTimeline*) default_timeline_construct (object_type, id);
	((DefaultTimeline*) self)->account = account;
	_tmp0_ = ((DefaultTimeline*) self)->tweet_list;
	_tmp0_->account = account;
	return self;
}

FavoritesTimeline*
favorites_timeline_new (gint id,
                        Account* account)
{
	return favorites_timeline_construct (TYPE_FAVORITES_TIMELINE, id, account);
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
	return g_boxed_copy (json_node_get_type (), self);
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
	return self ? _vala_JsonNode_copy (self) : NULL;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static void
favorites_timeline_real_stream_message_received (CbMessageReceiver* base,
                                                 CbStreamMessageType type,
                                                 JsonNode* root)
{
	FavoritesTimeline * self;
	self = (FavoritesTimeline*) base;
	g_return_if_fail (root != NULL);
	if (type == CB_STREAM_MESSAGE_TWEET) {
		JsonObject* _tmp0_;
		_tmp0_ = json_node_get_object (root);
		if (json_object_has_member (_tmp0_, "retweeted_status")) {
			TweetListBox* _tmp1_;
			CbTweetModel* _tmp2_;
			Account* _tmp3_;
			_tmp1_ = ((DefaultTimeline*) self)->tweet_list;
			_tmp2_ = _tmp1_->model;
			_tmp3_ = ((DefaultTimeline*) self)->account;
			utils_set_rt_from_tweet (root, _tmp2_, _tmp3_);
		}
	} else {
		if (type == CB_STREAM_MESSAGE_DELETE) {
			gint64 id = 0LL;
			JsonObject* _tmp4_;
			JsonObject* _tmp5_;
			JsonObject* _tmp6_;
			_tmp4_ = json_node_get_object (root);
			_tmp5_ = json_object_get_object_member (_tmp4_, "delete");
			_tmp6_ = json_object_get_object_member (_tmp5_, "status");
			id = json_object_get_int_member (_tmp6_, "id");
			default_timeline_delete_tweet ((DefaultTimeline*) self, id);
		} else {
			if (type == CB_STREAM_MESSAGE_RT_DELETE) {
				TweetListBox* _tmp7_;
				CbTweetModel* _tmp8_;
				_tmp7_ = ((DefaultTimeline*) self)->tweet_list;
				_tmp8_ = _tmp7_->model;
				utils_unrt_tweet (root, _tmp8_);
			} else {
				if (type == CB_STREAM_MESSAGE_EVENT_FAVORITE) {
					JsonNode* tweet_obj = NULL;
					JsonNode* _tmp9_;
					gint64 tweet_id = 0LL;
					JsonNode* _tmp10_;
					JsonObject* _tmp11_;
					CbTweet* existing_tweet = NULL;
					TweetListBox* _tmp12_;
					CbTweetModel* _tmp13_;
					CbTweet* _tmp14_;
					CbTweet* _tmp15_;
					CbTweet* _tmp16_;
					CbTweet* tweet = NULL;
					CbTweet* _tmp20_;
					CbTweet* _tmp21_;
					JsonNode* _tmp22_;
					Account* _tmp23_;
					GDateTime* _tmp24_;
					GDateTime* _tmp25_;
					CbTweet* _tmp26_;
					TweetListBox* _tmp27_;
					CbTweetModel* _tmp28_;
					CbTweet* _tmp29_;
					_tmp9_ = __vala_JsonNode_copy0 (root);
					tweet_obj = _tmp9_;
					_tmp10_ = tweet_obj;
					_tmp11_ = json_node_get_object (_tmp10_);
					tweet_id = json_object_get_int_member (_tmp11_, "id");
					_tmp12_ = ((DefaultTimeline*) self)->tweet_list;
					_tmp13_ = _tmp12_->model;
					_tmp14_ = cb_tweet_model_get_for_id (_tmp13_, tweet_id, 0);
					_tmp15_ = _g_object_ref0 (_tmp14_);
					existing_tweet = _tmp15_;
					_tmp16_ = existing_tweet;
					if (_tmp16_ != NULL) {
						TweetListBox* _tmp17_;
						CbTweetModel* _tmp18_;
						CbTweet* _tmp19_;
						_tmp17_ = ((DefaultTimeline*) self)->tweet_list;
						_tmp18_ = _tmp17_->model;
						_tmp19_ = existing_tweet;
						cb_tweet_model_set_tweet_flag (_tmp18_, _tmp19_, CB_TWEET_STATE_FAVORITED);
						_g_object_unref0 (existing_tweet);
						__vala_JsonNode_free0 (tweet_obj);
						return;
					}
					_tmp20_ = cb_tweet_new ();
					tweet = _tmp20_;
					_tmp21_ = tweet;
					_tmp22_ = tweet_obj;
					_tmp23_ = ((DefaultTimeline*) self)->account;
					_tmp24_ = g_date_time_new_now_local ();
					_tmp25_ = _tmp24_;
					cb_tweet_load_from_json (_tmp21_, _tmp22_, _tmp23_->id, _tmp25_);
					_g_date_time_unref0 (_tmp25_);
					_tmp26_ = tweet;
					cb_tweet_set_flag (_tmp26_, (guint) CB_TWEET_STATE_FAVORITED);
					_tmp27_ = ((DefaultTimeline*) self)->tweet_list;
					_tmp28_ = _tmp27_->model;
					_tmp29_ = tweet;
					cb_tweet_model_add (_tmp28_, _tmp29_);
					_g_object_unref0 (tweet);
					_g_object_unref0 (existing_tweet);
					__vala_JsonNode_free0 (tweet_obj);
				} else {
					if (type == CB_STREAM_MESSAGE_EVENT_UNFAVORITE) {
						gint64 id = 0LL;
						JsonObject* _tmp30_;
						JsonObject* _tmp31_;
						_tmp30_ = json_node_get_object (root);
						_tmp31_ = json_object_get_object_member (_tmp30_, "target_object");
						id = json_object_get_int_member (_tmp31_, "id");
						default_timeline_toggle_favorite ((DefaultTimeline*) self, id, FALSE);
					} else {
						default_timeline_handle_core_stream_messages ((DefaultTimeline*) self, type, root);
					}
				}
			}
		}
	}
}

static void
favorites_timeline_real_on_leave (DefaultTimeline* base)
{
	FavoritesTimeline * self;
	self = (FavoritesTimeline*) base;
	{
		guint i = 0U;
		i = (guint) 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				TweetListBox* _tmp2_;
				CbTweetModel* _tmp3_;
				CbTweet* tweet = NULL;
				TweetListBox* _tmp4_;
				CbTweetModel* _tmp5_;
				GObject* _tmp6_;
				CbTweet* _tmp7_;
				if (!_tmp0_) {
					guint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				_tmp2_ = ((DefaultTimeline*) self)->tweet_list;
				_tmp3_ = _tmp2_->model;
				if (!(i < g_list_model_get_n_items ((GListModel*) _tmp3_))) {
					break;
				}
				_tmp4_ = ((DefaultTimeline*) self)->tweet_list;
				_tmp5_ = _tmp4_->model;
				_tmp6_ = g_list_model_get_item ((GListModel*) _tmp5_, i);
				tweet = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, CB_TYPE_TWEET, CbTweet);
				_tmp7_ = tweet;
				if (!cb_tweet_is_flag_set (_tmp7_, (guint) CB_TWEET_STATE_FAVORITED)) {
					TweetListBox* _tmp8_;
					CbTweetModel* _tmp9_;
					CbTweet* _tmp10_;
					guint _tmp11_;
					_tmp8_ = ((DefaultTimeline*) self)->tweet_list;
					_tmp9_ = _tmp8_->model;
					_tmp10_ = tweet;
					cb_tweet_model_remove_tweet (_tmp9_, _tmp10_);
					_tmp11_ = i;
					i = _tmp11_ - 1;
				}
				_g_object_unref0 (tweet);
			}
		}
	}
	DEFAULT_TIMELINE_CLASS (favorites_timeline_parent_class)->on_leave (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DEFAULT_TIMELINE, DefaultTimeline));
}

static gchar*
favorites_timeline_real_get_title (DefaultTimeline* base)
{
	FavoritesTimeline * self;
	gchar* _tmp0_;
	gchar* result = NULL;
	self = (FavoritesTimeline*) base;
	_tmp0_ = g_strdup (_ ("Likes"));
	result = _tmp0_;
	return result;
}

static void
favorites_timeline_real_create_radio_button (DefaultTimeline* base,
                                             GtkRadioButton* group)
{
	FavoritesTimeline * self;
	BadgeRadioButton* _tmp0_;
	self = (FavoritesTimeline*) base;
	_tmp0_ = badge_radio_button_new (group, "cawbird-favorite-symbolic", _ ("Likes"));
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (((DefaultTimeline*) self)->radio_button);
	((DefaultTimeline*) self)->radio_button = _tmp0_;
}

static const gchar*
favorites_timeline_real_get_function (DefaultTimeline* base)
{
	const gchar* result;
	FavoritesTimeline* self;
	self = (FavoritesTimeline*) base;
	result = "1.1/favorites/list.json";
	return result;
}

static const gchar*
favorites_timeline_real_get_accessibility_name (DefaultTimeline* base)
{
	const gchar* result;
	FavoritesTimeline* self;
	self = (FavoritesTimeline*) base;
	result = _ ("Liked tweets timeline");
	return result;
}

static void
favorites_timeline_class_init (FavoritesTimelineClass * klass,
                               gpointer klass_data)
{
	favorites_timeline_parent_class = g_type_class_peek_parent (klass);
	((DefaultTimelineClass *) klass)->stream_message_received = (void (*) (DefaultTimeline*, CbStreamMessageType, JsonNode*)) favorites_timeline_real_stream_message_received;
	((DefaultTimelineClass *) klass)->on_leave = (void (*) (DefaultTimeline*)) favorites_timeline_real_on_leave;
	((DefaultTimelineClass *) klass)->get_title = (gchar* (*) (DefaultTimeline*)) favorites_timeline_real_get_title;
	((DefaultTimelineClass *) klass)->create_radio_button = (void (*) (DefaultTimeline*, GtkRadioButton*)) favorites_timeline_real_create_radio_button;
	DEFAULT_TIMELINE_CLASS (klass)->get_function = favorites_timeline_real_get_function;
	DEFAULT_TIMELINE_CLASS (klass)->get_accessibility_name = favorites_timeline_real_get_accessibility_name;
	G_OBJECT_CLASS (klass)->get_property = _vala_favorites_timeline_get_property;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FAVORITES_TIMELINE_FUNCTION_PROPERTY, favorites_timeline_properties[FAVORITES_TIMELINE_FUNCTION_PROPERTY] = g_param_spec_string ("function", "function", "function", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), FAVORITES_TIMELINE_ACCESSIBILITY_NAME_PROPERTY, favorites_timeline_properties[FAVORITES_TIMELINE_ACCESSIBILITY_NAME_PROPERTY] = g_param_spec_string ("accessibility-name", "accessibility-name", "accessibility-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
favorites_timeline_cb_message_receiver_interface_init (CbMessageReceiverInterface * iface,
                                                       gpointer iface_data)
{
	favorites_timeline_cb_message_receiver_parent_iface = g_type_interface_peek_parent (iface);
	iface->stream_message_received = (void (*) (CbMessageReceiver*, CbStreamMessageType, JsonNode*)) favorites_timeline_real_stream_message_received;
}

static void
favorites_timeline_instance_init (FavoritesTimeline * self,
                                  gpointer klass)
{
}

static GType
favorites_timeline_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FavoritesTimelineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) favorites_timeline_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FavoritesTimeline), 0, (GInstanceInitFunc) favorites_timeline_instance_init, NULL };
	static const GInterfaceInfo cb_message_receiver_info = { (GInterfaceInitFunc) favorites_timeline_cb_message_receiver_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType favorites_timeline_type_id;
	favorites_timeline_type_id = g_type_register_static (TYPE_DEFAULT_TIMELINE, "FavoritesTimeline", &g_define_type_info, 0);
	g_type_add_interface_static (favorites_timeline_type_id, CB_TYPE_MESSAGE_RECEIVER, &cb_message_receiver_info);
	return favorites_timeline_type_id;
}

GType
favorites_timeline_get_type (void)
{
	static volatile gsize favorites_timeline_type_id__volatile = 0;
	if (g_once_init_enter (&favorites_timeline_type_id__volatile)) {
		GType favorites_timeline_type_id;
		favorites_timeline_type_id = favorites_timeline_get_type_once ();
		g_once_init_leave (&favorites_timeline_type_id__volatile, favorites_timeline_type_id);
	}
	return favorites_timeline_type_id__volatile;
}

static void
_vala_favorites_timeline_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	FavoritesTimeline * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FAVORITES_TIMELINE, FavoritesTimeline);
	switch (property_id) {
		case FAVORITES_TIMELINE_FUNCTION_PROPERTY:
		g_value_set_string (value, default_timeline_get_function ((DefaultTimeline*) self));
		break;
		case FAVORITES_TIMELINE_ACCESSIBILITY_NAME_PROPERTY:
		g_value_set_string (value, default_timeline_get_accessibility_name ((DefaultTimeline*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

