/* HomeTimeline.c generated by valac 0.54.3, the Vala compiler
 * generated from HomeTimeline.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include <glib.h>
#include "CbUserStream.h"
#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "CbTweet.h"
#include <gio/gio.h>
#include "CbTypes.h"
#include "CbTweetModel.h"
#include <glib/gi18n-lib.h>
#include "CbMessageReceiver.h"

enum  {
	HOME_TIMELINE_0_PROPERTY,
	HOME_TIMELINE_FUNCTION_PROPERTY,
	HOME_TIMELINE_ACCESSIBILITY_NAME_PROPERTY,
	HOME_TIMELINE_NUM_PROPERTIES
};
static GParamSpec* home_timeline_properties[HOME_TIMELINE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _HomeTimelineLoadTweetsFromFollowData HomeTimelineLoadTweetsFromFollowData;

struct _HomeTimelinePrivate {
	gint64 last_tweet_id;
};

struct _HomeTimelineLoadTweetsFromFollowData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	HomeTimeline* self;
	JsonNode* follow_root;
	gint64 follow_id;
	JsonArray* root_array;
	Account* _tmp0_;
	TweetListBox* _tmp1_;
	CbTweetModel* _tmp2_;
	JsonArray* _tmp3_;
	GError* e;
	GError* _tmp4_;
	const gchar* _tmp5_;
	GError* _inner_error0_;
};

static gint HomeTimeline_private_offset;
static gpointer home_timeline_parent_class = NULL;
static CbMessageReceiverInterface * home_timeline_cb_message_receiver_parent_iface = NULL;

static void home_timeline_real_stream_message_received (CbMessageReceiver* base,
                                                 CbStreamMessageType type,
                                                 JsonNode* root);
static void home_timeline_load_tweets_from_follow (HomeTimeline* self,
                                            JsonNode* follow_root,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_);
static void home_timeline_load_tweets_from_follow_finish (HomeTimeline* self,
                                                   GAsyncResult* _res_);
VALA_EXTERN void tweet_utils_set_tweet_hidden_flags (CbTweet* t,
                                         Account* account);
#define TOP 1
static void _vala_JsonNode_free (JsonNode* self);
static void home_timeline_load_tweets_from_follow_data_free (gpointer _data);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static gboolean home_timeline_load_tweets_from_follow_co (HomeTimelineLoadTweetsFromFollowData* _data_);
VALA_EXTERN void user_utils_load_user_timeline_by_id (Account* account,
                                          gint64 user_id,
                                          gint tweet_count,
                                          gint64 since_id,
                                          gint64 max_id,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
VALA_EXTERN JsonArray* user_utils_load_user_timeline_by_id_finish (GAsyncResult* _res_,
                                                       GError** error);
static void home_timeline_load_tweets_from_follow_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_);
static void ___lambda219_ (HomeTimeline* self,
                    JsonArray* array,
                    guint idx,
                    JsonNode* node);
static void ____lambda219__json_array_foreach (JsonArray* array,
                                        guint index_,
                                        JsonNode* element_node,
                                        gpointer self);
static gchar* home_timeline_real_get_title (DefaultTimeline* base);
static void home_timeline_real_create_radio_button (DefaultTimeline* base,
                                             GtkRadioButton* group);
static void home_timeline_finalize (GObject * obj);
static GType home_timeline_get_type_once (void);
static void _vala_home_timeline_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
home_timeline_get_instance_private (HomeTimeline* self)
{
	return G_STRUCT_MEMBER_P (self, HomeTimeline_private_offset);
}

HomeTimeline*
home_timeline_construct (GType object_type,
                         gint id,
                         Account* account)
{
	HomeTimeline * self = NULL;
	TweetListBox* _tmp0_;
	g_return_val_if_fail (account != NULL, NULL);
	self = (HomeTimeline*) default_timeline_construct (object_type, id);
	((DefaultTimeline*) self)->account = account;
	_tmp0_ = ((DefaultTimeline*) self)->tweet_list;
	_tmp0_->account = account;
	return self;
}

HomeTimeline*
home_timeline_new (gint id,
                   Account* account)
{
	return home_timeline_construct (TYPE_HOME_TIMELINE, id, account);
}

static void
home_timeline_real_stream_message_received (CbMessageReceiver* base,
                                            CbStreamMessageType type,
                                            JsonNode* root)
{
	HomeTimeline * self;
	self = (HomeTimeline*) base;
	g_return_if_fail (root != NULL);
	if (type == CB_STREAM_MESSAGE_TWEET) {
		home_timeline_add_tweet (self, root);
	} else {
		if (type == CB_STREAM_MESSAGE_TIMELINE_LOADED) {
			((DefaultTimeline*) self)->preload_is_complete = TRUE;
		} else {
			if (type == CB_STREAM_MESSAGE_EVENT_UNFOLLOW) {
				default_timeline_hide_tweets_from ((DefaultTimeline*) self, root, CB_TWEET_STATE_HIDDEN_UNFOLLOWED, 0);
			} else {
				if (type == CB_STREAM_MESSAGE_EVENT_FOLLOW) {
					default_timeline_show_tweets_from ((DefaultTimeline*) self, root, CB_TWEET_STATE_HIDDEN_UNFOLLOWED, 0);
					home_timeline_load_tweets_from_follow (self, root, NULL, NULL);
				} else {
					DEFAULT_TIMELINE_CLASS (home_timeline_parent_class)->stream_message_received (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DEFAULT_TIMELINE, DefaultTimeline), type, root);
				}
			}
		}
	}
}

void
home_timeline_add_tweet (HomeTimeline* self,
                         JsonNode* obj)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	CbTweet* t = NULL;
	CbTweet* _tmp1_;
	CbTweet* _tmp2_;
	Account* _tmp3_;
	GDateTime* _tmp4_;
	CbTweet* _tmp5_;
	CbMiniTweet* _tmp6_;
	CbTweet* _tmp16_;
	Account* _tmp17_;
	gboolean auto_scroll = FALSE;
	gboolean is_new_unread = FALSE;
	gboolean _tmp18_ = FALSE;
	CbTweet* _tmp19_;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	CbTweet* _tmp35_;
	CbMiniTweet _tmp36_;
	CbUserIdentity _tmp37_;
	Account* _tmp38_;
	CbTweet* _tmp55_;
	gboolean _tmp56_ = FALSE;
	TweetListBox* _tmp57_;
	GtkWidget* _tmp58_;
	GtkWidget* _tmp59_;
	gboolean _tmp60_;
	gboolean focused = FALSE;
	gboolean _tmp66_ = FALSE;
	gboolean should_focus = FALSE;
	TweetListBox* _tmp69_;
	CbTweetModel* _tmp70_;
	CbTweet* _tmp71_;
	CbTweet* _tmp72_;
	CbTweet* _tmp83_;
	gboolean _tmp84_ = FALSE;
	gboolean _tmp85_ = FALSE;
	gboolean _tmp86_ = FALSE;
	CbTweet* _tmp87_;
	Account* _tmp88_;
	gint stack_size = 0;
	gboolean _tmp89_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (obj != NULL);
	_tmp0_ = g_date_time_new_now_local ();
	now = _tmp0_;
	_tmp1_ = cb_tweet_new ();
	t = _tmp1_;
	_tmp2_ = t;
	_tmp3_ = ((DefaultTimeline*) self)->account;
	_tmp4_ = now;
	cb_tweet_load_from_json (_tmp2_, obj, _tmp3_->id, _tmp4_);
	_tmp5_ = t;
	_tmp6_ = _tmp5_->retweeted_tweet;
	if (_tmp6_ != NULL) {
		CbTweet* _tmp7_;
		CbMiniTweet _tmp8_;
		CbUserIdentity _tmp9_;
		Account* _tmp10_;
		CbTweet* _tmp14_;
		CbTweet* _tmp15_;
		_tmp7_ = t;
		_tmp8_ = _tmp7_->source_tweet;
		_tmp9_ = _tmp8_.author;
		_tmp10_ = ((DefaultTimeline*) self)->account;
		if (_tmp9_.id == _tmp10_->id) {
			TweetListBox* _tmp11_;
			CbTweetModel* _tmp12_;
			Account* _tmp13_;
			_tmp11_ = ((DefaultTimeline*) self)->tweet_list;
			_tmp12_ = _tmp11_->model;
			_tmp13_ = ((DefaultTimeline*) self)->account;
			utils_set_rt_from_tweet (obj, _tmp12_, _tmp13_);
			_g_object_unref0 (t);
			_g_date_time_unref0 (now);
			return;
		}
		_tmp14_ = t;
		_tmp15_ = t;
		cb_tweet_set_flag (_tmp14_, (guint) default_timeline_get_rt_flags ((DefaultTimeline*) self, _tmp15_));
	}
	_tmp16_ = t;
	_tmp17_ = ((DefaultTimeline*) self)->account;
	tweet_utils_set_tweet_hidden_flags (_tmp16_, _tmp17_);
	auto_scroll = settings_auto_scroll_on_new_tweets ();
	is_new_unread = FALSE;
	_tmp19_ = t;
	if (_tmp19_->id < self->priv->last_tweet_id) {
		TweetListBox* _tmp20_;
		CbTweetModel* _tmp21_;
		CbTweet* _tmp22_;
		_tmp20_ = ((DefaultTimeline*) self)->tweet_list;
		_tmp21_ = _tmp20_->model;
		_tmp22_ = t;
		_tmp18_ = !cb_tweet_model_contains_id (_tmp21_, _tmp22_->id);
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		gint64 age_diff = 0LL;
		CbTweet* _tmp23_;
		CbTweet* _tmp24_;
		_tmp23_ = t;
		age_diff = (gint64) (((self->priv->last_tweet_id >> 22) / 1000) - ((_tmp23_->id >> 22) / 1000));
		_tmp24_ = t;
		g_debug ("HomeTimeline.vala:84: Loaded missing tweet %lld (%lld seconds older th" \
"an %lld)", _tmp24_->id, age_diff, self->priv->last_tweet_id);
		is_new_unread = TRUE;
	} else {
		gboolean _tmp25_ = FALSE;
		CbTweet* _tmp26_;
		_tmp26_ = t;
		if (_tmp26_->id > self->priv->last_tweet_id) {
			CbTweet* _tmp27_;
			CbMiniTweet _tmp28_;
			CbUserIdentity _tmp29_;
			Account* _tmp30_;
			_tmp27_ = t;
			_tmp28_ = _tmp27_->source_tweet;
			_tmp29_ = _tmp28_.author;
			_tmp30_ = ((DefaultTimeline*) self)->account;
			_tmp25_ = _tmp29_.id != _tmp30_->id;
		} else {
			_tmp25_ = FALSE;
		}
		if (_tmp25_) {
			CbTweet* _tmp31_;
			_tmp31_ = t;
			self->priv->last_tweet_id = _tmp31_->id;
			is_new_unread = TRUE;
		}
	}
	_tmp35_ = t;
	_tmp36_ = _tmp35_->source_tweet;
	_tmp37_ = _tmp36_.author;
	_tmp38_ = ((DefaultTimeline*) self)->account;
	if (_tmp37_.id == _tmp38_->id) {
		_tmp34_ = TRUE;
	} else {
		gboolean _tmp39_ = FALSE;
		CbTweet* _tmp40_;
		CbMiniTweet* _tmp41_;
		_tmp40_ = t;
		_tmp41_ = _tmp40_->retweeted_tweet;
		if (_tmp41_ != NULL) {
			CbTweet* _tmp42_;
			CbMiniTweet* _tmp43_;
			CbUserIdentity _tmp44_;
			Account* _tmp45_;
			_tmp42_ = t;
			_tmp43_ = _tmp42_->retweeted_tweet;
			_tmp44_ = (*_tmp43_).author;
			_tmp45_ = ((DefaultTimeline*) self)->account;
			_tmp39_ = _tmp44_.id == _tmp45_->id;
		} else {
			_tmp39_ = FALSE;
		}
		_tmp34_ = _tmp39_;
	}
	if (_tmp34_) {
		_tmp33_ = TRUE;
	} else {
		gboolean _tmp46_ = FALSE;
		gboolean _tmp47_ = FALSE;
		gboolean _tmp48_;
		gboolean _tmp49_;
		_tmp48_ = scroll_widget_get_scrolled_up ((ScrollWidget*) self);
		_tmp49_ = _tmp48_;
		if (_tmp49_) {
			MainWindow* _tmp50_;
			gint _tmp51_;
			gint _tmp52_;
			gint _tmp53_;
			gint _tmp54_;
			_tmp50_ = ((DefaultTimeline*) self)->main_window;
			_tmp51_ = main_window_get_cur_page_id (_tmp50_);
			_tmp52_ = _tmp51_;
			_tmp53_ = ipage_get_id ((IPage*) self);
			_tmp54_ = _tmp53_;
			_tmp47_ = _tmp52_ == _tmp54_;
		} else {
			_tmp47_ = FALSE;
		}
		if (_tmp47_) {
			_tmp46_ = auto_scroll;
		} else {
			_tmp46_ = FALSE;
		}
		_tmp33_ = _tmp46_;
	}
	if (_tmp33_) {
		_tmp32_ = TRUE;
	} else {
		_tmp32_ = !((DefaultTimeline*) self)->preload_is_complete;
	}
	_tmp55_ = t;
	cb_tweet_set_seen (_tmp55_, _tmp32_);
	_tmp57_ = ((DefaultTimeline*) self)->tweet_list;
	_tmp58_ = list_box_get_first_visible_row ((ListBox*) _tmp57_);
	_tmp59_ = _tmp58_;
	_tmp60_ = _tmp59_ != NULL;
	_g_object_unref0 (_tmp59_);
	if (_tmp60_) {
		TweetListBox* _tmp61_;
		GtkWidget* _tmp62_;
		GtkWidget* _tmp63_;
		gboolean _tmp64_;
		gboolean _tmp65_;
		_tmp61_ = ((DefaultTimeline*) self)->tweet_list;
		_tmp62_ = list_box_get_first_visible_row ((ListBox*) _tmp61_);
		_tmp63_ = _tmp62_;
		g_object_get (_tmp63_, "is-focus", &_tmp64_, NULL);
		_tmp65_ = _tmp64_;
		_tmp56_ = _tmp65_;
		_g_object_unref0 (_tmp63_);
	} else {
		_tmp56_ = FALSE;
	}
	focused = _tmp56_;
	if (focused) {
		gboolean _tmp67_;
		gboolean _tmp68_;
		_tmp67_ = scroll_widget_get_scrolled_up ((ScrollWidget*) self);
		_tmp68_ = _tmp67_;
		_tmp66_ = _tmp68_;
	} else {
		_tmp66_ = FALSE;
	}
	should_focus = _tmp66_;
	_tmp69_ = ((DefaultTimeline*) self)->tweet_list;
	_tmp70_ = _tmp69_->model;
	_tmp71_ = t;
	cb_tweet_model_add (_tmp70_, _tmp71_);
	_tmp72_ = t;
	if (!cb_tweet_is_hidden (_tmp72_)) {
		gboolean _tmp74_ = FALSE;
		gboolean _tmp75_ = FALSE;
		CbTweet* _tmp76_;
		if (auto_scroll) {
			CbTweet* _tmp73_;
			_tmp73_ = t;
			default_timeline_scroll_up (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_DEFAULT_TIMELINE, DefaultTimeline), _tmp73_);
		} else {
			if (((DefaultTimeline*) self)->preload_is_complete) {
				scroll_widget_balance_next_upper_change ((ScrollWidget*) self, TOP);
			}
		}
		_tmp76_ = t;
		if (!cb_tweet_get_seen (_tmp76_)) {
			_tmp75_ = ((DefaultTimeline*) self)->preload_is_complete;
		} else {
			_tmp75_ = FALSE;
		}
		if (_tmp75_) {
			_tmp74_ = is_new_unread;
		} else {
			_tmp74_ = FALSE;
		}
		if (_tmp74_) {
			gint _tmp77_;
			gint _tmp78_;
			_tmp77_ = default_timeline_get_unread_count ((DefaultTimeline*) self);
			_tmp78_ = _tmp77_;
			default_timeline_set_unread_count ((DefaultTimeline*) self, _tmp78_ + 1);
		}
	} else {
		CbTweet* _tmp79_;
		_tmp79_ = t;
		cb_tweet_set_seen (_tmp79_, TRUE);
	}
	if (should_focus) {
		TweetListBox* _tmp80_;
		GtkWidget* _tmp81_;
		GtkWidget* _tmp82_;
		_tmp80_ = ((DefaultTimeline*) self)->tweet_list;
		_tmp81_ = list_box_get_first_visible_row ((ListBox*) _tmp80_);
		_tmp82_ = _tmp81_;
		gtk_widget_grab_focus (_tmp82_);
		_g_object_unref0 (_tmp82_);
	}
	_tmp83_ = t;
	if (cb_tweet_is_hidden (_tmp83_)) {
		_g_object_unref0 (t);
		_g_date_time_unref0 (now);
		return;
	}
	_tmp87_ = t;
	_tmp88_ = ((DefaultTimeline*) self)->account;
	if (cb_tweet_get_user_id (_tmp87_) == _tmp88_->id) {
		_tmp86_ = TRUE;
	} else {
		_tmp86_ = auto_scroll;
	}
	if (_tmp86_) {
		_tmp85_ = TRUE;
	} else {
		_tmp85_ = !((DefaultTimeline*) self)->preload_is_complete;
	}
	if (_tmp85_) {
		_tmp84_ = TRUE;
	} else {
		_tmp84_ = !is_new_unread;
	}
	if (_tmp84_) {
		_g_object_unref0 (t);
		_g_date_time_unref0 (now);
		return;
	}
	stack_size = settings_get_tweet_stack_count ();
	if (stack_size == 1) {
		_tmp89_ = !auto_scroll;
	} else {
		_tmp89_ = FALSE;
	}
	if (_tmp89_) {
		gchar* summary = NULL;
		gchar* _tmp90_;
		CbTweet* _tmp91_;
		CbMiniTweet* _tmp92_;
		gchar* id_suffix = NULL;
		CbTweet* _tmp107_;
		gchar* _tmp108_;
		gchar* _tmp109_;
		gchar* _tmp110_;
		gchar* _tmp111_;
		CbTweet* _tmp112_;
		Account* _tmp113_;
		NotificationManager* _tmp114_;
		const gchar* _tmp115_;
		CbTweet* _tmp116_;
		gchar* _tmp117_;
		gchar* _tmp118_;
		const gchar* _tmp119_;
		gchar* _tmp120_;
		_tmp90_ = g_strdup ("");
		summary = _tmp90_;
		_tmp91_ = t;
		_tmp92_ = _tmp91_->retweeted_tweet;
		if (_tmp92_ != NULL) {
			CbTweet* _tmp93_;
			CbMiniTweet _tmp94_;
			CbUserIdentity _tmp95_;
			const gchar* _tmp96_;
			CbTweet* _tmp97_;
			CbMiniTweet* _tmp98_;
			CbUserIdentity _tmp99_;
			const gchar* _tmp100_;
			gchar* _tmp101_;
			_tmp93_ = t;
			_tmp94_ = _tmp93_->source_tweet;
			_tmp95_ = _tmp94_.author;
			_tmp96_ = _tmp95_.user_name;
			_tmp97_ = t;
			_tmp98_ = _tmp97_->retweeted_tweet;
			_tmp99_ = (*_tmp98_).author;
			_tmp100_ = _tmp99_.user_name;
			_tmp101_ = g_strdup_printf (_ ("%s retweeted %s"), _tmp96_, _tmp100_);
			_g_free0 (summary);
			summary = _tmp101_;
		} else {
			CbTweet* _tmp102_;
			CbMiniTweet _tmp103_;
			CbUserIdentity _tmp104_;
			const gchar* _tmp105_;
			gchar* _tmp106_;
			_tmp102_ = t;
			_tmp103_ = _tmp102_->source_tweet;
			_tmp104_ = _tmp103_.author;
			_tmp105_ = _tmp104_.user_name;
			_tmp106_ = g_strdup_printf (_ ("%s tweeted"), _tmp105_);
			_g_free0 (summary);
			summary = _tmp106_;
		}
		_tmp107_ = t;
		_tmp108_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp107_->id);
		_tmp109_ = _tmp108_;
		_tmp110_ = g_strdup_printf ("tweet-%s", _tmp109_);
		_tmp111_ = _tmp110_;
		_g_free0 (_tmp109_);
		id_suffix = _tmp111_;
		_tmp112_ = t;
		_tmp113_ = ((DefaultTimeline*) self)->account;
		_tmp114_ = _tmp113_->notifications;
		_tmp115_ = summary;
		_tmp116_ = t;
		_tmp117_ = cb_tweet_get_real_text (_tmp116_);
		_tmp118_ = _tmp117_;
		_tmp119_ = id_suffix;
		_tmp120_ = notification_manager_send (_tmp114_, _tmp115_, _tmp118_, _tmp119_);
		_g_free0 (_tmp112_->notification_id);
		_tmp112_->notification_id = _tmp120_;
		_g_free0 (_tmp118_);
		_g_free0 (id_suffix);
		_g_free0 (summary);
	} else {
		gboolean _tmp121_ = FALSE;
		gboolean _tmp122_ = FALSE;
		if (stack_size != 0) {
			gint _tmp123_;
			gint _tmp124_;
			_tmp123_ = default_timeline_get_unread_count ((DefaultTimeline*) self);
			_tmp124_ = _tmp123_;
			_tmp122_ = (_tmp124_ % stack_size) == 0;
		} else {
			_tmp122_ = FALSE;
		}
		if (_tmp122_) {
			gint _tmp125_;
			gint _tmp126_;
			_tmp125_ = default_timeline_get_unread_count ((DefaultTimeline*) self);
			_tmp126_ = _tmp125_;
			_tmp121_ = _tmp126_ > 0;
		} else {
			_tmp121_ = FALSE;
		}
		if (_tmp121_) {
			gchar* summary = NULL;
			gint _tmp127_;
			gint _tmp128_;
			gint _tmp129_;
			gint _tmp130_;
			gchar* _tmp131_;
			Account* _tmp132_;
			NotificationManager* _tmp133_;
			const gchar* _tmp134_;
			gchar* _tmp135_;
			gchar* _tmp136_;
			_tmp127_ = default_timeline_get_unread_count ((DefaultTimeline*) self);
			_tmp128_ = _tmp127_;
			_tmp129_ = default_timeline_get_unread_count ((DefaultTimeline*) self);
			_tmp130_ = _tmp129_;
			_tmp131_ = g_strdup_printf (ngettext ("%d new Tweet!", "%d new Tweets!", (gulong) _tmp128_), _tmp130_);
			summary = _tmp131_;
			_tmp132_ = ((DefaultTimeline*) self)->account;
			_tmp133_ = _tmp132_->notifications;
			_tmp134_ = summary;
			_tmp135_ = notification_manager_send (_tmp133_, _tmp134_, "", NULL);
			_tmp136_ = _tmp135_;
			_g_free0 (_tmp136_);
			_g_free0 (summary);
		}
	}
	_g_object_unref0 (t);
	_g_date_time_unref0 (now);
}

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static void
home_timeline_load_tweets_from_follow_data_free (gpointer _data)
{
	HomeTimelineLoadTweetsFromFollowData* _data_;
	_data_ = _data;
	__vala_JsonNode_free0 (_data_->follow_root);
	_g_object_unref0 (_data_->self);
	g_slice_free (HomeTimelineLoadTweetsFromFollowData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
	return g_boxed_copy (json_node_get_type (), self);
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
	return self ? _vala_JsonNode_copy (self) : NULL;
}

static void
home_timeline_load_tweets_from_follow (HomeTimeline* self,
                                       JsonNode* follow_root,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_)
{
	HomeTimelineLoadTweetsFromFollowData* _data_;
	HomeTimeline* _tmp0_;
	JsonNode* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (follow_root != NULL);
	_data_ = g_slice_new0 (HomeTimelineLoadTweetsFromFollowData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, home_timeline_load_tweets_from_follow_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = __vala_JsonNode_copy0 (follow_root);
	__vala_JsonNode_free0 (_data_->follow_root);
	_data_->follow_root = _tmp1_;
	home_timeline_load_tweets_from_follow_co (_data_);
}

static void
home_timeline_load_tweets_from_follow_finish (HomeTimeline* self,
                                              GAsyncResult* _res_)
{
	HomeTimelineLoadTweetsFromFollowData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
home_timeline_load_tweets_from_follow_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_)
{
	HomeTimelineLoadTweetsFromFollowData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	home_timeline_load_tweets_from_follow_co (_data_);
}

static void
___lambda219_ (HomeTimeline* self,
               JsonArray* array,
               guint idx,
               JsonNode* node)
{
	g_return_if_fail (array != NULL);
	g_return_if_fail (node != NULL);
	home_timeline_add_tweet (self, node);
}

static void
____lambda219__json_array_foreach (JsonArray* array,
                                   guint index_,
                                   JsonNode* element_node,
                                   gpointer self)
{
	___lambda219_ ((HomeTimeline*) self, array, index_, element_node);
}

static gboolean
home_timeline_load_tweets_from_follow_co (HomeTimelineLoadTweetsFromFollowData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->follow_id = default_timeline_get_user_id ((DefaultTimeline*) _data_->self, _data_->follow_root);
	{
		_data_->_tmp0_ = ((DefaultTimeline*) _data_->self)->account;
		_data_->_tmp1_ = ((DefaultTimeline*) _data_->self)->tweet_list;
		_data_->_tmp2_ = _data_->_tmp1_->model;
		_data_->_state_ = 1;
		user_utils_load_user_timeline_by_id (_data_->_tmp0_, _data_->follow_id, 200, _data_->_tmp2_->min_id, (gint64) -1, home_timeline_load_tweets_from_follow_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp3_ = user_utils_load_user_timeline_by_id_finish (_data_->_res_, &_data_->_inner_error0_);
		_data_->root_array = _data_->_tmp3_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		json_array_foreach_element (_data_->root_array, ____lambda219__json_array_foreach, _data_->self);
		_json_array_unref0 (_data_->root_array);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp4_ = _data_->e;
		_data_->_tmp5_ = _data_->_tmp4_->message;
		g_warning ("HomeTimeline.vala:171: %s", _data_->_tmp5_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gchar*
home_timeline_real_get_title (DefaultTimeline* base)
{
	HomeTimeline * self;
	Account* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result = NULL;
	self = (HomeTimeline*) base;
	_tmp0_ = ((DefaultTimeline*) self)->account;
	_tmp1_ = _tmp0_->screen_name;
	_tmp2_ = g_strconcat ("@", _tmp1_, NULL);
	result = _tmp2_;
	return result;
}

static void
home_timeline_real_create_radio_button (DefaultTimeline* base,
                                        GtkRadioButton* group)
{
	HomeTimeline * self;
	BadgeRadioButton* _tmp0_;
	self = (HomeTimeline*) base;
	_tmp0_ = badge_radio_button_new (group, "cawbird-user-home-symbolic", _ ("Home"));
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (((DefaultTimeline*) self)->radio_button);
	((DefaultTimeline*) self)->radio_button = _tmp0_;
}

static const gchar*
home_timeline_real_get_function (DefaultTimeline* base)
{
	const gchar* result;
	HomeTimeline* self;
	self = (HomeTimeline*) base;
	result = "1.1/statuses/home_timeline.json";
	return result;
}

static const gchar*
home_timeline_real_get_accessibility_name (DefaultTimeline* base)
{
	const gchar* result;
	HomeTimeline* self;
	self = (HomeTimeline*) base;
	result = _ ("Home timeline");
	return result;
}

static void
home_timeline_class_init (HomeTimelineClass * klass,
                          gpointer klass_data)
{
	home_timeline_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &HomeTimeline_private_offset);
	((DefaultTimelineClass *) klass)->stream_message_received = (void (*) (DefaultTimeline*, CbStreamMessageType, JsonNode*)) home_timeline_real_stream_message_received;
	((DefaultTimelineClass *) klass)->get_title = (gchar* (*) (DefaultTimeline*)) home_timeline_real_get_title;
	((DefaultTimelineClass *) klass)->create_radio_button = (void (*) (DefaultTimeline*, GtkRadioButton*)) home_timeline_real_create_radio_button;
	DEFAULT_TIMELINE_CLASS (klass)->get_function = home_timeline_real_get_function;
	DEFAULT_TIMELINE_CLASS (klass)->get_accessibility_name = home_timeline_real_get_accessibility_name;
	G_OBJECT_CLASS (klass)->get_property = _vala_home_timeline_get_property;
	G_OBJECT_CLASS (klass)->finalize = home_timeline_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), HOME_TIMELINE_FUNCTION_PROPERTY, home_timeline_properties[HOME_TIMELINE_FUNCTION_PROPERTY] = g_param_spec_string ("function", "function", "function", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), HOME_TIMELINE_ACCESSIBILITY_NAME_PROPERTY, home_timeline_properties[HOME_TIMELINE_ACCESSIBILITY_NAME_PROPERTY] = g_param_spec_string ("accessibility-name", "accessibility-name", "accessibility-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}

static void
home_timeline_cb_message_receiver_interface_init (CbMessageReceiverInterface * iface,
                                                  gpointer iface_data)
{
	home_timeline_cb_message_receiver_parent_iface = g_type_interface_peek_parent (iface);
	iface->stream_message_received = (void (*) (CbMessageReceiver*, CbStreamMessageType, JsonNode*)) home_timeline_real_stream_message_received;
}

static void
home_timeline_instance_init (HomeTimeline * self,
                             gpointer klass)
{
	self->priv = home_timeline_get_instance_private (self);
	self->priv->last_tweet_id = (gint64) 0;
}

static void
home_timeline_finalize (GObject * obj)
{
	HomeTimeline * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_HOME_TIMELINE, HomeTimeline);
	G_OBJECT_CLASS (home_timeline_parent_class)->finalize (obj);
}

static GType
home_timeline_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (HomeTimelineClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) home_timeline_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (HomeTimeline), 0, (GInstanceInitFunc) home_timeline_instance_init, NULL };
	static const GInterfaceInfo cb_message_receiver_info = { (GInterfaceInitFunc) home_timeline_cb_message_receiver_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
	GType home_timeline_type_id;
	home_timeline_type_id = g_type_register_static (TYPE_DEFAULT_TIMELINE, "HomeTimeline", &g_define_type_info, 0);
	g_type_add_interface_static (home_timeline_type_id, CB_TYPE_MESSAGE_RECEIVER, &cb_message_receiver_info);
	HomeTimeline_private_offset = g_type_add_instance_private (home_timeline_type_id, sizeof (HomeTimelinePrivate));
	return home_timeline_type_id;
}

GType
home_timeline_get_type (void)
{
	static volatile gsize home_timeline_type_id__volatile = 0;
	if (g_once_init_enter (&home_timeline_type_id__volatile)) {
		GType home_timeline_type_id;
		home_timeline_type_id = home_timeline_get_type_once ();
		g_once_init_leave (&home_timeline_type_id__volatile, home_timeline_type_id);
	}
	return home_timeline_type_id__volatile;
}

static void
_vala_home_timeline_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	HomeTimeline * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_HOME_TIMELINE, HomeTimeline);
	switch (property_id) {
		case HOME_TIMELINE_FUNCTION_PROPERTY:
		g_value_set_string (value, default_timeline_get_function ((DefaultTimeline*) self));
		break;
		case HOME_TIMELINE_ACCESSIBILITY_NAME_PROPERTY:
		g_value_set_string (value, default_timeline_get_accessibility_name ((DefaultTimeline*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

