/* NotificationManager.c generated by valac 0.54.3, the Vala compiler
 * generated from NotificationManager.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

enum  {
	NOTIFICATION_MANAGER_0_PROPERTY,
	NOTIFICATION_MANAGER_NUM_PROPERTIES
};
static GParamSpec* notification_manager_properties[NOTIFICATION_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _NotificationManagerPrivate {
	Account* account;
};

static gint NotificationManager_private_offset;
static gpointer notification_manager_parent_class = NULL;

static GVariant* _variant_new4 (gint64 value);
static void notification_manager_finalize (GObject * obj);
static GType notification_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
notification_manager_get_instance_private (NotificationManager* self)
{
	return G_STRUCT_MEMBER_P (self, NotificationManager_private_offset);
}

NotificationManager*
notification_manager_construct (GType object_type,
                                Account* account)
{
	NotificationManager * self = NULL;
	g_return_val_if_fail (account != NULL, NULL);
	self = (NotificationManager*) g_object_new (object_type, NULL);
	self->priv->account = account;
	return self;
}

NotificationManager*
notification_manager_new (Account* account)
{
	return notification_manager_construct (TYPE_NOTIFICATION_MANAGER, account);
}

void
notification_manager_withdraw (NotificationManager* self,
                               const gchar* id)
{
	GApplication* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (id != NULL);
	_tmp0_ = g_application_get_default ();
	g_application_withdraw_notification (_tmp0_, id);
}

static GVariant*
_variant_new4 (gint64 value)
{
	return g_variant_ref_sink (g_variant_new_int64 (value));
}

gchar*
notification_manager_send (NotificationManager* self,
                           const gchar* summary,
                           const gchar* body,
                           const gchar* id_suffix)
{
	GNotification* n = NULL;
	GNotification* _tmp0_;
	GNotification* _tmp1_;
	const gchar* _tmp2_ = NULL;
	gchar* id = NULL;
	Account* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GNotification* _tmp8_;
	Account* _tmp9_;
	GVariant* _tmp10_;
	GApplication* _tmp11_;
	GNotification* _tmp12_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (summary != NULL, NULL);
	g_return_val_if_fail (body != NULL, NULL);
	_tmp0_ = g_notification_new (summary);
	n = _tmp0_;
	_tmp1_ = n;
	g_notification_set_body (_tmp1_, body);
	_tmp2_ = id_suffix;
	if (_tmp2_ == NULL) {
		_tmp2_ = "";
	}
	_tmp3_ = self->priv->account;
	_tmp4_ = g_strdup_printf ("%" G_GINT64_FORMAT, _tmp3_->id);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strdup_printf ("%s-%s", _tmp5_, _tmp2_);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp5_);
	id = _tmp7_;
	_tmp8_ = n;
	_tmp9_ = self->priv->account;
	_tmp10_ = _variant_new4 (_tmp9_->id);
	g_notification_set_default_action_and_target_value (_tmp8_, "app.show-window", _tmp10_);
	_g_variant_unref0 (_tmp10_);
	_tmp11_ = g_application_get_default ();
	_tmp12_ = n;
	g_application_send_notification (_tmp11_, id, _tmp12_);
	result = id;
	_g_object_unref0 (n);
	return result;
}

gchar*
notification_manager_send_dm (NotificationManager* self,
                              gint64 sender_id,
                              const gchar* existing_id,
                              const gchar* summary,
                              const gchar* text)
{
	gchar* new_id = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GNotification* n = NULL;
	GNotification* _tmp4_;
	GVariant* value = NULL;
	Account* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GVariant** _tmp8_;
	GVariant** _tmp9_;
	gint _tmp9__length1;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GApplication* _tmp12_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (summary != NULL, NULL);
	g_return_val_if_fail (text != NULL, NULL);
	if (existing_id != NULL) {
		notification_manager_withdraw (self, existing_id);
	}
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, sender_id);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strdup_printf ("new-dm-%s", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	new_id = _tmp3_;
	_tmp4_ = g_notification_new (summary);
	n = _tmp4_;
	_tmp5_ = self->priv->account;
	_tmp6_ = g_variant_new_int64 (_tmp5_->id);
	g_variant_ref_sink (_tmp6_);
	_tmp7_ = g_variant_new_int64 (sender_id);
	g_variant_ref_sink (_tmp7_);
	_tmp8_ = g_new0 (GVariant*, 2 + 1);
	_tmp8_[0] = _tmp6_;
	_tmp8_[1] = _tmp7_;
	_tmp9_ = _tmp8_;
	_tmp9__length1 = 2;
	_tmp10_ = g_variant_new_tuple (_tmp9_, 2);
	g_variant_ref_sink (_tmp10_);
	_tmp11_ = _tmp10_;
	_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_variant_unref), NULL);
	value = _tmp11_;
	g_notification_set_default_action_and_target_value (n, "app.show-dm-thread", value);
	g_notification_set_body (n, text);
	_tmp12_ = g_application_get_default ();
	g_application_send_notification (_tmp12_, new_id, n);
	result = new_id;
	_g_variant_unref0 (value);
	_g_object_unref0 (n);
	return result;
}

static void
notification_manager_class_init (NotificationManagerClass * klass,
                                 gpointer klass_data)
{
	notification_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &NotificationManager_private_offset);
	G_OBJECT_CLASS (klass)->finalize = notification_manager_finalize;
}

static void
notification_manager_instance_init (NotificationManager * self,
                                    gpointer klass)
{
	self->priv = notification_manager_get_instance_private (self);
}

static void
notification_manager_finalize (GObject * obj)
{
	NotificationManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NOTIFICATION_MANAGER, NotificationManager);
	G_OBJECT_CLASS (notification_manager_parent_class)->finalize (obj);
}

static GType
notification_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NotificationManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notification_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NotificationManager), 0, (GInstanceInitFunc) notification_manager_instance_init, NULL };
	GType notification_manager_type_id;
	notification_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "NotificationManager", &g_define_type_info, 0);
	NotificationManager_private_offset = g_type_add_instance_private (notification_manager_type_id, sizeof (NotificationManagerPrivate));
	return notification_manager_type_id;
}

GType
notification_manager_get_type (void)
{
	static volatile gsize notification_manager_type_id__volatile = 0;
	if (g_once_init_enter (&notification_manager_type_id__volatile)) {
		GType notification_manager_type_id;
		notification_manager_type_id = notification_manager_get_type_once ();
		g_once_init_leave (&notification_manager_type_id__volatile, notification_manager_type_id);
	}
	return notification_manager_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

