/* DeleteStatement.c generated by valac 0.54.3, the Vala compiler
 * generated from DeleteStatement.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2020 IBBoard
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <sqlite3.h>

enum  {
	SQL_DELETE_STATEMENT_0_PROPERTY,
	SQL_DELETE_STATEMENT_NUM_PROPERTIES
};
static GParamSpec* sql_delete_statement_properties[SQL_DELETE_STATEMENT_NUM_PROPERTIES];
#define _sqlite3_finalize0(var) ((var == NULL) ? NULL : (var = (sqlite3_finalize (var), NULL)))

struct _SqlDeleteStatementPrivate {
	gboolean ran;
};

static gint SqlDeleteStatement_private_offset;
static gpointer sql_delete_statement_parent_class = NULL;

static void sql_delete_statement_finalize (GObject * obj);
static GType sql_delete_statement_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sql_delete_statement_get_instance_private (SqlDeleteStatement* self)
{
	return G_STRUCT_MEMBER_P (self, SqlDeleteStatement_private_offset);
}

SqlDeleteStatement*
sql_delete_statement_construct (GType object_type,
                                const gchar* table_name)
{
	SqlDeleteStatement * self = NULL;
	GString* _tmp0_;
	GString* _tmp1_;
	GString* _tmp2_;
	g_return_val_if_fail (table_name != NULL, NULL);
	self = (SqlDeleteStatement*) sql_base_statement_construct (object_type, SQL_TYPE_DELETE_STATEMENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref);
	_tmp0_ = ((SqlBaseStatement*) self)->query_builder;
	_tmp1_ = g_string_append (_tmp0_, "DELETE FROM `");
	_tmp2_ = g_string_append (_tmp1_, table_name);
	g_string_append (_tmp2_, "` ");
	return self;
}

SqlDeleteStatement*
sql_delete_statement_new (const gchar* table_name)
{
	return sql_delete_statement_construct (SQL_TYPE_DELETE_STATEMENT, table_name);
}

static gint
vala_g_ptr_array_get_length (GPtrArray* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = (gint) self->len;
	return result;
}

gint
sql_delete_statement_run (SqlDeleteStatement* self)
{
	sqlite3_stmt* stmt = NULL;
	GString* _tmp0_;
	gint ok = 0;
	sqlite3* _tmp1_;
	GString* _tmp2_;
	const gchar* _tmp3_;
	sqlite3_stmt* _tmp4_ = NULL;
	gint _tmp5_;
	sqlite3_stmt* _tmp18_;
	sqlite3* _tmp23_;
	gint result = 0;
	g_return_val_if_fail (self != NULL, 0);
	if (!((SqlBaseStatement*) self)->where_set) {
		g_critical ("DeleteStatement.vala:28: Bare DELETE statements are not allowed!");
		result = -1;
		return result;
	}
	_tmp0_ = ((SqlBaseStatement*) self)->query_builder;
	g_string_append (_tmp0_, ";");
	_tmp1_ = ((SqlBaseStatement*) self)->db;
	_tmp2_ = ((SqlBaseStatement*) self)->query_builder;
	_tmp3_ = _tmp2_->str;
	_tmp5_ = sqlite3_prepare_v2 (_tmp1_, _tmp3_, -1, &_tmp4_, NULL);
	_sqlite3_finalize0 (stmt);
	stmt = _tmp4_;
	ok = _tmp5_;
	if (ok != SQLITE_OK) {
		sqlite3* _tmp6_;
		const gchar* _tmp7_;
		_tmp6_ = ((SqlBaseStatement*) self)->db;
		_tmp7_ = sqlite3_errmsg (_tmp6_);
		g_critical ("DeleteStatement.vala:36: %s", _tmp7_);
		result = -1;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				GPtrArray* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
				sqlite3_stmt* _tmp13_;
				GPtrArray* _tmp14_;
				gconstpointer _tmp15_;
				gchar* _tmp16_;
				GDestroyNotify _tmp17_;
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = i;
					i = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				_tmp10_ = ((SqlBaseStatement*) self)->bindings;
				_tmp11_ = vala_g_ptr_array_get_length (_tmp10_);
				_tmp12_ = _tmp11_;
				if (!(i < _tmp12_)) {
					break;
				}
				_tmp13_ = stmt;
				_tmp14_ = ((SqlBaseStatement*) self)->bindings;
				_tmp15_ = g_ptr_array_index (_tmp14_, (guint) i);
				_tmp16_ = g_strdup ((const gchar*) _tmp15_);
				_tmp17_ = g_free;
				sqlite3_bind_text (_tmp13_, i + 1, _tmp16_, -1, _tmp17_);
			}
		}
	}
	_tmp18_ = stmt;
	ok = sqlite3_step (_tmp18_);
	if (ok == SQLITE_ERROR) {
		sqlite3* _tmp19_;
		const gchar* _tmp20_;
		sqlite3_stmt* _tmp21_;
		const gchar* _tmp22_;
		_tmp19_ = ((SqlBaseStatement*) self)->db;
		_tmp20_ = sqlite3_errmsg (_tmp19_);
		g_critical ("DeleteStatement.vala:44: %s", _tmp20_);
		_tmp21_ = stmt;
		_tmp22_ = sqlite3_sql (_tmp21_);
		g_critical ("DeleteStatement.vala:45: %s", _tmp22_);
		result = -1;
		_sqlite3_finalize0 (stmt);
		return result;
	}
	self->priv->ran = TRUE;
	_tmp23_ = ((SqlBaseStatement*) self)->db;
	result = sqlite3_changes (_tmp23_);
	_sqlite3_finalize0 (stmt);
	return result;
}

static void
sql_delete_statement_class_init (SqlDeleteStatementClass * klass,
                                 gpointer klass_data)
{
	sql_delete_statement_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SqlDeleteStatement_private_offset);
	G_OBJECT_CLASS (klass)->finalize = sql_delete_statement_finalize;
}

static void
sql_delete_statement_instance_init (SqlDeleteStatement * self,
                                    gpointer klass)
{
	self->priv = sql_delete_statement_get_instance_private (self);
	self->priv->ran = FALSE;
}

static void
sql_delete_statement_finalize (GObject * obj)
{
	SqlDeleteStatement * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SQL_TYPE_DELETE_STATEMENT, SqlDeleteStatement);
	G_OBJECT_CLASS (sql_delete_statement_parent_class)->finalize (obj);
}

static GType
sql_delete_statement_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SqlDeleteStatementClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sql_delete_statement_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SqlDeleteStatement), 0, (GInstanceInitFunc) sql_delete_statement_instance_init, NULL };
	GType sql_delete_statement_type_id;
	sql_delete_statement_type_id = g_type_register_static (SQL_TYPE_BASE_STATEMENT, "SqlDeleteStatement", &g_define_type_info, 0);
	SqlDeleteStatement_private_offset = g_type_add_instance_private (sql_delete_statement_type_id, sizeof (SqlDeleteStatementPrivate));
	return sql_delete_statement_type_id;
}

GType
sql_delete_statement_get_type (void)
{
	static volatile gsize sql_delete_statement_type_id__volatile = 0;
	if (g_once_init_enter (&sql_delete_statement_type_id__volatile)) {
		GType sql_delete_statement_type_id;
		sql_delete_statement_type_id = sql_delete_statement_get_type_once ();
		g_once_init_leave (&sql_delete_statement_type_id__volatile, sql_delete_statement_type_id);
	}
	return sql_delete_statement_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

