/* AspectImage.c generated by valac 0.54.3, the Vala compiler
 * generated from AspectImage.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <cairo-gobject.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include "cawbird.h"
#include <stdlib.h>
#include <string.h>

#define TYPE_ASPECT_IMAGE (aspect_image_get_type ())
#define ASPECT_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ASPECT_IMAGE, AspectImage))
#define ASPECT_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ASPECT_IMAGE, AspectImageClass))
#define IS_ASPECT_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ASPECT_IMAGE))
#define IS_ASPECT_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ASPECT_IMAGE))
#define ASPECT_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ASPECT_IMAGE, AspectImageClass))

typedef struct _AspectImage AspectImage;
typedef struct _AspectImageClass AspectImageClass;
typedef struct _AspectImagePrivate AspectImagePrivate;
enum  {
	ASPECT_IMAGE_0_PROPERTY,
	ASPECT_IMAGE_PIXBUF_PROPERTY,
	ASPECT_IMAGE_COLOR_STRING_PROPERTY,
	ASPECT_IMAGE_NUM_PROPERTIES
};
static GParamSpec* aspect_image_properties[ASPECT_IMAGE_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _AspectImage {
	GtkWidget parent_instance;
	AspectImagePrivate * priv;
};

struct _AspectImageClass {
	GtkWidgetClass parent_class;
};

struct _AspectImagePrivate {
	GdkRGBA bg_color;
	cairo_surface_t* old_surface;
	cairo_surface_t* pixbuf_surface;
	gdouble alpha;
	gint64 start_time;
	gboolean in_transition;
};

static gint AspectImage_private_offset;
static gpointer aspect_image_parent_class = NULL;

VALA_EXTERN GType aspect_image_get_type (void) G_GNUC_CONST ;
VALA_EXTERN AspectImage* aspect_image_new (void);
VALA_EXTERN AspectImage* aspect_image_construct (GType object_type);
static void aspect_image_start_animation (AspectImage* self);
static gboolean aspect_image_fade_in_cb (AspectImage* self,
                                  GtkWidget* widget,
                                  GdkFrameClock* frame_clock);
static gboolean _aspect_image_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                                     GdkFrameClock* frame_clock,
                                                     gpointer self);
#define TRANSITION_DURATION (200 * 1000)
VALA_EXTERN gdouble ease_out_cubic (gdouble t);
static void aspect_image_real_get_preferred_height_for_width (GtkWidget* base,
                                                       gint width,
                                                       gint* min_height,
                                                       gint* nat_height);
static GtkSizeRequestMode aspect_image_real_get_request_mode (GtkWidget* base);
static gboolean aspect_image_real_draw (GtkWidget* base,
                                 cairo_t* ct);
VALA_EXTERN void aspect_image_set_pixbuf (AspectImage* self,
                              GdkPixbuf* value);
VALA_EXTERN void aspect_image_set_color_string (AspectImage* self,
                                    const gchar* value);
static GObject * aspect_image_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
static void aspect_image_finalize (GObject * obj);
static GType aspect_image_get_type_once (void);
static void _vala_aspect_image_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
aspect_image_get_instance_private (AspectImage* self)
{
	return G_STRUCT_MEMBER_P (self, AspectImage_private_offset);
}

AspectImage*
aspect_image_construct (GType object_type)
{
	AspectImage * self = NULL;
	self = (AspectImage*) gtk_widget_new (object_type, NULL);
	return self;
}

AspectImage*
aspect_image_new (void)
{
	return aspect_image_construct (TYPE_ASPECT_IMAGE);
}

static gboolean
_aspect_image_fade_in_cb_gtk_tick_callback (GtkWidget* widget,
                                            GdkFrameClock* frame_clock,
                                            gpointer self)
{
	gboolean result;
	result = aspect_image_fade_in_cb ((AspectImage*) self, widget, frame_clock);
	return result;
}

static void
aspect_image_start_animation (AspectImage* self)
{
	GdkFrameClock* _tmp0_;
	g_return_if_fail (self != NULL);
	if (!gtk_widget_get_realized ((GtkWidget*) self)) {
		return;
	}
	self->priv->alpha = 0.0;
	self->priv->in_transition = TRUE;
	_tmp0_ = gtk_widget_get_frame_clock ((GtkWidget*) self);
	self->priv->start_time = gdk_frame_clock_get_frame_time (_tmp0_);
	gtk_widget_add_tick_callback ((GtkWidget*) self, _aspect_image_fade_in_cb_gtk_tick_callback, g_object_ref (self), g_object_unref);
}

static gboolean
aspect_image_fade_in_cb (AspectImage* self,
                         GtkWidget* widget,
                         GdkFrameClock* frame_clock)
{
	gint64 now = 0LL;
	gdouble t = 0.0;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	g_return_val_if_fail (frame_clock != NULL, FALSE);
	now = gdk_frame_clock_get_frame_time (frame_clock);
	t = ((gdouble) (now - self->priv->start_time)) / TRANSITION_DURATION;
	if (t >= 1.0) {
		t = 1.0;
		self->priv->in_transition = FALSE;
	}
	self->priv->alpha = ease_out_cubic (t);
	gtk_widget_queue_draw ((GtkWidget*) self);
	result = t < 1.0;
	return result;
}

static void
aspect_image_real_get_preferred_height_for_width (GtkWidget* base,
                                                  gint width,
                                                  gint* min_height,
                                                  gint* nat_height)
{
	AspectImage * self;
	gint _vala_min_height = 0;
	gint _vala_nat_height = 0;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	self = (AspectImage*) base;
	_tmp0_ = self->priv->pixbuf_surface;
	if (_tmp0_ == NULL) {
		_vala_min_height = 0;
		_vala_nat_height = 1;
		if (min_height) {
			*min_height = _vala_min_height;
		}
		if (nat_height) {
			*nat_height = _vala_nat_height;
		}
		return;
	}
	_tmp1_ = self->priv->pixbuf_surface;
	_vala_min_height = cairo_image_surface_get_height (_tmp1_);
	_tmp2_ = self->priv->pixbuf_surface;
	_vala_nat_height = cairo_image_surface_get_height (_tmp2_);
	if (min_height) {
		*min_height = _vala_min_height;
	}
	if (nat_height) {
		*nat_height = _vala_nat_height;
	}
}

static GtkSizeRequestMode
aspect_image_real_get_request_mode (GtkWidget* base)
{
	AspectImage * self;
	GtkSizeRequestMode result = 0;
	self = (AspectImage*) base;
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
	return result;
}

static gboolean
aspect_image_real_draw (GtkWidget* base,
                        cairo_t* ct)
{
	AspectImage * self;
	gint width = 0;
	gint height = 0;
	gdouble scale_x = 0.0;
	GdkRGBA _tmp0_;
	cairo_surface_t* _tmp2_;
	GdkRGBA _tmp9_;
	gboolean result = FALSE;
	self = (AspectImage*) base;
	g_return_val_if_fail (ct != NULL, FALSE);
	width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	scale_x = 1.0;
	_tmp0_ = self->priv->bg_color;
	if (_tmp0_.alpha == 0.0) {
		cairo_surface_t* _tmp1_;
		_tmp1_ = self->priv->pixbuf_surface;
		scale_x = width / ((gdouble) cairo_image_surface_get_width (_tmp1_));
	}
	scale_x = MAX (scale_x, 1.0);
	cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) width, (gdouble) height);
	cairo_scale (ct, scale_x, 1.0);
	cairo_push_group (ct);
	_tmp2_ = self->priv->old_surface;
	if (_tmp2_ != NULL) {
		cairo_surface_t* _tmp3_;
		_tmp3_ = self->priv->old_surface;
		cairo_set_source_surface (ct, _tmp3_, (gdouble) 0, (gdouble) 0);
		cairo_paint (ct);
	} else {
		GdkRGBA _tmp4_;
		_tmp4_ = self->priv->bg_color;
		if (_tmp4_.alpha > 0.0) {
			GdkRGBA _tmp5_;
			GdkRGBA _tmp6_;
			GdkRGBA _tmp7_;
			GdkRGBA _tmp8_;
			_tmp5_ = self->priv->bg_color;
			_tmp6_ = self->priv->bg_color;
			_tmp7_ = self->priv->bg_color;
			_tmp8_ = self->priv->bg_color;
			cairo_set_source_rgba (ct, _tmp5_.red, _tmp6_.green, _tmp7_.blue, _tmp8_.alpha);
			cairo_fill (ct);
		} else {
			self->priv->alpha = 1.0;
		}
	}
	_tmp9_ = self->priv->bg_color;
	if (_tmp9_.alpha == 0.0) {
		gint x = 0;
		cairo_surface_t* _tmp10_;
		cairo_surface_t* _tmp11_;
		_tmp10_ = self->priv->pixbuf_surface;
		x = ((gint) (width - (cairo_image_surface_get_width (_tmp10_) * scale_x))) / 2;
		_tmp11_ = self->priv->pixbuf_surface;
		cairo_set_source_surface (ct, _tmp11_, (gdouble) x, (gdouble) 0);
	} else {
		GdkRGBA _tmp12_;
		GdkRGBA _tmp13_;
		GdkRGBA _tmp14_;
		GdkRGBA _tmp15_;
		_tmp12_ = self->priv->bg_color;
		_tmp13_ = self->priv->bg_color;
		_tmp14_ = self->priv->bg_color;
		_tmp15_ = self->priv->bg_color;
		cairo_set_source_rgba (ct, _tmp12_.red, _tmp13_.green, _tmp14_.blue, _tmp15_.alpha);
	}
	if (self->priv->in_transition) {
		cairo_paint_with_alpha (ct, self->priv->alpha);
	} else {
		cairo_paint (ct);
	}
	cairo_pop_group_to_source (ct);
	cairo_set_operator (ct, CAIRO_OPERATOR_OVER);
	cairo_paint (ct);
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gpointer
_cairo_surface_reference0 (gpointer self)
{
	return self ? cairo_surface_reference (self) : NULL;
}

void
aspect_image_set_pixbuf (AspectImage* self,
                         GdkPixbuf* value)
{
	g_return_if_fail (self != NULL);
	if (value != NULL) {
		GdkPixbuf* _tmp0_;
		cairo_surface_t* _tmp1_;
		GdkWindow* _tmp4_;
		cairo_surface_t* _tmp5_;
		_tmp0_ = twitter_no_banner;
		if (value != _tmp0_) {
			aspect_image_start_animation (self);
		}
		_tmp1_ = self->priv->pixbuf_surface;
		if (_tmp1_ != NULL) {
			cairo_surface_t* _tmp2_;
			cairo_surface_t* _tmp3_;
			_tmp2_ = self->priv->pixbuf_surface;
			_tmp3_ = _cairo_surface_reference0 (_tmp2_);
			_cairo_surface_destroy0 (self->priv->old_surface);
			self->priv->old_surface = _tmp3_;
		}
		_tmp4_ = gtk_widget_get_window ((GtkWidget*) self);
		_tmp5_ = gdk_cairo_surface_create_from_pixbuf (value, 1, _tmp4_);
		_cairo_surface_destroy0 (self->priv->pixbuf_surface);
		self->priv->pixbuf_surface = (cairo_surface_t*) _tmp5_;
		self->priv->bg_color.alpha = 0.0;
	}
	gtk_widget_queue_draw ((GtkWidget*) self);
	g_object_notify_by_pspec ((GObject *) self, aspect_image_properties[ASPECT_IMAGE_PIXBUF_PROPERTY]);
}

void
aspect_image_set_color_string (AspectImage* self,
                               const gchar* value)
{
	g_return_if_fail (self != NULL);
	gdk_rgba_parse (&self->priv->bg_color, value);
	g_object_notify_by_pspec ((GObject *) self, aspect_image_properties[ASPECT_IMAGE_COLOR_STRING_PROPERTY]);
}

static GObject *
aspect_image_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	AspectImage * self;
	parent_class = G_OBJECT_CLASS (aspect_image_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASPECT_IMAGE, AspectImage);
	gtk_widget_set_has_window ((GtkWidget*) self, FALSE);
	return obj;
}

static void
aspect_image_class_init (AspectImageClass * klass,
                         gpointer klass_data)
{
	aspect_image_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AspectImage_private_offset);
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) aspect_image_real_get_preferred_height_for_width;
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) aspect_image_real_get_request_mode;
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) aspect_image_real_draw;
	G_OBJECT_CLASS (klass)->set_property = _vala_aspect_image_set_property;
	G_OBJECT_CLASS (klass)->constructor = aspect_image_constructor;
	G_OBJECT_CLASS (klass)->finalize = aspect_image_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASPECT_IMAGE_PIXBUF_PROPERTY, aspect_image_properties[ASPECT_IMAGE_PIXBUF_PROPERTY] = g_param_spec_object ("pixbuf", "pixbuf", "pixbuf", gdk_pixbuf_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), ASPECT_IMAGE_COLOR_STRING_PROPERTY, aspect_image_properties[ASPECT_IMAGE_COLOR_STRING_PROPERTY] = g_param_spec_string ("color-string", "color-string", "color-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
}

static void
aspect_image_instance_init (AspectImage * self,
                            gpointer klass)
{
	self->priv = aspect_image_get_instance_private (self);
	self->priv->pixbuf_surface = NULL;
	self->priv->alpha = 0.0;
	self->priv->in_transition = FALSE;
}

static void
aspect_image_finalize (GObject * obj)
{
	AspectImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ASPECT_IMAGE, AspectImage);
	_cairo_surface_destroy0 (self->priv->old_surface);
	_cairo_surface_destroy0 (self->priv->pixbuf_surface);
	G_OBJECT_CLASS (aspect_image_parent_class)->finalize (obj);
}

static GType
aspect_image_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AspectImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) aspect_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AspectImage), 0, (GInstanceInitFunc) aspect_image_instance_init, NULL };
	GType aspect_image_type_id;
	aspect_image_type_id = g_type_register_static (gtk_widget_get_type (), "AspectImage", &g_define_type_info, 0);
	AspectImage_private_offset = g_type_add_instance_private (aspect_image_type_id, sizeof (AspectImagePrivate));
	return aspect_image_type_id;
}

GType
aspect_image_get_type (void)
{
	static volatile gsize aspect_image_type_id__volatile = 0;
	if (g_once_init_enter (&aspect_image_type_id__volatile)) {
		GType aspect_image_type_id;
		aspect_image_type_id = aspect_image_get_type_once ();
		g_once_init_leave (&aspect_image_type_id__volatile, aspect_image_type_id);
	}
	return aspect_image_type_id__volatile;
}

static void
_vala_aspect_image_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	AspectImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_ASPECT_IMAGE, AspectImage);
	switch (property_id) {
		case ASPECT_IMAGE_PIXBUF_PROPERTY:
		aspect_image_set_pixbuf (self, g_value_get_object (value));
		break;
		case ASPECT_IMAGE_COLOR_STRING_PROPERTY:
		aspect_image_set_color_string (self, g_value_get_string (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

