/* BadgeRadioButton.c generated by valac 0.54.3, the Vala compiler
 * generated from BadgeRadioButton.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <cairo-gobject.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <atk/atk.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>

enum  {
	BADGE_RADIO_BUTTON_0_PROPERTY,
	BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY,
	BADGE_RADIO_BUTTON_NUM_PROPERTIES
};
static GParamSpec* badge_radio_button_properties[BADGE_RADIO_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _BadgeRadioButtonPrivate {
	gboolean _show_badge;
};

static gint BadgeRadioButton_private_offset;
static gpointer badge_radio_button_parent_class = NULL;

#define BADGE_RADIO_BUTTON_BADGE_SIZE 10
static gboolean badge_radio_button_real_draw (GtkWidget* base,
                                       cairo_t* ct);
static void badge_radio_button_finalize (GObject * obj);
static GType badge_radio_button_get_type_once (void);
static void _vala_badge_radio_button_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_badge_radio_button_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
badge_radio_button_get_instance_private (BadgeRadioButton* self)
{
	return G_STRUCT_MEMBER_P (self, BadgeRadioButton_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

BadgeRadioButton*
badge_radio_button_construct (GType object_type,
                              GtkRadioButton* group,
                              const gchar* icon_name,
                              const gchar* text)
{
	BadgeRadioButton * self = NULL;
	GtkStyleContext* ctx = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkStyleContext* _tmp3_;
	GtkImage* i = NULL;
	GtkImage* _tmp4_;
	GtkImage* _tmp5_;
	g_return_val_if_fail (group != NULL, NULL);
	g_return_val_if_fail (icon_name != NULL, NULL);
	g_return_val_if_fail (text != NULL, NULL);
	self = (BadgeRadioButton*) g_object_new (object_type, "group", group, NULL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	ctx = _tmp1_;
	_tmp2_ = ctx;
	gtk_style_context_add_class (_tmp2_, "image-button");
	_tmp3_ = ctx;
	gtk_style_context_add_class (_tmp3_, "flat");
	_tmp4_ = (GtkImage*) gtk_image_new_from_icon_name (icon_name, (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp4_);
	i = _tmp4_;
	_tmp5_ = i;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
	gtk_toggle_button_set_mode ((GtkToggleButton*) self, FALSE);
	gtk_widget_set_focus_on_click ((GtkWidget*) self, FALSE);
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	if (g_strcmp0 (text, "") != 0) {
		AtkObject* accessible = NULL;
		AtkObject* _tmp6_;
		AtkObject* _tmp7_;
		AtkObject* _tmp8_;
		gtk_widget_set_tooltip_text ((GtkWidget*) self, text);
		_tmp6_ = gtk_widget_get_accessible ((GtkWidget*) self);
		_tmp7_ = _g_object_ref0 (_tmp6_);
		accessible = _tmp7_;
		_tmp8_ = accessible;
		atk_object_set_name (_tmp8_, text);
		_g_object_unref0 (accessible);
	}
	_g_object_unref0 (i);
	_g_object_unref0 (ctx);
	return self;
}

BadgeRadioButton*
badge_radio_button_new (GtkRadioButton* group,
                        const gchar* icon_name,
                        const gchar* text)
{
	return badge_radio_button_construct (TYPE_BADGE_RADIO_BUTTON, group, icon_name, text);
}

static gboolean
badge_radio_button_real_draw (GtkWidget* base,
                              cairo_t* ct)
{
	BadgeRadioButton * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkAllocation child_allocation = {0};
	GtkAllocation allocation = {0};
	GtkWidget* _tmp4_;
	GtkAllocation _tmp5_ = {0};
	GtkAllocation _tmp6_ = {0};
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp7_;
	GtkStyleContext* _tmp8_;
	gint x = 0;
	GtkAllocation _tmp9_;
	GtkAllocation _tmp10_;
	GtkAllocation _tmp11_;
	gint y = 0;
	GtkStyleContext* _tmp12_;
	GtkStyleContext* _tmp13_;
	GtkStyleContext* _tmp14_;
	GtkStyleContext* _tmp15_;
	GtkStyleContext* _tmp16_;
	gboolean result = FALSE;
	self = (BadgeRadioButton*) base;
	g_return_val_if_fail (ct != NULL, FALSE);
	GTK_WIDGET_CLASS (badge_radio_button_parent_class)->draw ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_radio_button_get_type (), GtkRadioButton), ct);
	_tmp1_ = badge_radio_button_get_show_badge (self);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		_tmp0_ = TRUE;
	} else {
		GtkWidget* _tmp3_;
		_tmp3_ = gtk_bin_get_child ((GtkBin*) self);
		_tmp0_ = _tmp3_ == NULL;
	}
	if (_tmp0_) {
		result = GDK_EVENT_PROPAGATE;
		return result;
	}
	_tmp4_ = gtk_bin_get_child ((GtkBin*) self);
	gtk_widget_get_allocation (_tmp4_, &_tmp5_);
	child_allocation = _tmp5_;
	gtk_widget_get_allocation ((GtkWidget*) self, &_tmp6_);
	allocation = _tmp6_;
	_tmp7_ = gtk_widget_get_style_context ((GtkWidget*) self);
	_tmp8_ = _g_object_ref0 (_tmp7_);
	context = _tmp8_;
	_tmp9_ = allocation;
	_tmp10_ = child_allocation;
	_tmp11_ = child_allocation;
	x = ((_tmp9_.x - _tmp10_.x) + _tmp11_.width) - BADGE_RADIO_BUTTON_BADGE_SIZE;
	y = 5;
	_tmp12_ = context;
	gtk_style_context_save (_tmp12_);
	_tmp13_ = context;
	gtk_style_context_add_class (_tmp13_, "badge");
	_tmp14_ = context;
	gtk_render_background (_tmp14_, ct, (gdouble) x, (gdouble) y, (gdouble) BADGE_RADIO_BUTTON_BADGE_SIZE, (gdouble) BADGE_RADIO_BUTTON_BADGE_SIZE);
	_tmp15_ = context;
	gtk_render_frame (_tmp15_, ct, (gdouble) x, (gdouble) y, (gdouble) BADGE_RADIO_BUTTON_BADGE_SIZE, (gdouble) BADGE_RADIO_BUTTON_BADGE_SIZE);
	_tmp16_ = context;
	gtk_style_context_restore (_tmp16_);
	result = GDK_EVENT_PROPAGATE;
	_g_object_unref0 (context);
	return result;
}

gboolean
badge_radio_button_get_show_badge (BadgeRadioButton* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_show_badge;
	return result;
}

void
badge_radio_button_set_show_badge (BadgeRadioButton* self,
                                   gboolean value)
{
	const gchar* _tmp0_ = NULL;
	g_return_if_fail (self != NULL);
	if (value) {
		_tmp0_ = "true";
	} else {
		_tmp0_ = "false";
	}
	g_debug ("BadgeRadioButton.vala:23: New show_badge value: %s", _tmp0_);
	if (value != self->priv->_show_badge) {
		self->priv->_show_badge = value;
		gtk_widget_queue_draw ((GtkWidget*) self);
	}
	g_object_notify_by_pspec ((GObject *) self, badge_radio_button_properties[BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY]);
}

static void
badge_radio_button_class_init (BadgeRadioButtonClass * klass,
                               gpointer klass_data)
{
	badge_radio_button_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BadgeRadioButton_private_offset);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) badge_radio_button_real_draw;
	G_OBJECT_CLASS (klass)->get_property = _vala_badge_radio_button_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_badge_radio_button_set_property;
	G_OBJECT_CLASS (klass)->finalize = badge_radio_button_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY, badge_radio_button_properties[BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY] = g_param_spec_boolean ("show-badge", "show-badge", "show-badge", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
badge_radio_button_instance_init (BadgeRadioButton * self,
                                  gpointer klass)
{
	self->priv = badge_radio_button_get_instance_private (self);
	self->priv->_show_badge = FALSE;
}

static void
badge_radio_button_finalize (GObject * obj)
{
	BadgeRadioButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BADGE_RADIO_BUTTON, BadgeRadioButton);
	G_OBJECT_CLASS (badge_radio_button_parent_class)->finalize (obj);
}

static GType
badge_radio_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BadgeRadioButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) badge_radio_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BadgeRadioButton), 0, (GInstanceInitFunc) badge_radio_button_instance_init, NULL };
	GType badge_radio_button_type_id;
	badge_radio_button_type_id = g_type_register_static (gtk_radio_button_get_type (), "BadgeRadioButton", &g_define_type_info, 0);
	BadgeRadioButton_private_offset = g_type_add_instance_private (badge_radio_button_type_id, sizeof (BadgeRadioButtonPrivate));
	return badge_radio_button_type_id;
}

GType
badge_radio_button_get_type (void)
{
	static volatile gsize badge_radio_button_type_id__volatile = 0;
	if (g_once_init_enter (&badge_radio_button_type_id__volatile)) {
		GType badge_radio_button_type_id;
		badge_radio_button_type_id = badge_radio_button_get_type_once ();
		g_once_init_leave (&badge_radio_button_type_id__volatile, badge_radio_button_type_id);
	}
	return badge_radio_button_type_id__volatile;
}

static void
_vala_badge_radio_button_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	BadgeRadioButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BADGE_RADIO_BUTTON, BadgeRadioButton);
	switch (property_id) {
		case BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY:
		g_value_set_boolean (value, badge_radio_button_get_show_badge (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_badge_radio_button_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	BadgeRadioButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_BADGE_RADIO_BUTTON, BadgeRadioButton);
	switch (property_id) {
		case BADGE_RADIO_BUTTON_SHOW_BADGE_PROPERTY:
		badge_radio_button_set_show_badge (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

