/* ResizableImage.c generated by valac 0.54.3, the Vala compiler
 * generated from ResizableImage.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2020 IBBoard
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <cairo-gobject.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <string.h>
#include "cawbird.h"

#define TYPE_RESIZABLE_IMAGE (resizable_image_get_type ())
#define RESIZABLE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RESIZABLE_IMAGE, ResizableImage))
#define RESIZABLE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RESIZABLE_IMAGE, ResizableImageClass))
#define IS_RESIZABLE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RESIZABLE_IMAGE))
#define IS_RESIZABLE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RESIZABLE_IMAGE))
#define RESIZABLE_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RESIZABLE_IMAGE, ResizableImageClass))

typedef struct _ResizableImage ResizableImage;
typedef struct _ResizableImageClass ResizableImageClass;
typedef struct _ResizableImagePrivate ResizableImagePrivate;
enum  {
	RESIZABLE_IMAGE_0_PROPERTY,
	RESIZABLE_IMAGE_NUM_PROPERTIES
};
static GParamSpec* resizable_image_properties[RESIZABLE_IMAGE_NUM_PROPERTIES];
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ResizableImage {
	GtkImage parent_instance;
	ResizableImagePrivate * priv;
	cairo_surface_t* image_surface;
};

struct _ResizableImageClass {
	GtkImageClass parent_class;
};

static gpointer resizable_image_parent_class = NULL;

VALA_EXTERN GType resizable_image_get_type (void) G_GNUC_CONST ;
#define RESIZABLE_IMAGE_MIN_HEIGHT 120
#define RESIZABLE_IMAGE_MIN_WIDTH 120
VALA_EXTERN ResizableImage* resizable_image_new (void);
VALA_EXTERN ResizableImage* resizable_image_construct (GType object_type);
static void resizable_image_get_draw_size (ResizableImage* self,
                                    gint allocated_width,
                                    gint allocated_height,
                                    gint* width,
                                    gint* height,
                                    gdouble* scale);
static gboolean resizable_image_real_draw (GtkWidget* base,
                                    cairo_t* ct);
static GtkSizeRequestMode resizable_image_real_get_request_mode (GtkWidget* base);
static void resizable_image_real_get_preferred_height (GtkWidget* base,
                                                gint* minimum,
                                                gint* natural);
static void resizable_image_real_get_preferred_height_for_width (GtkWidget* base,
                                                          gint width,
                                                          gint* minimum,
                                                          gint* natural);
static void resizable_image_real_get_preferred_width_for_height (GtkWidget* base,
                                                          gint height,
                                                          gint* minimum,
                                                          gint* natural);
static void resizable_image_real_get_preferred_width (GtkWidget* base,
                                               gint* minimum,
                                               gint* natural);
static void resizable_image_finalize (GObject * obj);
static GType resizable_image_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

ResizableImage*
resizable_image_construct (GType object_type)
{
	ResizableImage * self = NULL;
	GtkStyleContext* _tmp0_;
	self = (ResizableImage*) g_object_new (object_type, NULL);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "inline-media");
	return self;
}

ResizableImage*
resizable_image_new (void)
{
	return resizable_image_construct (TYPE_RESIZABLE_IMAGE);
}

static void
resizable_image_get_draw_size (ResizableImage* self,
                               gint allocated_width,
                               gint allocated_height,
                               gint* width,
                               gint* height,
                               gdouble* scale)
{
	gint _vala_width = 0;
	gint _vala_height = 0;
	gdouble _vala_scale = 0.0;
	cairo_surface_t* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->image_surface;
	if (_tmp0_ != NULL) {
		gdouble w = 0.0;
		cairo_surface_t* _tmp1_;
		gdouble h = 0.0;
		cairo_surface_t* _tmp2_;
		_tmp1_ = self->image_surface;
		w = cairo_image_surface_get_width (_tmp1_) * 1.0;
		_tmp2_ = self->image_surface;
		h = cairo_image_surface_get_height (_tmp2_) * 1.0;
		_vala_scale = MIN (1.0, MIN (allocated_width / w, allocated_height / h));
		_vala_width = (gint) floor (w * _vala_scale);
		_vala_height = (gint) floor (h * _vala_scale);
	} else {
		_vala_width = RESIZABLE_IMAGE_MIN_WIDTH;
		_vala_height = RESIZABLE_IMAGE_MIN_HEIGHT;
		_vala_scale = (gdouble) 1;
	}
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
	if (scale) {
		*scale = _vala_scale;
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
resizable_image_real_draw (GtkWidget* base,
                           cairo_t* ct)
{
	ResizableImage * self;
	cairo_surface_t* _tmp0_;
	gboolean result = FALSE;
	self = (ResizableImage*) base;
	g_return_val_if_fail (ct != NULL, FALSE);
	_tmp0_ = self->image_surface;
	if (_tmp0_ != NULL) {
		gint widget_width = 0;
		gint widget_height = 0;
		gint draw_width = 0;
		gint draw_height = 0;
		gdouble scale = 0.0;
		gint _tmp1_ = 0;
		gint _tmp2_ = 0;
		gdouble _tmp3_ = 0.0;
		gdouble draw_x = 0.0;
		gdouble draw_y = 0.0;
		cairo_surface_t* _tmp4_;
		GtkStyleContext* sc = NULL;
		GtkStyleContext* _tmp5_;
		GtkStyleContext* _tmp6_;
		GtkStyleContext* _tmp7_;
		GtkStyleContext* _tmp8_;
		widget_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
		widget_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
		resizable_image_get_draw_size (self, widget_width, widget_height, &_tmp1_, &_tmp2_, &_tmp3_);
		draw_width = _tmp1_;
		draw_height = _tmp2_;
		scale = _tmp3_;
		draw_x = (gdouble) ((widget_width - draw_width) / 2);
		cairo_save (ct);
		cairo_rectangle (ct, (gdouble) 0, (gdouble) 0, (gdouble) widget_width, (gdouble) widget_height);
		cairo_scale (ct, scale, scale);
		draw_y = (gdouble) ((widget_height - draw_height) / 2);
		_tmp4_ = self->image_surface;
		cairo_set_source_surface (ct, _tmp4_, draw_x / scale, draw_y / scale);
		cairo_paint (ct);
		cairo_restore (ct);
		_tmp5_ = gtk_widget_get_style_context ((GtkWidget*) self);
		_tmp6_ = _g_object_ref0 (_tmp5_);
		sc = _tmp6_;
		_tmp7_ = sc;
		gtk_render_background (_tmp7_, ct, draw_x, (gdouble) 0, (gdouble) draw_width, (gdouble) draw_height);
		_tmp8_ = sc;
		gtk_render_frame (_tmp8_, ct, draw_x, (gdouble) 0, (gdouble) draw_width, (gdouble) draw_height);
		if (gtk_widget_has_visible_focus ((GtkWidget*) self)) {
			GtkStyleContext* _tmp9_;
			_tmp9_ = sc;
			gtk_render_focus (_tmp9_, ct, draw_x + 2, (gdouble) 2, (gdouble) (draw_width - 4), (gdouble) (draw_height - 4));
		}
		_g_object_unref0 (sc);
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static GtkSizeRequestMode
resizable_image_real_get_request_mode (GtkWidget* base)
{
	ResizableImage * self;
	GtkSizeRequestMode result = 0;
	self = (ResizableImage*) base;
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
	return result;
}

static void
resizable_image_real_get_preferred_height (GtkWidget* base,
                                           gint* minimum,
                                           gint* natural)
{
	ResizableImage * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _tmp0_ = 0;
	cairo_surface_t* _tmp1_;
	gint media_height = 0;
	self = (ResizableImage*) base;
	_tmp1_ = self->image_surface;
	if (_tmp1_ != NULL) {
		cairo_surface_t* _tmp2_;
		_tmp2_ = self->image_surface;
		_tmp0_ = cairo_image_surface_get_height (_tmp2_);
	} else {
		_tmp0_ = RESIZABLE_IMAGE_MIN_HEIGHT;
	}
	media_height = _tmp0_;
	_vala_minimum = MIN (media_height, RESIZABLE_IMAGE_MIN_HEIGHT);
	_vala_natural = media_height;
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}

static void
resizable_image_real_get_preferred_height_for_width (GtkWidget* base,
                                                     gint width,
                                                     gint* minimum,
                                                     gint* natural)
{
	ResizableImage * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _tmp0_ = 0;
	cairo_surface_t* _tmp1_;
	gint media_width = 0;
	gint _tmp3_ = 0;
	cairo_surface_t* _tmp4_;
	gint media_height = 0;
	gdouble scale = 0.0;
	self = (ResizableImage*) base;
	_tmp1_ = self->image_surface;
	if (_tmp1_ != NULL) {
		cairo_surface_t* _tmp2_;
		_tmp2_ = self->image_surface;
		_tmp0_ = cairo_image_surface_get_width (_tmp2_);
	} else {
		_tmp0_ = RESIZABLE_IMAGE_MIN_WIDTH;
	}
	media_width = _tmp0_;
	_tmp4_ = self->image_surface;
	if (_tmp4_ != NULL) {
		cairo_surface_t* _tmp5_;
		_tmp5_ = self->image_surface;
		_tmp3_ = cairo_image_surface_get_height (_tmp5_);
	} else {
		_tmp3_ = RESIZABLE_IMAGE_MIN_HEIGHT;
	}
	media_height = _tmp3_;
	scale = width / ((gdouble) media_width);
	if (scale >= ((gdouble) 1)) {
		_vala_natural = media_height;
	} else {
		_vala_natural = (gint) floor (media_height * scale);
	}
	_vala_minimum = MIN (media_height, RESIZABLE_IMAGE_MIN_HEIGHT);
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}

static void
resizable_image_real_get_preferred_width_for_height (GtkWidget* base,
                                                     gint height,
                                                     gint* minimum,
                                                     gint* natural)
{
	ResizableImage * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _tmp0_ = 0;
	cairo_surface_t* _tmp1_;
	gint media_width = 0;
	gint _tmp3_ = 0;
	cairo_surface_t* _tmp4_;
	gint media_height = 0;
	gdouble scale = 0.0;
	self = (ResizableImage*) base;
	_tmp1_ = self->image_surface;
	if (_tmp1_ != NULL) {
		cairo_surface_t* _tmp2_;
		_tmp2_ = self->image_surface;
		_tmp0_ = cairo_image_surface_get_width (_tmp2_);
	} else {
		_tmp0_ = RESIZABLE_IMAGE_MIN_WIDTH;
	}
	media_width = _tmp0_;
	_tmp4_ = self->image_surface;
	if (_tmp4_ != NULL) {
		cairo_surface_t* _tmp5_;
		_tmp5_ = self->image_surface;
		_tmp3_ = cairo_image_surface_get_height (_tmp5_);
	} else {
		_tmp3_ = RESIZABLE_IMAGE_MIN_HEIGHT;
	}
	media_height = _tmp3_;
	scale = height / ((gdouble) media_height);
	if (scale >= ((gdouble) 1)) {
		_vala_natural = media_width;
	} else {
		_vala_natural = (gint) floor (media_width * scale);
	}
	_vala_minimum = MIN (media_width, RESIZABLE_IMAGE_MIN_WIDTH);
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}

static void
resizable_image_real_get_preferred_width (GtkWidget* base,
                                          gint* minimum,
                                          gint* natural)
{
	ResizableImage * self;
	gint _vala_minimum = 0;
	gint _vala_natural = 0;
	gint _tmp0_ = 0;
	cairo_surface_t* _tmp1_;
	gint media_width = 0;
	self = (ResizableImage*) base;
	_tmp1_ = self->image_surface;
	if (_tmp1_ != NULL) {
		cairo_surface_t* _tmp2_;
		_tmp2_ = self->image_surface;
		_tmp0_ = cairo_image_surface_get_width (_tmp2_);
	} else {
		_tmp0_ = RESIZABLE_IMAGE_MIN_WIDTH;
	}
	media_width = _tmp0_;
	_vala_minimum = MIN (media_width, RESIZABLE_IMAGE_MIN_WIDTH);
	_vala_natural = media_width;
	if (minimum) {
		*minimum = _vala_minimum;
	}
	if (natural) {
		*natural = _vala_natural;
	}
}

static void
resizable_image_class_init (ResizableImageClass * klass,
                            gpointer klass_data)
{
	resizable_image_parent_class = g_type_class_peek_parent (klass);
	((GtkWidgetClass *) klass)->draw = (gboolean (*) (GtkWidget*, cairo_t*)) resizable_image_real_draw;
	((GtkWidgetClass *) klass)->get_request_mode = (GtkSizeRequestMode (*) (GtkWidget*)) resizable_image_real_get_request_mode;
	((GtkWidgetClass *) klass)->get_preferred_height = (void (*) (GtkWidget*, gint*, gint*)) resizable_image_real_get_preferred_height;
	((GtkWidgetClass *) klass)->get_preferred_height_for_width = (void (*) (GtkWidget*, gint, gint*, gint*)) resizable_image_real_get_preferred_height_for_width;
	((GtkWidgetClass *) klass)->get_preferred_width_for_height = (void (*) (GtkWidget*, gint, gint*, gint*)) resizable_image_real_get_preferred_width_for_height;
	((GtkWidgetClass *) klass)->get_preferred_width = (void (*) (GtkWidget*, gint*, gint*)) resizable_image_real_get_preferred_width;
	G_OBJECT_CLASS (klass)->finalize = resizable_image_finalize;
}

static void
resizable_image_instance_init (ResizableImage * self,
                               gpointer klass)
{
	self->image_surface = NULL;
}

static void
resizable_image_finalize (GObject * obj)
{
	ResizableImage * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RESIZABLE_IMAGE, ResizableImage);
	_cairo_surface_destroy0 (self->image_surface);
	G_OBJECT_CLASS (resizable_image_parent_class)->finalize (obj);
}

static GType
resizable_image_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ResizableImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) resizable_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ResizableImage), 0, (GInstanceInitFunc) resizable_image_instance_init, NULL };
	GType resizable_image_type_id;
	resizable_image_type_id = g_type_register_static (gtk_image_get_type (), "ResizableImage", &g_define_type_info, 0);
	return resizable_image_type_id;
}

GType
resizable_image_get_type (void)
{
	static volatile gsize resizable_image_type_id__volatile = 0;
	if (g_once_init_enter (&resizable_image_type_id__volatile)) {
		GType resizable_image_type_id;
		resizable_image_type_id = resizable_image_get_type_once ();
		g_once_init_leave (&resizable_image_type_id__volatile, resizable_image_type_id);
	}
	return resizable_image_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

