/* TextButton.c generated by valac 0.54.3, the Vala compiler
 * generated from TextButton.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>

enum  {
	TEXT_BUTTON_0_PROPERTY,
	TEXT_BUTTON_NUM_PROPERTIES
};
static GParamSpec* text_button_properties[TEXT_BUTTON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

static gpointer text_button_parent_class = NULL;

static GObject * text_button_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static GType text_button_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

TextButton*
text_button_construct (GType object_type)
{
	TextButton * self = NULL;
	self = (TextButton*) g_object_new (object_type, NULL);
	return self;
}

TextButton*
text_button_new (void)
{
	return text_button_construct (TYPE_TEXT_BUTTON);
}

/**
   * Adds a GtkLabel to the Button using the given text as the text.
   * If the button already contains another child, that will either be replaced if it's
   * no instance of GtkLabel, or - if it's a GtkLabel already - be reused.
   *
   * @param text The markup to use(see pango markup)
   */
static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
text_button_set_text (TextButton* self,
                      const gchar* text)
{
	GtkLabel* label = NULL;
	GtkWidget* child = NULL;
	GtkWidget* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkLabel* _tmp10_;
	GtkLabel* _tmp11_;
	GtkLabel* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkContainer* _tmp16_;
	GtkContainer* _tmp17_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (text != NULL);
	label = NULL;
	_tmp0_ = gtk_bin_get_child ((GtkBin*) self);
	_tmp1_ = _g_object_ref0 (_tmp0_);
	child = _tmp1_;
	_tmp2_ = child;
	if (_tmp2_ != NULL) {
		GtkWidget* _tmp3_;
		_tmp3_ = child;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, gtk_label_get_type ())) {
			GtkWidget* _tmp4_;
			GtkLabel* _tmp5_;
			GtkLabel* _tmp6_;
			_tmp4_ = child;
			_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_label_get_type (), GtkLabel));
			_g_object_unref0 (label);
			label = _tmp5_;
			_tmp6_ = label;
			gtk_label_set_text (_tmp6_, text);
		} else {
			GtkWidget* _tmp7_;
			GtkLabel* _tmp8_;
			_tmp7_ = child;
			gtk_container_remove ((GtkContainer*) self, _tmp7_);
			_tmp8_ = (GtkLabel*) gtk_label_new (text);
			g_object_ref_sink (_tmp8_);
			_g_object_unref0 (label);
			label = _tmp8_;
		}
	} else {
		GtkLabel* _tmp9_;
		_tmp9_ = (GtkLabel*) gtk_label_new (text);
		g_object_ref_sink (_tmp9_);
		_g_object_unref0 (label);
		label = _tmp9_;
	}
	_tmp10_ = label;
	gtk_label_set_justify (_tmp10_, GTK_JUSTIFY_CENTER);
	_tmp11_ = label;
	gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_BASELINE);
	_tmp12_ = label;
	gtk_label_set_ellipsize (_tmp12_, PANGO_ELLIPSIZE_END);
	_tmp13_ = label;
	gtk_label_set_xalign (_tmp13_, (gfloat) 0);
	_tmp14_ = label;
	gtk_widget_set_visible ((GtkWidget*) _tmp14_, TRUE);
	_tmp15_ = label;
	_tmp16_ = gtk_widget_get_parent ((GtkWidget*) _tmp15_);
	_tmp17_ = _tmp16_;
	if (_tmp17_ == NULL) {
		GtkLabel* _tmp18_;
		_tmp18_ = label;
		gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp18_);
	}
	_g_object_unref0 (child);
	_g_object_unref0 (label);
}

static GObject *
text_button_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TextButton * self;
	GtkStyleContext* _tmp0_;
	parent_class = G_OBJECT_CLASS (text_button_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TEXT_BUTTON, TextButton);
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
	gtk_style_context_add_class (_tmp0_, "text-only-button");
	return obj;
}

static void
text_button_class_init (TextButtonClass * klass,
                        gpointer klass_data)
{
	text_button_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->constructor = text_button_constructor;
}

static void
text_button_instance_init (TextButton * self,
                           gpointer klass)
{
}

static GType
text_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TextButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) text_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TextButton), 0, (GInstanceInitFunc) text_button_instance_init, NULL };
	GType text_button_type_id;
	text_button_type_id = g_type_register_static (gtk_button_get_type (), "TextButton", &g_define_type_info, 0);
	return text_button_type_id;
}

GType
text_button_get_type (void)
{
	static volatile gsize text_button_type_id__volatile = 0;
	if (g_once_init_enter (&text_button_type_id__volatile)) {
		GType text_button_type_id;
		text_button_type_id = text_button_get_type_once ();
		g_once_init_leave (&text_button_type_id__volatile, text_button_type_id);
	}
	return text_button_type_id__volatile;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

