/* UserListsWidget.c generated by valac 0.54.3, the Vala compiler
 * generated from UserListsWidget.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "cawbird.h"
#include <glib.h>
#include "CbBundle.h"
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <rest/rest-proxy-call.h>
#include <rest/oauth-proxy.h>
#include <rest/rest-proxy.h>
#include "CbUtils.h"
#include <json-glib/json-glib.h>
#include <glib/gi18n-lib.h>
#include <atk/atk.h>
#include <gdk/gdk.h>

#define TYPE_USER_LISTS_WIDGET (user_lists_widget_get_type ())
#define USER_LISTS_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_LISTS_WIDGET, UserListsWidget))
#define USER_LISTS_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_LISTS_WIDGET, UserListsWidgetClass))
#define IS_USER_LISTS_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_LISTS_WIDGET))
#define IS_USER_LISTS_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_LISTS_WIDGET))
#define USER_LISTS_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_LISTS_WIDGET, UserListsWidgetClass))

typedef struct _UserListsWidget UserListsWidget;
typedef struct _UserListsWidgetClass UserListsWidgetClass;
typedef struct _UserListsWidgetPrivate UserListsWidgetPrivate;

#define TYPE_NEW_LIST_ENTRY (new_list_entry_get_type ())
#define NEW_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NEW_LIST_ENTRY, NewListEntry))
#define NEW_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NEW_LIST_ENTRY, NewListEntryClass))
#define IS_NEW_LIST_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NEW_LIST_ENTRY))
#define IS_NEW_LIST_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NEW_LIST_ENTRY))
#define NEW_LIST_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NEW_LIST_ENTRY, NewListEntryClass))

typedef struct _NewListEntry NewListEntry;
typedef struct _NewListEntryClass NewListEntryClass;
enum  {
	USER_LISTS_WIDGET_0_PROPERTY,
	USER_LISTS_WIDGET_MAIN_WINDOW_PROPERTY,
	USER_LISTS_WIDGET_ACCOUNT_PROPERTY,
	USER_LISTS_WIDGET_NUM_PROPERTIES
};
static GParamSpec* user_lists_widget_properties[USER_LISTS_WIDGET_NUM_PROPERTIES];
typedef enum  {
	PAGE_STREAM = 0,
	PAGE_MENTIONS,
	PAGE_FAVORITES,
	PAGE_DM_THREADS,
	PAGE_LISTS,
	PAGE_FILTERS,
	PAGE_SEARCH,
	PAGE_PROFILE,
	PAGE_TWEET_INFO,
	PAGE_DM,
	PAGE_LIST_STATUSES,
	PAGE_PREVIOUS = 1024,
	PAGE_NEXT = 2048
} Page;

#define TYPE_PAGE (page_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block87Data Block87Data;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _UserListsWidgetLoadListsData UserListsWidgetLoadListsData;
typedef struct _Block88Data Block88Data;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
typedef struct _Block89Data Block89Data;
typedef struct _Block90Data Block90Data;

#define TYPE_TWITTER_LIST (twitter_list_get_type ())
typedef struct _TwitterList TwitterList;
typedef struct _Block91Data Block91Data;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _UserListsWidget {
	GtkBox parent_instance;
	UserListsWidgetPrivate * priv;
};

struct _UserListsWidgetClass {
	GtkBoxClass parent_class;
};

struct _UserListsWidgetPrivate {
	GtkLabel* user_list_label;
	GtkListBox* user_list_box;
	GtkFrame* user_list_frame;
	GtkLabel* subscribed_list_label;
	GtkListBox* subscribed_list_box;
	GtkFrame* subscribed_list_frame;
	NewListEntry* new_list_entry;
	GtkRevealer* user_lists_revealer;
	GtkSeparator* upper_separator;
	GtkListBox* new_list_box;
	MainWindow* _main_window;
	Account* _account;
	gboolean show_create_entry;
};

struct _Block87Data {
	int _ref_count_;
	UserListsWidget* self;
	Collect* collect_obj;
	gpointer _async_data_;
};

struct _UserListsWidgetLoadListsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	UserListsWidget* self;
	gint64 user_id;
	gchar* name;
	gchar* screen_name;
	Block87Data* _data87_;
	Account* _tmp0_;
	Collect* _tmp1_;
	Collect* _tmp2_;
	RestProxyCall* call;
	Account* _tmp3_;
	OAuthProxy* _tmp4_;
	RestProxyCall* _tmp5_;
	RestProxyCall* _tmp6_;
	RestProxyCall* _tmp7_;
	RestProxyCall* _tmp8_;
	RestProxyCall* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	RestProxyCall* _tmp12_;
	RestProxyCall* user_call;
	Account* _tmp13_;
	OAuthProxy* _tmp14_;
	RestProxyCall* _tmp15_;
	RestProxyCall* _tmp16_;
	RestProxyCall* _tmp17_;
	RestProxyCall* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	RestProxyCall* _tmp21_;
	RestProxyCall* _tmp22_;
	gchar* _tmp23_;
	Account* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* accessible_name;
	gchar* _tmp27_;
	GtkListBox* _tmp28_;
	AtkObject* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	Account* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	GtkListBox* _tmp36_;
	AtkObject* _tmp37_;
	const gchar* _tmp38_;
};

struct _Block88Data {
	int _ref_count_;
	UserListsWidget* self;
	gint64* ids;
	gint ids_length1;
	gint _ids_size_;
	GtkListBox* list_box;
};

struct _Block89Data {
	int _ref_count_;
	UserListsWidget* self;
	guint n_user_lists;
	gint64 list_id;
};

struct _Block90Data {
	int _ref_count_;
	UserListsWidget* self;
	gint64 list_id;
	gchar* title;
	gchar* name;
	gchar* description;
	gchar* mode;
};

struct _TwitterList {
	gint64 id;
	gchar* name;
	gchar* description;
	gchar* mode;
	guint n_members;
};

struct _Block91Data {
	int _ref_count_;
	UserListsWidget* self;
	RestProxyCall* call;
};

static gint UserListsWidget_private_offset;
static gpointer user_lists_widget_parent_class = NULL;

VALA_EXTERN GType user_lists_widget_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType new_list_entry_get_type (void) G_GNUC_CONST ;
VALA_EXTERN UserListsWidget* user_lists_widget_new (void);
VALA_EXTERN UserListsWidget* user_lists_widget_construct (GType object_type);
VALA_EXTERN void user_lists_widget_connect_nav (UserListsWidget* self,
                                    GtkScrolledWindow* parent,
                                    GtkWidget* widget_up);
VALA_EXTERN void user_lists_widget_hide_user_list_entry (UserListsWidget* self);
static void user_lists_widget_row_activated (UserListsWidget* self,
                                      GtkListBoxRow* row);
VALA_EXTERN void new_list_entry_reveal (NewListEntry* self);
#define LIST_STATUSES_PAGE_KEY_LIST_ID 8
#define LIST_STATUSES_PAGE_KEY_TITLE 9
#define LIST_STATUSES_PAGE_KEY_NAME 1
#define LIST_STATUSES_PAGE_KEY_USER_LIST 0
#define LIST_STATUSES_PAGE_KEY_DESCRIPTION 2
#define LIST_STATUSES_PAGE_KEY_CREATOR 3
#define LIST_STATUSES_PAGE_KEY_N_SUBSCRIBERS 4
#define LIST_STATUSES_PAGE_KEY_N_MEMBERS 5
#define LIST_STATUSES_PAGE_KEY_CREATED_AT 6
#define LIST_STATUSES_PAGE_KEY_MODE 7
VALA_EXTERN MainWindow* user_lists_widget_get_main_window (UserListsWidget* self);
VALA_EXTERN GType page_get_type (void) G_GNUC_CONST ;
static void _user_lists_widget_row_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                  GtkListBoxRow* row,
                                                                  gpointer self);
static void user_lists_widget_load_lists_data_free (gpointer _data);
VALA_EXTERN void user_lists_widget_load_lists (UserListsWidget* self,
                                   gint64 user_id,
                                   const gchar* name,
                                   const gchar* screen_name,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
VALA_EXTERN void user_lists_widget_load_lists_finish (UserListsWidget* self,
                                          GAsyncResult* _res_);
static gboolean user_lists_widget_load_lists_co (UserListsWidgetLoadListsData* _data_);
static Block87Data* block87_data_ref (Block87Data* _data87_);
static void block87_data_unref (void * _userdata_);
VALA_EXTERN Account* user_lists_widget_get_account (UserListsWidget* self);
static void __lambda107_ (Block87Data* _data87_);
static void ___lambda107__collect_finished (Collect* _sender,
                                     GError* _error_,
                                     gpointer self);
static void __lambda108_ (Block87Data* _data87_,
                   GObject* _,
                   GAsyncResult* res);
static void _vala_JsonNode_free (JsonNode* self);
static guint user_lists_widget_lists_received_cb (UserListsWidget* self,
                                           JsonNode* root,
                                           GtkListBox* list_box);
static void ___lambda108__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void __lambda112_ (Block87Data* _data87_,
                   GObject* _,
                   GAsyncResult* res);
static void ___lambda112__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static Block88Data* block88_data_ref (Block88Data* _data88_);
static void block88_data_unref (void * _userdata_);
static void __lambda109_ (Block88Data* _data88_,
                   JsonArray* array,
                   guint index,
                   JsonNode* node);
static void _vala_array_add4 (gint64* * array,
                       gint* length,
                       gint* size,
                       gint64 value);
VALA_EXTERN void user_lists_widget_add_list (UserListsWidget* self,
                                 ListListEntry* entry,
                                 GtkListBox* list_box);
static void ___lambda109__json_array_foreach (JsonArray* array,
                                       guint index_,
                                       JsonNode* element_node,
                                       gpointer self);
static gboolean _vala_int64_array_contains (gint64 * stack,
                                     gssize stack_length,
                                     const gint64 needle);
VALA_EXTERN void user_lists_widget_remove_list (UserListsWidget* self,
                                    gint64 list_id);
static Block89Data* block89_data_ref (Block89Data* _data89_);
static void block89_data_unref (void * _userdata_);
static void __lambda110_ (Block89Data* _data89_,
                   GtkWidget* w);
static void ___lambda110__gtk_callback (GtkWidget* widget,
                                 gpointer self);
static void __lambda111_ (Block89Data* _data89_,
                   GtkWidget* w);
static void ___lambda111__gtk_callback (GtkWidget* widget,
                                 gpointer self);
static void user_lists_widget_update_list_entry_from_entry (UserListsWidget* self,
                                                     ListListEntry* list_entry,
                                                     ListListEntry* src_entry);
VALA_EXTERN void user_lists_widget_update_list (UserListsWidget* self,
                                    gint64 list_id,
                                    const gchar* title,
                                    const gchar* name,
                                    const gchar* description,
                                    const gchar* mode);
static Block90Data* block90_data_ref (Block90Data* _data90_);
static void block90_data_unref (void * _userdata_);
static void __lambda113_ (Block90Data* _data90_,
                   GtkWidget* w);
static void user_lists_widget_update_list_entry (UserListsWidget* self,
                                          ListListEntry* list_entry,
                                          const gchar* title,
                                          const gchar* name,
                                          const gchar* description,
                                          const gchar* mode);
static void ___lambda113__gtk_callback (GtkWidget* widget,
                                 gpointer self);
VALA_EXTERN void user_lists_widget_update_member_count (UserListsWidget* self,
                                            gint64 list_id,
                                            gint increase);
VALA_EXTERN GType twitter_list_get_type (void) G_GNUC_CONST ;
VALA_EXTERN TwitterList* twitter_list_dup (const TwitterList* self);
VALA_EXTERN void twitter_list_free (TwitterList* self);
VALA_EXTERN void twitter_list_copy (const TwitterList* self,
                        TwitterList* dest);
VALA_EXTERN void twitter_list_destroy (TwitterList* self);
VALA_EXTERN TwitterList* user_lists_widget_get_user_lists (UserListsWidget* self,
                                               gint* result_length1);
VALA_EXTERN void user_lists_widget_clear_lists (UserListsWidget* self);
static void __lambda115_ (UserListsWidget* self,
                   GtkWidget* w);
static void ___lambda115__gtk_callback (GtkWidget* widget,
                                 gpointer self);
static void __lambda116_ (UserListsWidget* self,
                   GtkWidget* w);
static void ___lambda116__gtk_callback (GtkWidget* widget,
                                 gpointer self);
static void user_lists_widget_new_list_create_activated_cb (UserListsWidget* self,
                                                     const gchar* list_name);
static Block91Data* block91_data_ref (Block91Data* _data91_);
static void block91_data_unref (void * _userdata_);
static void __lambda117_ (Block91Data* _data91_,
                   GObject* o,
                   GAsyncResult* res);
VALA_EXTERN void utils_show_error_dialog (GError* e,
                              GtkWindow* transient_for,
                              const gchar* file,
                              gint line);
static void ___lambda117__gasync_ready_callback (GObject* source_object,
                                          GAsyncResult* res,
                                          gpointer self);
static void _user_lists_widget_new_list_create_activated_cb_new_list_entry_create_activated (NewListEntry* _sender,
                                                                                      const gchar* list_name,
                                                                                      gpointer self);
VALA_EXTERN void user_lists_widget_unreveal (UserListsWidget* self);
VALA_EXTERN void new_list_entry_unreveal (NewListEntry* self);
static gboolean user_lists_widget_new_list_box_keynav_failed_cb (UserListsWidget* self,
                                                          GtkDirectionType direction);
static gboolean _user_lists_widget_new_list_box_keynav_failed_cb_gtk_widget_keynav_failed (GtkWidget* _sender,
                                                                                    GtkDirectionType direction,
                                                                                    gpointer self);
static gboolean user_lists_widget_user_list_box_keynav_failed_cb (UserListsWidget* self,
                                                           GtkDirectionType direction);
static gboolean _user_lists_widget_user_list_box_keynav_failed_cb_gtk_widget_keynav_failed (GtkWidget* _sender,
                                                                                     GtkDirectionType direction,
                                                                                     gpointer self);
static gboolean user_lists_widget_subscribed_list_box_keynav_failed_cb (UserListsWidget* self,
                                                                 GtkDirectionType direction);
static gboolean _user_lists_widget_subscribed_list_box_keynav_failed_cb_gtk_widget_keynav_failed (GtkWidget* _sender,
                                                                                           GtkDirectionType direction,
                                                                                           gpointer self);
static void user_lists_widget_revealer_child_revealed_cb (UserListsWidget* self,
                                                   GObject* source,
                                                   GParamSpec* spec);
static void _user_lists_widget_revealer_child_revealed_cb_g_object_notify (GObject* _sender,
                                                                    GParamSpec* pspec,
                                                                    gpointer self);
VALA_EXTERN void user_lists_widget_set_main_window (UserListsWidget* self,
                                        MainWindow* value);
VALA_EXTERN void user_lists_widget_set_account (UserListsWidget* self,
                                    Account* value);
static GObject * user_lists_widget_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties);
VALA_EXTERN void default_header_func (GtkListBoxRow* row,
                          GtkListBoxRow* row_before);
static void _default_header_func_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                           GtkListBoxRow* before,
                                                           gpointer self);
static gint _list_list_entry_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                        GtkListBoxRow* row2,
                                                        gpointer self);
static void user_lists_widget_finalize (GObject * obj);
static GType user_lists_widget_get_type_once (void);
static void _vala_user_lists_widget_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec);
static void _vala_user_lists_widget_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
user_lists_widget_get_instance_private (UserListsWidget* self)
{
	return G_STRUCT_MEMBER_P (self, UserListsWidget_private_offset);
}

UserListsWidget*
user_lists_widget_construct (GType object_type)
{
	UserListsWidget * self = NULL;
	self = (UserListsWidget*) g_object_new (object_type, NULL);
	return self;
}

UserListsWidget*
user_lists_widget_new (void)
{
	return user_lists_widget_construct (TYPE_USER_LISTS_WIDGET);
}

void
user_lists_widget_connect_nav (UserListsWidget* self,
                               GtkScrolledWindow* parent,
                               GtkWidget* widget_up)
{
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (parent != NULL);
	g_return_if_fail (widget_up != NULL);
	_tmp0_ = self->priv->user_list_box;
	utils_connect_vadjustment (parent, _tmp0_, NULL, NULL);
	_tmp1_ = self->priv->subscribed_list_box;
	utils_connect_vadjustment (parent, _tmp1_, NULL, NULL);
}

void
user_lists_widget_hide_user_list_entry (UserListsWidget* self)
{
	NewListEntry* _tmp0_;
	NewListEntry* _tmp1_;
	GtkLabel* _tmp2_;
	GtkSeparator* _tmp3_;
	GtkSeparator* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->new_list_entry;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	_tmp1_ = self->priv->new_list_entry;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = self->priv->user_list_label;
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, TRUE);
	self->priv->show_create_entry = FALSE;
	_tmp3_ = self->priv->upper_separator;
	gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
	_tmp4_ = self->priv->upper_separator;
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp4_, TRUE);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
user_lists_widget_row_activated (UserListsWidget* self,
                                 GtkListBoxRow* row)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (row != NULL);
	if (IS_NEW_LIST_ENTRY (row)) {
		new_list_entry_reveal (G_TYPE_CHECK_INSTANCE_CAST (row, TYPE_NEW_LIST_ENTRY, NewListEntry));
	} else {
		ListListEntry* entry = NULL;
		ListListEntry* _tmp0_;
		CbBundle* bundle = NULL;
		CbBundle* _tmp1_;
		CbBundle* _tmp2_;
		ListListEntry* _tmp3_;
		CbBundle* _tmp4_;
		ListListEntry* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		CbBundle* _tmp8_;
		ListListEntry* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		CbBundle* _tmp12_;
		ListListEntry* _tmp13_;
		CbBundle* _tmp14_;
		ListListEntry* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		CbBundle* _tmp18_;
		ListListEntry* _tmp19_;
		const gchar* _tmp20_;
		CbBundle* _tmp21_;
		ListListEntry* _tmp22_;
		CbBundle* _tmp23_;
		ListListEntry* _tmp24_;
		CbBundle* _tmp25_;
		ListListEntry* _tmp26_;
		CbBundle* _tmp27_;
		ListListEntry* _tmp28_;
		const gchar* _tmp29_;
		MainWindow* _tmp30_;
		MainWidget* _tmp31_;
		CbBundle* _tmp32_;
		_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (row, TYPE_LIST_LIST_ENTRY, ListListEntry));
		entry = _tmp0_;
		_tmp1_ = cb_bundle_new ();
		bundle = _tmp1_;
		_tmp2_ = bundle;
		_tmp3_ = entry;
		cb_bundle_put_int64 (_tmp2_, LIST_STATUSES_PAGE_KEY_LIST_ID, _tmp3_->id);
		_tmp4_ = bundle;
		_tmp5_ = entry;
		_tmp6_ = list_list_entry_get_title (_tmp5_);
		_tmp7_ = _tmp6_;
		cb_bundle_put_string (_tmp4_, LIST_STATUSES_PAGE_KEY_TITLE, _tmp7_);
		_tmp8_ = bundle;
		_tmp9_ = entry;
		_tmp10_ = list_list_entry_get_name (_tmp9_);
		_tmp11_ = _tmp10_;
		cb_bundle_put_string (_tmp8_, LIST_STATUSES_PAGE_KEY_NAME, _tmp11_);
		_tmp12_ = bundle;
		_tmp13_ = entry;
		cb_bundle_put_bool (_tmp12_, LIST_STATUSES_PAGE_KEY_USER_LIST, _tmp13_->user_list);
		_tmp14_ = bundle;
		_tmp15_ = entry;
		_tmp16_ = list_list_entry_get_description (_tmp15_);
		_tmp17_ = _tmp16_;
		cb_bundle_put_string (_tmp14_, LIST_STATUSES_PAGE_KEY_DESCRIPTION, _tmp17_);
		_tmp18_ = bundle;
		_tmp19_ = entry;
		_tmp20_ = _tmp19_->creator_screen_name;
		cb_bundle_put_string (_tmp18_, LIST_STATUSES_PAGE_KEY_CREATOR, _tmp20_);
		_tmp21_ = bundle;
		_tmp22_ = entry;
		cb_bundle_put_int (_tmp21_, LIST_STATUSES_PAGE_KEY_N_SUBSCRIBERS, _tmp22_->n_subscribers);
		_tmp23_ = bundle;
		_tmp24_ = entry;
		cb_bundle_put_int (_tmp23_, LIST_STATUSES_PAGE_KEY_N_MEMBERS, _tmp24_->n_members);
		_tmp25_ = bundle;
		_tmp26_ = entry;
		cb_bundle_put_int64 (_tmp25_, LIST_STATUSES_PAGE_KEY_CREATED_AT, _tmp26_->created_at);
		_tmp27_ = bundle;
		_tmp28_ = entry;
		_tmp29_ = _tmp28_->mode;
		cb_bundle_put_string (_tmp27_, LIST_STATUSES_PAGE_KEY_MODE, _tmp29_);
		_tmp30_ = self->priv->_main_window;
		_tmp31_ = _tmp30_->main_widget;
		_tmp32_ = bundle;
		main_widget_switch_page (_tmp31_, (gint) PAGE_LIST_STATUSES, _tmp32_);
		_g_object_unref0 (bundle);
		_g_object_unref0 (entry);
	}
}

static void
_user_lists_widget_row_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                             GtkListBoxRow* row,
                                                             gpointer self)
{
	user_lists_widget_row_activated ((UserListsWidget*) self, row);
}

static void
user_lists_widget_load_lists_data_free (gpointer _data)
{
	UserListsWidgetLoadListsData* _data_;
	_data_ = _data;
	_g_free0 (_data_->name);
	_g_free0 (_data_->screen_name);
	_g_object_unref0 (_data_->self);
	g_slice_free (UserListsWidgetLoadListsData, _data_);
}

void
user_lists_widget_load_lists (UserListsWidget* self,
                              gint64 user_id,
                              const gchar* name,
                              const gchar* screen_name,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	UserListsWidgetLoadListsData* _data_;
	UserListsWidget* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (screen_name != NULL);
	_data_ = g_slice_new0 (UserListsWidgetLoadListsData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, user_lists_widget_load_lists_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->user_id = user_id;
	_tmp1_ = g_strdup (name);
	_g_free0 (_data_->name);
	_data_->name = _tmp1_;
	_tmp2_ = g_strdup (screen_name);
	_g_free0 (_data_->screen_name);
	_data_->screen_name = _tmp2_;
	user_lists_widget_load_lists_co (_data_);
}

void
user_lists_widget_load_lists_finish (UserListsWidget* self,
                                     GAsyncResult* _res_)
{
	UserListsWidgetLoadListsData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static Block87Data*
block87_data_ref (Block87Data* _data87_)
{
	g_atomic_int_inc (&_data87_->_ref_count_);
	return _data87_;
}

static void
block87_data_unref (void * _userdata_)
{
	Block87Data* _data87_;
	_data87_ = (Block87Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data87_->_ref_count_)) {
		UserListsWidget* self;
		self = _data87_->self;
		_g_object_unref0 (_data87_->collect_obj);
		_g_object_unref0 (self);
		g_slice_free (Block87Data, _data87_);
	}
}

static void
__lambda107_ (Block87Data* _data87_)
{
	UserListsWidget* self;
	self = _data87_->self;
	user_lists_widget_load_lists_co (_data87_->_async_data_);
}

static void
___lambda107__collect_finished (Collect* _sender,
                                GError* _error_,
                                gpointer self)
{
	__lambda107_ (self);
}

static void
_vala_JsonNode_free (JsonNode* self)
{
	g_boxed_free (json_node_get_type (), self);
}

static void
__lambda108_ (Block87Data* _data87_,
              GObject* _,
              GAsyncResult* res)
{
	UserListsWidget* self;
	JsonNode* root = NULL;
	guint n_subscribed_list = 0U;
	JsonNode* _tmp5_;
	GtkListBox* _tmp6_;
	Collect* _tmp13_;
	GError* _inner_error0_ = NULL;
	self = _data87_->self;
	g_return_if_fail (res != NULL);
	root = NULL;
	{
		JsonNode* _tmp0_ = NULL;
		JsonNode* _tmp1_;
		JsonNode* _tmp2_;
		_tmp1_ = cb_utils_load_threaded_finish (res, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		__vala_JsonNode_free0 (root);
		root = _tmp2_;
		__vala_JsonNode_free0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("UserListsWidget.vala:115: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		__vala_JsonNode_free0 (root);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp5_ = root;
	_tmp6_ = self->priv->subscribed_list_box;
	n_subscribed_list = user_lists_widget_lists_received_cb (self, _tmp5_, _tmp6_);
	if (n_subscribed_list == ((guint) 0)) {
		GtkListBox* _tmp7_;
		GtkFrame* _tmp8_;
		GtkLabel* _tmp9_;
		_tmp7_ = self->priv->subscribed_list_box;
		gtk_widget_hide ((GtkWidget*) _tmp7_);
		_tmp8_ = self->priv->subscribed_list_frame;
		gtk_widget_hide ((GtkWidget*) _tmp8_);
		_tmp9_ = self->priv->subscribed_list_label;
		gtk_widget_hide ((GtkWidget*) _tmp9_);
	} else {
		GtkListBox* _tmp10_;
		GtkFrame* _tmp11_;
		GtkLabel* _tmp12_;
		_tmp10_ = self->priv->subscribed_list_box;
		gtk_widget_show ((GtkWidget*) _tmp10_);
		_tmp11_ = self->priv->subscribed_list_frame;
		gtk_widget_show ((GtkWidget*) _tmp11_);
		_tmp12_ = self->priv->subscribed_list_label;
		gtk_widget_show ((GtkWidget*) _tmp12_);
	}
	_tmp13_ = _data87_->collect_obj;
	collect_emit (_tmp13_, NULL);
	__vala_JsonNode_free0 (root);
}

static void
___lambda108__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	__lambda108_ (self, source_object, res);
	block87_data_unref (self);
}

static void
__lambda112_ (Block87Data* _data87_,
              GObject* _,
              GAsyncResult* res)
{
	UserListsWidget* self;
	JsonNode* root = NULL;
	guint n_user_list = 0U;
	JsonNode* _tmp5_;
	GtkListBox* _tmp6_;
	gboolean _tmp7_ = FALSE;
	Collect* _tmp18_;
	GError* _inner_error0_ = NULL;
	self = _data87_->self;
	g_return_if_fail (res != NULL);
	root = NULL;
	{
		JsonNode* _tmp0_ = NULL;
		JsonNode* _tmp1_;
		JsonNode* _tmp2_;
		_tmp1_ = cb_utils_load_threaded_finish (res, &_inner_error0_);
		_tmp0_ = _tmp1_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp2_ = _tmp0_;
		_tmp0_ = NULL;
		__vala_JsonNode_free0 (root);
		root = _tmp2_;
		__vala_JsonNode_free0 (_tmp0_);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp3_ = e;
		_tmp4_ = _tmp3_->message;
		g_warning ("UserListsWidget.vala:141: %s", _tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		__vala_JsonNode_free0 (root);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp5_ = root;
	_tmp6_ = self->priv->user_list_box;
	n_user_list = user_lists_widget_lists_received_cb (self, _tmp5_, _tmp6_);
	if (n_user_list == ((guint) 0)) {
		_tmp7_ = !self->priv->show_create_entry;
	} else {
		_tmp7_ = FALSE;
	}
	if (_tmp7_) {
		GtkLabel* _tmp8_;
		GtkListBox* _tmp9_;
		GtkFrame* _tmp10_;
		GtkFrame* _tmp11_;
		_tmp8_ = self->priv->user_list_label;
		gtk_widget_hide ((GtkWidget*) _tmp8_);
		_tmp9_ = self->priv->user_list_box;
		gtk_widget_hide ((GtkWidget*) _tmp9_);
		_tmp10_ = self->priv->user_list_frame;
		gtk_widget_hide ((GtkWidget*) _tmp10_);
		_tmp11_ = self->priv->user_list_frame;
		gtk_widget_set_margin_top ((GtkWidget*) _tmp11_, 0);
	} else {
		GtkLabel* _tmp12_;
		gint _tmp13_ = 0;
		GtkFrame* _tmp14_;
		GtkListBox* _tmp15_;
		GtkFrame* _tmp16_;
		GtkRevealer* _tmp17_;
		_tmp12_ = self->priv->user_list_label;
		gtk_widget_set_visible ((GtkWidget*) _tmp12_, !self->priv->show_create_entry);
		if (self->priv->show_create_entry) {
			_tmp13_ = 24;
		} else {
			_tmp13_ = 0;
		}
		_tmp14_ = self->priv->user_list_frame;
		gtk_widget_set_margin_top ((GtkWidget*) _tmp14_, _tmp13_);
		_tmp15_ = self->priv->user_list_box;
		gtk_widget_show ((GtkWidget*) _tmp15_);
		_tmp16_ = self->priv->user_list_frame;
		gtk_widget_show ((GtkWidget*) _tmp16_);
		_tmp17_ = self->priv->user_lists_revealer;
		gtk_revealer_set_reveal_child (_tmp17_, n_user_list > ((guint) 0));
	}
	_tmp18_ = _data87_->collect_obj;
	collect_emit (_tmp18_, NULL);
	__vala_JsonNode_free0 (root);
}

static void
___lambda112__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	__lambda112_ (self, source_object, res);
	block87_data_unref (self);
}

static gboolean
user_lists_widget_load_lists_co (UserListsWidgetLoadListsData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_data87_ = g_slice_new0 (Block87Data);
	_data_->_data87_->_ref_count_ = 1;
	_data_->_data87_->self = g_object_ref (_data_->self);
	_data_->_data87_->_async_data_ = _data_;
	if (_data_->user_id == ((gint64) 0)) {
		_data_->_tmp0_ = _data_->self->priv->_account;
		_data_->user_id = _data_->_tmp0_->id;
	}
	_data_->_tmp1_ = collect_new (2);
	_data_->_data87_->collect_obj = _data_->_tmp1_;
	_data_->_tmp2_ = _data_->_data87_->collect_obj;
	g_signal_connect_data (_data_->_tmp2_, "finished", (GCallback) ___lambda107__collect_finished, block87_data_ref (_data_->_data87_), (GClosureNotify) block87_data_unref, 0);
	_data_->_tmp3_ = _data_->self->priv->_account;
	_data_->_tmp4_ = _data_->_tmp3_->proxy;
	_data_->_tmp5_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp4_);
	_data_->call = _data_->_tmp5_;
	_data_->_tmp6_ = _data_->call;
	rest_proxy_call_set_function (_data_->_tmp6_, "1.1/lists/subscriptions.json");
	_data_->_tmp7_ = _data_->call;
	rest_proxy_call_set_method (_data_->_tmp7_, "GET");
	_data_->_tmp8_ = _data_->call;
	rest_proxy_call_add_param (_data_->_tmp8_, "count", "200");
	_data_->_tmp9_ = _data_->call;
	_data_->_tmp10_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->user_id);
	_data_->_tmp11_ = _data_->_tmp10_;
	rest_proxy_call_add_param (_data_->_tmp9_, "user_id", _data_->_tmp11_);
	_g_free0 (_data_->_tmp11_);
	_data_->_tmp12_ = _data_->call;
	cb_utils_load_threaded_async (_data_->_tmp12_, NULL, ___lambda108__gasync_ready_callback, block87_data_ref (_data_->_data87_));
	_data_->_tmp13_ = _data_->self->priv->_account;
	_data_->_tmp14_ = _data_->_tmp13_->proxy;
	_data_->_tmp15_ = rest_proxy_new_call ((RestProxy*) _data_->_tmp14_);
	_data_->user_call = _data_->_tmp15_;
	_data_->_tmp16_ = _data_->user_call;
	rest_proxy_call_set_function (_data_->_tmp16_, "1.1/lists/ownerships.json");
	_data_->_tmp17_ = _data_->user_call;
	rest_proxy_call_set_method (_data_->_tmp17_, "GET");
	_data_->_tmp18_ = _data_->user_call;
	_data_->_tmp19_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->user_id);
	_data_->_tmp20_ = _data_->_tmp19_;
	rest_proxy_call_add_param (_data_->_tmp18_, "user_id", _data_->_tmp20_);
	_g_free0 (_data_->_tmp20_);
	_data_->_tmp21_ = _data_->user_call;
	rest_proxy_call_add_param (_data_->_tmp21_, "count", "200");
	_data_->_tmp22_ = _data_->user_call;
	cb_utils_load_threaded_async (_data_->_tmp22_, NULL, ___lambda112__gasync_ready_callback, block87_data_ref (_data_->_data87_));
	_data_->_tmp24_ = _data_->self->priv->_account;
	if (_data_->user_id == _data_->_tmp24_->id) {
		_data_->_tmp25_ = g_strdup (_ ("Subscribed lists"));
		_g_free0 (_data_->_tmp23_);
		_data_->_tmp23_ = _data_->_tmp25_;
	} else {
		_data_->_tmp26_ = g_strdup_printf (_ ("%s subscribed lists"), _data_->name);
		_g_free0 (_data_->_tmp23_);
		_data_->_tmp23_ = _data_->_tmp26_;
	}
	_data_->_tmp27_ = g_strdup (_data_->_tmp23_);
	_data_->accessible_name = _data_->_tmp27_;
	_data_->_tmp28_ = _data_->self->priv->subscribed_list_box;
	_data_->_tmp29_ = gtk_widget_get_accessible ((GtkWidget*) _data_->_tmp28_);
	_data_->_tmp30_ = _data_->accessible_name;
	atk_object_set_name (_data_->_tmp29_, _data_->_tmp30_);
	_data_->_tmp32_ = _data_->self->priv->_account;
	if (_data_->user_id == _data_->_tmp32_->id) {
		_data_->_tmp33_ = g_strdup (_ ("Your lists"));
		_g_free0 (_data_->_tmp31_);
		_data_->_tmp31_ = _data_->_tmp33_;
	} else {
		_data_->_tmp34_ = g_strdup_printf (_ ("%s lists"), _data_->name);
		_g_free0 (_data_->_tmp31_);
		_data_->_tmp31_ = _data_->_tmp34_;
	}
	_data_->_tmp35_ = g_strdup (_data_->_tmp31_);
	_g_free0 (_data_->accessible_name);
	_data_->accessible_name = _data_->_tmp35_;
	_data_->_tmp36_ = _data_->self->priv->user_list_box;
	_data_->_tmp37_ = gtk_widget_get_accessible ((GtkWidget*) _data_->_tmp36_);
	_data_->_tmp38_ = _data_->accessible_name;
	atk_object_set_name (_data_->_tmp37_, _data_->_tmp38_);
	_data_->_state_ = 1;
	return FALSE;
	_state_1:
	;
	_g_free0 (_data_->_tmp31_);
	_g_free0 (_data_->accessible_name);
	_g_free0 (_data_->_tmp23_);
	_g_object_unref0 (_data_->user_call);
	_g_object_unref0 (_data_->call);
	block87_data_unref (_data_->_data87_);
	_data_->_data87_ = NULL;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static Block88Data*
block88_data_ref (Block88Data* _data88_)
{
	g_atomic_int_inc (&_data88_->_ref_count_);
	return _data88_;
}

static void
block88_data_unref (void * _userdata_)
{
	Block88Data* _data88_;
	_data88_ = (Block88Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data88_->_ref_count_)) {
		UserListsWidget* self;
		self = _data88_->self;
		_data88_->ids = (g_free (_data88_->ids), NULL);
		_g_object_unref0 (_data88_->list_box);
		_g_object_unref0 (self);
		g_slice_free (Block88Data, _data88_);
	}
}

static gpointer
_json_array_ref0 (gpointer self)
{
	return self ? json_array_ref (self) : NULL;
}

static gpointer
_json_object_ref0 (gpointer self)
{
	return self ? json_object_ref (self) : NULL;
}

static void
_vala_array_add4 (gint64* * array,
                  gint* length,
                  gint* size,
                  gint64 value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gint64, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
__lambda109_ (Block88Data* _data88_,
              JsonArray* array,
              guint index,
              JsonNode* node)
{
	UserListsWidget* self;
	JsonObject* obj = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	ListListEntry* entry = NULL;
	Account* _tmp2_;
	ListListEntry* _tmp3_;
	self = _data88_->self;
	g_return_if_fail (array != NULL);
	g_return_if_fail (node != NULL);
	_tmp0_ = json_node_get_object (node);
	_tmp1_ = _json_object_ref0 (_tmp0_);
	obj = _tmp1_;
	_vala_array_add4 (&_data88_->ids, &_data88_->ids_length1, &_data88_->_ids_size_, json_object_get_int_member (obj, "id"));
	_tmp2_ = self->priv->_account;
	_tmp3_ = list_list_entry_new_from_json_data (obj, _tmp2_);
	g_object_ref_sink (_tmp3_);
	entry = _tmp3_;
	user_lists_widget_add_list (self, entry, _data88_->list_box);
	_g_object_unref0 (entry);
	_json_object_unref0 (obj);
}

static void
___lambda109__json_array_foreach (JsonArray* array,
                                  guint index_,
                                  JsonNode* element_node,
                                  gpointer self)
{
	__lambda109_ (self, array, index_, element_node);
}

static gboolean
_vala_int64_array_contains (gint64 * stack,
                            gssize stack_length,
                            const gint64 needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

static guint
user_lists_widget_lists_received_cb (UserListsWidget* self,
                                     JsonNode* root,
                                     GtkListBox* list_box)
{
	Block88Data* _data88_;
	GtkListBox* _tmp0_;
	gint64* _tmp1_;
	JsonArray* arr = NULL;
	JsonObject* _tmp2_;
	JsonArray* _tmp3_;
	JsonArray* _tmp4_;
	JsonArray* _tmp5_;
	guint size_after = 0U;
	GList* _tmp6_;
	GList* _tmp7_;
	guint _tmp8_;
	guint list_count = 0U;
	JsonArray* _tmp9_;
	guint result = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	g_return_val_if_fail (list_box != NULL, 0U);
	_data88_ = g_slice_new0 (Block88Data);
	_data88_->_ref_count_ = 1;
	_data88_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (list_box);
	_g_object_unref0 (_data88_->list_box);
	_data88_->list_box = _tmp0_;
	if (root == NULL) {
		result = (guint) 0;
		block88_data_unref (_data88_);
		_data88_ = NULL;
		return result;
	}
	_tmp1_ = g_new0 (gint64, 0);
	_data88_->ids = _tmp1_;
	_data88_->ids_length1 = 0;
	_data88_->_ids_size_ = _data88_->ids_length1;
	_tmp2_ = json_node_get_object (root);
	_tmp3_ = json_object_get_array_member (_tmp2_, "lists");
	_tmp4_ = _json_array_ref0 (_tmp3_);
	arr = _tmp4_;
	_tmp5_ = arr;
	json_array_foreach_element (_tmp5_, ___lambda109__json_array_foreach, _data88_);
	_tmp6_ = gtk_container_get_children ((GtkContainer*) _data88_->list_box);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_list_length (_tmp7_);
	(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
	size_after = _tmp8_;
	_tmp9_ = arr;
	list_count = json_array_get_length (_tmp9_);
	if (size_after != list_count) {
		GList* _tmp10_;
		_tmp10_ = gtk_container_get_children ((GtkContainer*) _data88_->list_box);
		{
			GList* entry_collection = NULL;
			GList* entry_it = NULL;
			entry_collection = _tmp10_;
			for (entry_it = entry_collection; entry_it != NULL; entry_it = entry_it->next) {
				GtkWidget* entry = NULL;
				entry = (GtkWidget*) entry_it->data;
				{
					gint64 id = 0LL;
					GtkWidget* _tmp11_;
					gint64* _tmp12_;
					gint _tmp12__length1;
					_tmp11_ = entry;
					id = G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_LIST_LIST_ENTRY, ListListEntry)->id;
					_tmp12_ = _data88_->ids;
					_tmp12__length1 = _data88_->ids_length1;
					if (!_vala_int64_array_contains (_tmp12_, _tmp12__length1, id)) {
						user_lists_widget_remove_list (self, id);
					}
				}
			}
			(entry_collection == NULL) ? NULL : (entry_collection = (g_list_free (entry_collection), NULL));
		}
	}
	result = list_count;
	_json_array_unref0 (arr);
	block88_data_unref (_data88_);
	_data88_ = NULL;
	return result;
}

static Block89Data*
block89_data_ref (Block89Data* _data89_)
{
	g_atomic_int_inc (&_data89_->_ref_count_);
	return _data89_;
}

static void
block89_data_unref (void * _userdata_)
{
	Block89Data* _data89_;
	_data89_ = (Block89Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data89_->_ref_count_)) {
		UserListsWidget* self;
		self = _data89_->self;
		_g_object_unref0 (self);
		g_slice_free (Block89Data, _data89_);
	}
}

static void
__lambda110_ (Block89Data* _data89_,
              GtkWidget* w)
{
	UserListsWidget* self;
	self = _data89_->self;
	g_return_if_fail (w != NULL);
	if (!IS_LIST_LIST_ENTRY (w)) {
		return;
	}
	if (G_TYPE_CHECK_INSTANCE_CAST (w, TYPE_LIST_LIST_ENTRY, ListListEntry)->id == _data89_->list_id) {
		GtkListBox* _tmp0_;
		_tmp0_ = self->priv->user_list_box;
		gtk_container_remove ((GtkContainer*) _tmp0_, w);
		if ((_data89_->n_user_lists - 1) == ((guint) 0)) {
			GtkRevealer* _tmp1_;
			_tmp1_ = self->priv->user_lists_revealer;
			gtk_revealer_set_reveal_child (_tmp1_, FALSE);
		}
	}
}

static void
___lambda110__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
	__lambda110_ (self, widget);
}

static void
__lambda111_ (Block89Data* _data89_,
              GtkWidget* w)
{
	UserListsWidget* self;
	self = _data89_->self;
	g_return_if_fail (w != NULL);
	if (!IS_LIST_LIST_ENTRY (w)) {
		return;
	}
	if (G_TYPE_CHECK_INSTANCE_CAST (w, TYPE_LIST_LIST_ENTRY, ListListEntry)->id == _data89_->list_id) {
		GtkListBox* _tmp0_;
		_tmp0_ = self->priv->subscribed_list_box;
		gtk_container_remove ((GtkContainer*) _tmp0_, w);
	}
}

static void
___lambda111__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
	__lambda111_ (self, widget);
}

void
user_lists_widget_remove_list (UserListsWidget* self,
                               gint64 list_id)
{
	Block89Data* _data89_;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	guint _tmp3_;
	GtkListBox* _tmp4_;
	GtkListBox* _tmp5_;
	GtkListBox* _tmp6_;
	GList* _tmp7_;
	GList* _tmp8_;
	gboolean _tmp9_;
	g_return_if_fail (self != NULL);
	_data89_ = g_slice_new0 (Block89Data);
	_data89_->_ref_count_ = 1;
	_data89_->self = g_object_ref (self);
	_data89_->list_id = list_id;
	_tmp0_ = self->priv->user_list_box;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_list_length (_tmp2_);
	(_tmp2_ == NULL) ? NULL : (_tmp2_ = (g_list_free (_tmp2_), NULL));
	_data89_->n_user_lists = _tmp3_;
	_tmp4_ = self->priv->user_list_box;
	gtk_container_foreach ((GtkContainer*) _tmp4_, ___lambda110__gtk_callback, _data89_);
	_tmp5_ = self->priv->subscribed_list_box;
	gtk_container_foreach ((GtkContainer*) _tmp5_, ___lambda111__gtk_callback, _data89_);
	_tmp6_ = self->priv->subscribed_list_box;
	_tmp7_ = gtk_container_get_children ((GtkContainer*) _tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_list_length (_tmp8_) == ((guint) 0);
	(_tmp8_ == NULL) ? NULL : (_tmp8_ = (g_list_free (_tmp8_), NULL));
	if (_tmp9_) {
		GtkLabel* _tmp10_;
		GtkFrame* _tmp11_;
		_tmp10_ = self->priv->subscribed_list_label;
		gtk_widget_hide ((GtkWidget*) _tmp10_);
		_tmp11_ = self->priv->subscribed_list_frame;
		gtk_widget_hide ((GtkWidget*) _tmp11_);
	}
	block89_data_unref (_data89_);
	_data89_ = NULL;
}

void
user_lists_widget_add_list (UserListsWidget* self,
                            ListListEntry* entry,
                            GtkListBox* list_box)
{
	gboolean updated = FALSE;
	GList* user_lists = NULL;
	GList* _tmp2_;
	GList* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entry != NULL);
	if (list_box == NULL) {
		if (entry->user_list) {
			GtkListBox* _tmp0_;
			_tmp0_ = self->priv->user_list_box;
			list_box = _tmp0_;
		} else {
			GtkListBox* _tmp1_;
			_tmp1_ = self->priv->subscribed_list_box;
			list_box = _tmp1_;
		}
	}
	updated = FALSE;
	_tmp2_ = gtk_container_get_children ((GtkContainer*) list_box);
	user_lists = _tmp2_;
	_tmp3_ = user_lists;
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp3_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* _tmp4_;
			GtkWidget* w = NULL;
			_tmp4_ = _g_object_ref0 ((GtkWidget*) w_it->data);
			w = _tmp4_;
			{
				GtkWidget* _tmp5_;
				ListListEntry* list_entry = NULL;
				GtkWidget* _tmp6_;
				ListListEntry* _tmp7_;
				ListListEntry* _tmp8_;
				_tmp5_ = w;
				if (!IS_LIST_LIST_ENTRY (_tmp5_)) {
					_g_object_unref0 (w);
					continue;
				}
				_tmp6_ = w;
				_tmp7_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, TYPE_LIST_LIST_ENTRY, ListListEntry));
				list_entry = _tmp7_;
				_tmp8_ = list_entry;
				if (_tmp8_->id == entry->id) {
					ListListEntry* _tmp9_;
					_tmp9_ = list_entry;
					user_lists_widget_update_list_entry_from_entry (self, _tmp9_, entry);
					updated = TRUE;
					_g_object_unref0 (list_entry);
					_g_object_unref0 (w);
					break;
				}
				_g_object_unref0 (list_entry);
				_g_object_unref0 (w);
			}
		}
	}
	if (!updated) {
		gtk_container_add ((GtkContainer*) list_box, (GtkWidget*) entry);
	}
	if (entry->user_list) {
		GtkRevealer* _tmp10_;
		_tmp10_ = self->priv->user_lists_revealer;
		gtk_revealer_set_reveal_child (_tmp10_, TRUE);
	} else {
		GList* _tmp11_;
		GList* _tmp12_;
		gboolean _tmp13_;
		_tmp11_ = gtk_container_get_children ((GtkContainer*) list_box);
		_tmp12_ = _tmp11_;
		_tmp13_ = g_list_length (_tmp12_) > ((guint) 0);
		(_tmp12_ == NULL) ? NULL : (_tmp12_ = (g_list_free (_tmp12_), NULL));
		if (_tmp13_) {
			GtkListBox* _tmp14_;
			_tmp14_ = self->priv->user_list_box;
			if (list_box == _tmp14_) {
				GtkFrame* _tmp15_;
				GtkListBox* _tmp16_;
				GtkLabel* _tmp17_;
				_tmp15_ = self->priv->user_list_frame;
				gtk_widget_show ((GtkWidget*) _tmp15_);
				_tmp16_ = self->priv->user_list_box;
				gtk_widget_show ((GtkWidget*) _tmp16_);
				_tmp17_ = self->priv->user_list_label;
				gtk_widget_show ((GtkWidget*) _tmp17_);
			} else {
				GtkFrame* _tmp18_;
				GtkListBox* _tmp19_;
				GtkLabel* _tmp20_;
				_tmp18_ = self->priv->subscribed_list_frame;
				gtk_widget_show ((GtkWidget*) _tmp18_);
				_tmp19_ = self->priv->subscribed_list_box;
				gtk_widget_show ((GtkWidget*) _tmp19_);
				_tmp20_ = self->priv->subscribed_list_label;
				gtk_widget_show ((GtkWidget*) _tmp20_);
			}
		}
	}
	(user_lists == NULL) ? NULL : (user_lists = (g_list_free (user_lists), NULL));
}

static Block90Data*
block90_data_ref (Block90Data* _data90_)
{
	g_atomic_int_inc (&_data90_->_ref_count_);
	return _data90_;
}

static void
block90_data_unref (void * _userdata_)
{
	Block90Data* _data90_;
	_data90_ = (Block90Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data90_->_ref_count_)) {
		UserListsWidget* self;
		self = _data90_->self;
		_g_free0 (_data90_->title);
		_g_free0 (_data90_->name);
		_g_free0 (_data90_->description);
		_g_free0 (_data90_->mode);
		_g_object_unref0 (self);
		g_slice_free (Block90Data, _data90_);
	}
}

static void
__lambda113_ (Block90Data* _data90_,
              GtkWidget* w)
{
	UserListsWidget* self;
	ListListEntry* lle = NULL;
	ListListEntry* _tmp0_;
	ListListEntry* _tmp1_;
	self = _data90_->self;
	g_return_if_fail (w != NULL);
	if (!IS_LIST_LIST_ENTRY (w)) {
		return;
	}
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (w, TYPE_LIST_LIST_ENTRY, ListListEntry));
	lle = _tmp0_;
	_tmp1_ = lle;
	if (_tmp1_->id == _data90_->list_id) {
		ListListEntry* _tmp2_;
		_tmp2_ = lle;
		user_lists_widget_update_list_entry (self, _tmp2_, _data90_->title, _data90_->name, _data90_->description, _data90_->mode);
	}
	_g_object_unref0 (lle);
}

static void
___lambda113__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
	__lambda113_ (self, widget);
}

void
user_lists_widget_update_list (UserListsWidget* self,
                               gint64 list_id,
                               const gchar* title,
                               const gchar* name,
                               const gchar* description,
                               const gchar* mode)
{
	Block90Data* _data90_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GtkListBox* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (title != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (description != NULL);
	g_return_if_fail (mode != NULL);
	_data90_ = g_slice_new0 (Block90Data);
	_data90_->_ref_count_ = 1;
	_data90_->self = g_object_ref (self);
	_data90_->list_id = list_id;
	_tmp0_ = g_strdup (title);
	_g_free0 (_data90_->title);
	_data90_->title = _tmp0_;
	_tmp1_ = g_strdup (name);
	_g_free0 (_data90_->name);
	_data90_->name = _tmp1_;
	_tmp2_ = g_strdup (description);
	_g_free0 (_data90_->description);
	_data90_->description = _tmp2_;
	_tmp3_ = g_strdup (mode);
	_g_free0 (_data90_->mode);
	_data90_->mode = _tmp3_;
	_tmp4_ = self->priv->user_list_box;
	gtk_container_foreach ((GtkContainer*) _tmp4_, ___lambda113__gtk_callback, _data90_);
	block90_data_unref (_data90_);
	_data90_ = NULL;
}

static void
user_lists_widget_update_list_entry_from_entry (UserListsWidget* self,
                                                ListListEntry* list_entry,
                                                ListListEntry* src_entry)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (list_entry != NULL);
	g_return_if_fail (src_entry != NULL);
	_tmp0_ = list_list_entry_get_title (src_entry);
	_tmp1_ = _tmp0_;
	_tmp2_ = list_list_entry_get_name (src_entry);
	_tmp3_ = _tmp2_;
	_tmp4_ = list_list_entry_get_description (src_entry);
	_tmp5_ = _tmp4_;
	_tmp6_ = src_entry->mode;
	user_lists_widget_update_list_entry (self, list_entry, _tmp1_, _tmp3_, _tmp5_, _tmp6_);
}

static void
user_lists_widget_update_list_entry (UserListsWidget* self,
                                     ListListEntry* list_entry,
                                     const gchar* title,
                                     const gchar* name,
                                     const gchar* description,
                                     const gchar* mode)
{
	gchar* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (list_entry != NULL);
	g_return_if_fail (title != NULL);
	g_return_if_fail (name != NULL);
	g_return_if_fail (description != NULL);
	g_return_if_fail (mode != NULL);
	list_list_entry_set_title (list_entry, title);
	list_list_entry_set_name (list_entry, name);
	list_list_entry_set_description (list_entry, description);
	_tmp0_ = g_strdup (mode);
	_g_free0 (list_entry->mode);
	list_entry->mode = _tmp0_;
	gtk_widget_queue_draw ((GtkWidget*) list_entry);
}

void
user_lists_widget_update_member_count (UserListsWidget* self,
                                       gint64 list_id,
                                       gint increase)
{
	GList* lists = NULL;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->user_list_box;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	lists = _tmp1_;
	_tmp2_ = lists;
	{
		GList* list_collection = NULL;
		GList* list_it = NULL;
		list_collection = _tmp2_;
		for (list_it = list_collection; list_it != NULL; list_it = list_it->next) {
			GtkWidget* list = NULL;
			list = (GtkWidget*) list_it->data;
			{
				GtkWidget* _tmp3_;
				ListListEntry* lle = NULL;
				GtkWidget* _tmp4_;
				ListListEntry* _tmp5_;
				ListListEntry* _tmp6_;
				_tmp3_ = list;
				if (!IS_LIST_LIST_ENTRY (_tmp3_)) {
					continue;
				}
				_tmp4_ = list;
				_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, TYPE_LIST_LIST_ENTRY, ListListEntry));
				lle = _tmp5_;
				_tmp6_ = lle;
				if (_tmp6_->id == list_id) {
					ListListEntry* _tmp7_;
					ListListEntry* _tmp8_;
					_tmp7_ = lle;
					_tmp8_ = lle;
					_tmp8_->n_members = _tmp8_->n_members + increase;
					_g_object_unref0 (lle);
					break;
				}
				_g_object_unref0 (lle);
			}
		}
	}
	(lists == NULL) ? NULL : (lists = (g_list_free (lists), NULL));
}

TwitterList*
user_lists_widget_get_user_lists (UserListsWidget* self,
                                  gint* result_length1)
{
	GList* children = NULL;
	GtkListBox* _tmp0_;
	GList* _tmp1_;
	TwitterList* lists = NULL;
	GList* _tmp2_;
	TwitterList* _tmp3_;
	gint lists_length1;
	gint _lists_size_;
	gint i = 0;
	GList* _tmp4_;
	TwitterList* _tmp28_;
	gint _tmp28__length1;
	TwitterList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->user_list_box;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	children = _tmp1_;
	_tmp2_ = children;
	_tmp3_ = g_new0 (TwitterList, g_list_length (_tmp2_));
	lists = _tmp3_;
	lists_length1 = g_list_length (_tmp2_);
	_lists_size_ = lists_length1;
	i = 0;
	_tmp4_ = children;
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp4_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* _tmp5_;
			GtkWidget* w = NULL;
			_tmp5_ = _g_object_ref0 ((GtkWidget*) w_it->data);
			w = _tmp5_;
			{
				GtkWidget* _tmp6_;
				ListListEntry* lle = NULL;
				GtkWidget* _tmp7_;
				ListListEntry* _tmp8_;
				TwitterList* _tmp9_;
				gint _tmp9__length1;
				ListListEntry* _tmp10_;
				TwitterList* _tmp11_;
				gint _tmp11__length1;
				ListListEntry* _tmp12_;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				TwitterList* _tmp16_;
				gint _tmp16__length1;
				ListListEntry* _tmp17_;
				const gchar* _tmp18_;
				const gchar* _tmp19_;
				gchar* _tmp20_;
				TwitterList* _tmp21_;
				gint _tmp21__length1;
				ListListEntry* _tmp22_;
				const gchar* _tmp23_;
				gchar* _tmp24_;
				TwitterList* _tmp25_;
				gint _tmp25__length1;
				ListListEntry* _tmp26_;
				gint _tmp27_;
				_tmp6_ = w;
				_vala_assert (IS_LIST_LIST_ENTRY (_tmp6_), "w is ListListEntry");
				_tmp7_ = w;
				_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, TYPE_LIST_LIST_ENTRY, ListListEntry));
				lle = _tmp8_;
				_tmp9_ = lists;
				_tmp9__length1 = lists_length1;
				_tmp10_ = lle;
				_tmp9_[i].id = _tmp10_->id;
				_tmp11_ = lists;
				_tmp11__length1 = lists_length1;
				_tmp12_ = lle;
				_tmp13_ = list_list_entry_get_name (_tmp12_);
				_tmp14_ = _tmp13_;
				_tmp15_ = g_strdup (_tmp14_);
				_g_free0 (_tmp11_[i].name);
				_tmp11_[i].name = _tmp15_;
				_tmp16_ = lists;
				_tmp16__length1 = lists_length1;
				_tmp17_ = lle;
				_tmp18_ = list_list_entry_get_description (_tmp17_);
				_tmp19_ = _tmp18_;
				_tmp20_ = g_strdup (_tmp19_);
				_g_free0 (_tmp16_[i].description);
				_tmp16_[i].description = _tmp20_;
				_tmp21_ = lists;
				_tmp21__length1 = lists_length1;
				_tmp22_ = lle;
				_tmp23_ = _tmp22_->mode;
				_tmp24_ = g_strdup (_tmp23_);
				_g_free0 (_tmp21_[i].mode);
				_tmp21_[i].mode = _tmp24_;
				_tmp25_ = lists;
				_tmp25__length1 = lists_length1;
				_tmp26_ = lle;
				_tmp25_[i].n_members = (guint) _tmp26_->n_members;
				_tmp27_ = i;
				i = _tmp27_ + 1;
				_g_object_unref0 (lle);
				_g_object_unref0 (w);
			}
		}
	}
	_tmp28_ = lists;
	_tmp28__length1 = lists_length1;
	if (result_length1) {
		*result_length1 = _tmp28__length1;
	}
	result = _tmp28_;
	(children == NULL) ? NULL : (children = (g_list_free (children), NULL));
	return result;
}

static void
__lambda115_ (UserListsWidget* self,
              GtkWidget* w)
{
	GtkListBox* _tmp0_;
	g_return_if_fail (w != NULL);
	_tmp0_ = self->priv->user_list_box;
	gtk_container_remove ((GtkContainer*) _tmp0_, w);
}

static void
___lambda115__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
	__lambda115_ ((UserListsWidget*) self, widget);
}

static void
__lambda116_ (UserListsWidget* self,
              GtkWidget* w)
{
	GtkListBox* _tmp0_;
	g_return_if_fail (w != NULL);
	_tmp0_ = self->priv->subscribed_list_box;
	gtk_container_remove ((GtkContainer*) _tmp0_, w);
}

static void
___lambda116__gtk_callback (GtkWidget* widget,
                            gpointer self)
{
	__lambda116_ ((UserListsWidget*) self, widget);
}

void
user_lists_widget_clear_lists (UserListsWidget* self)
{
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->user_list_box;
	gtk_container_foreach ((GtkContainer*) _tmp0_, ___lambda115__gtk_callback, self);
	_tmp1_ = self->priv->subscribed_list_box;
	gtk_container_foreach ((GtkContainer*) _tmp1_, ___lambda116__gtk_callback, self);
}

static Block91Data*
block91_data_ref (Block91Data* _data91_)
{
	g_atomic_int_inc (&_data91_->_ref_count_);
	return _data91_;
}

static void
block91_data_unref (void * _userdata_)
{
	Block91Data* _data91_;
	_data91_ = (Block91Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data91_->_ref_count_)) {
		UserListsWidget* self;
		self = _data91_->self;
		_g_object_unref0 (_data91_->call);
		_g_object_unref0 (self);
		g_slice_free (Block91Data, _data91_);
	}
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	g_strstrip (_result_);
	result = _result_;
	return result;
}

static void
__lambda117_ (Block91Data* _data91_,
              GObject* o,
              GAsyncResult* res)
{
	UserListsWidget* self;
	JsonParser* parser = NULL;
	JsonParser* _tmp7_;
	JsonObject* root = NULL;
	JsonParser* _tmp13_;
	JsonNode* _tmp14_;
	JsonObject* _tmp15_;
	JsonObject* _tmp16_;
	ListListEntry* entry = NULL;
	JsonObject* _tmp17_;
	Account* _tmp18_;
	ListListEntry* _tmp19_;
	ListListEntry* _tmp20_;
	CbBundle* bundle = NULL;
	CbBundle* _tmp21_;
	CbBundle* _tmp22_;
	ListListEntry* _tmp23_;
	CbBundle* _tmp24_;
	ListListEntry* _tmp25_;
	const gchar* _tmp26_;
	const gchar* _tmp27_;
	CbBundle* _tmp28_;
	ListListEntry* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	CbBundle* _tmp32_;
	CbBundle* _tmp33_;
	ListListEntry* _tmp34_;
	const gchar* _tmp35_;
	const gchar* _tmp36_;
	CbBundle* _tmp37_;
	ListListEntry* _tmp38_;
	const gchar* _tmp39_;
	CbBundle* _tmp40_;
	ListListEntry* _tmp41_;
	CbBundle* _tmp42_;
	ListListEntry* _tmp43_;
	CbBundle* _tmp44_;
	ListListEntry* _tmp45_;
	CbBundle* _tmp46_;
	ListListEntry* _tmp47_;
	const gchar* _tmp48_;
	MainWindow* _tmp49_;
	MainWidget* _tmp50_;
	CbBundle* _tmp51_;
	NewListEntry* _tmp52_;
	GError* _inner_error0_ = NULL;
	self = _data91_->self;
	g_return_if_fail (res != NULL);
	{
		RestProxyCall* _tmp0_;
		_tmp0_ = _data91_->call;
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		RestProxyCall* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
		MainWindow* _tmp5_;
		NewListEntry* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = _data91_->call;
		_tmp2_ = e;
		_tmp3_ = tweet_utils_failed_request_to_error (_tmp1_, _tmp2_);
		_tmp4_ = _tmp3_;
		_tmp5_ = self->priv->_main_window;
		utils_show_error_dialog (_tmp4_, (GtkWindow*) _tmp5_, NULL, 0);
		_g_error_free0 (_tmp4_);
		_tmp6_ = self->priv->new_list_entry;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, TRUE);
		_g_error_free0 (e);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp7_ = json_parser_new ();
	parser = _tmp7_;
	{
		JsonParser* _tmp8_;
		RestProxyCall* _tmp9_;
		const gchar* _tmp10_;
		_tmp8_ = parser;
		_tmp9_ = _data91_->call;
		_tmp10_ = rest_proxy_call_get_payload (_tmp9_);
		json_parser_load_from_data (_tmp8_, _tmp10_, (gssize) -1, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch1_g_error;
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp11_ = e;
		_tmp12_ = _tmp11_->message;
		g_critical ("UserListsWidget.vala:354: %s", _tmp12_);
		_g_error_free0 (e);
		_g_object_unref0 (parser);
		return;
	}
	__finally1:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (parser);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp13_ = parser;
	_tmp14_ = json_parser_get_root (_tmp13_);
	_tmp15_ = json_node_get_object (_tmp14_);
	_tmp16_ = _json_object_ref0 (_tmp15_);
	root = _tmp16_;
	_tmp17_ = root;
	_tmp18_ = self->priv->_account;
	_tmp19_ = list_list_entry_new_from_json_data (_tmp17_, _tmp18_);
	g_object_ref_sink (_tmp19_);
	entry = _tmp19_;
	_tmp20_ = entry;
	user_lists_widget_add_list (self, _tmp20_, NULL);
	_tmp21_ = cb_bundle_new ();
	bundle = _tmp21_;
	_tmp22_ = bundle;
	_tmp23_ = entry;
	cb_bundle_put_int64 (_tmp22_, LIST_STATUSES_PAGE_KEY_LIST_ID, _tmp23_->id);
	_tmp24_ = bundle;
	_tmp25_ = entry;
	_tmp26_ = list_list_entry_get_title (_tmp25_);
	_tmp27_ = _tmp26_;
	cb_bundle_put_string (_tmp24_, LIST_STATUSES_PAGE_KEY_TITLE, _tmp27_);
	_tmp28_ = bundle;
	_tmp29_ = entry;
	_tmp30_ = list_list_entry_get_name (_tmp29_);
	_tmp31_ = _tmp30_;
	cb_bundle_put_string (_tmp28_, LIST_STATUSES_PAGE_KEY_NAME, _tmp31_);
	_tmp32_ = bundle;
	cb_bundle_put_bool (_tmp32_, LIST_STATUSES_PAGE_KEY_USER_LIST, TRUE);
	_tmp33_ = bundle;
	_tmp34_ = entry;
	_tmp35_ = list_list_entry_get_description (_tmp34_);
	_tmp36_ = _tmp35_;
	cb_bundle_put_string (_tmp33_, LIST_STATUSES_PAGE_KEY_DESCRIPTION, _tmp36_);
	_tmp37_ = bundle;
	_tmp38_ = entry;
	_tmp39_ = _tmp38_->creator_screen_name;
	cb_bundle_put_string (_tmp37_, LIST_STATUSES_PAGE_KEY_CREATOR, _tmp39_);
	_tmp40_ = bundle;
	_tmp41_ = entry;
	cb_bundle_put_int (_tmp40_, LIST_STATUSES_PAGE_KEY_N_SUBSCRIBERS, _tmp41_->n_subscribers);
	_tmp42_ = bundle;
	_tmp43_ = entry;
	cb_bundle_put_int (_tmp42_, LIST_STATUSES_PAGE_KEY_N_MEMBERS, _tmp43_->n_members);
	_tmp44_ = bundle;
	_tmp45_ = entry;
	cb_bundle_put_int64 (_tmp44_, LIST_STATUSES_PAGE_KEY_CREATED_AT, _tmp45_->created_at);
	_tmp46_ = bundle;
	_tmp47_ = entry;
	_tmp48_ = _tmp47_->mode;
	cb_bundle_put_string (_tmp46_, LIST_STATUSES_PAGE_KEY_MODE, _tmp48_);
	_tmp49_ = self->priv->_main_window;
	_tmp50_ = _tmp49_->main_widget;
	_tmp51_ = bundle;
	main_widget_switch_page (_tmp50_, (gint) PAGE_LIST_STATUSES, _tmp51_);
	_tmp52_ = self->priv->new_list_entry;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp52_, TRUE);
	_g_object_unref0 (bundle);
	_g_object_unref0 (entry);
	_json_object_unref0 (root);
	_g_object_unref0 (parser);
}

static void
___lambda117__gasync_ready_callback (GObject* source_object,
                                     GAsyncResult* res,
                                     gpointer self)
{
	__lambda117_ (self, source_object, res);
	block91_data_unref (self);
}

static void
user_lists_widget_new_list_create_activated_cb (UserListsWidget* self,
                                                const gchar* list_name)
{
	Block91Data* _data91_;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gboolean _tmp4_;
	NewListEntry* _tmp5_;
	Account* _tmp6_;
	OAuthProxy* _tmp7_;
	RestProxyCall* _tmp8_;
	RestProxyCall* _tmp9_;
	RestProxyCall* _tmp10_;
	RestProxyCall* _tmp11_;
	RestProxyCall* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (list_name != NULL);
	_data91_ = g_slice_new0 (Block91Data);
	_data91_->_ref_count_ = 1;
	_data91_->self = g_object_ref (self);
	_tmp0_ = string_strip (list_name);
	_tmp1_ = _tmp0_;
	_tmp2_ = strlen (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_ <= 0;
	_g_free0 (_tmp1_);
	if (_tmp4_) {
		block91_data_unref (_data91_);
		_data91_ = NULL;
		return;
	}
	_tmp5_ = self->priv->new_list_entry;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, FALSE);
	_tmp6_ = self->priv->_account;
	_tmp7_ = _tmp6_->proxy;
	_tmp8_ = rest_proxy_new_call ((RestProxy*) _tmp7_);
	_data91_->call = _tmp8_;
	_tmp9_ = _data91_->call;
	rest_proxy_call_set_function (_tmp9_, "1.1/lists/create.json");
	_tmp10_ = _data91_->call;
	rest_proxy_call_set_method (_tmp10_, "POST");
	_tmp11_ = _data91_->call;
	rest_proxy_call_add_param (_tmp11_, "name", list_name);
	_tmp12_ = _data91_->call;
	rest_proxy_call_invoke_async (_tmp12_, NULL, ___lambda117__gasync_ready_callback, block91_data_ref (_data91_));
	block91_data_unref (_data91_);
	_data91_ = NULL;
}

static void
_user_lists_widget_new_list_create_activated_cb_new_list_entry_create_activated (NewListEntry* _sender,
                                                                                 const gchar* list_name,
                                                                                 gpointer self)
{
	user_lists_widget_new_list_create_activated_cb ((UserListsWidget*) self, list_name);
}

void
user_lists_widget_unreveal (UserListsWidget* self)
{
	NewListEntry* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->new_list_entry;
	new_list_entry_unreveal (_tmp0_);
}

static gboolean
user_lists_widget_new_list_box_keynav_failed_cb (UserListsWidget* self,
                                                 GtkDirectionType direction)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (direction == GTK_DIR_DOWN) {
		GtkListBox* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
		_tmp0_ = self->priv->user_list_box;
		_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
		_tmp2_ = _tmp1_;
		if (_tmp2_) {
			GtkListBox* _tmp3_;
			_tmp3_ = self->priv->user_list_box;
			gtk_widget_child_focus ((GtkWidget*) _tmp3_, direction);
			result = GDK_EVENT_STOP;
			return result;
		} else {
			GtkListBox* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
			_tmp4_ = self->priv->subscribed_list_box;
			_tmp5_ = gtk_widget_get_visible ((GtkWidget*) _tmp4_);
			_tmp6_ = _tmp5_;
			if (_tmp6_) {
				GtkListBox* _tmp7_;
				_tmp7_ = self->priv->subscribed_list_box;
				gtk_widget_child_focus ((GtkWidget*) _tmp7_, direction);
				result = GDK_EVENT_STOP;
				return result;
			}
		}
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
_user_lists_widget_new_list_box_keynav_failed_cb_gtk_widget_keynav_failed (GtkWidget* _sender,
                                                                           GtkDirectionType direction,
                                                                           gpointer self)
{
	gboolean result;
	result = user_lists_widget_new_list_box_keynav_failed_cb ((UserListsWidget*) self, direction);
	return result;
}

static gboolean
user_lists_widget_user_list_box_keynav_failed_cb (UserListsWidget* self,
                                                  GtkDirectionType direction)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (direction == GTK_DIR_UP) {
		GtkListBox* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
		_tmp0_ = self->priv->new_list_box;
		_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
		_tmp2_ = _tmp1_;
		if (_tmp2_) {
			GtkListBox* _tmp3_;
			_tmp3_ = self->priv->new_list_box;
			gtk_widget_child_focus ((GtkWidget*) _tmp3_, direction);
			result = GDK_EVENT_STOP;
			return result;
		}
	} else {
		if (direction == GTK_DIR_DOWN) {
			GtkListBox* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
			_tmp4_ = self->priv->subscribed_list_box;
			_tmp5_ = gtk_widget_get_visible ((GtkWidget*) _tmp4_);
			_tmp6_ = _tmp5_;
			if (_tmp6_) {
				GtkListBox* _tmp7_;
				_tmp7_ = self->priv->subscribed_list_box;
				gtk_widget_child_focus ((GtkWidget*) _tmp7_, direction);
				result = GDK_EVENT_STOP;
				return result;
			}
		}
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
_user_lists_widget_user_list_box_keynav_failed_cb_gtk_widget_keynav_failed (GtkWidget* _sender,
                                                                            GtkDirectionType direction,
                                                                            gpointer self)
{
	gboolean result;
	result = user_lists_widget_user_list_box_keynav_failed_cb ((UserListsWidget*) self, direction);
	return result;
}

static gboolean
user_lists_widget_subscribed_list_box_keynav_failed_cb (UserListsWidget* self,
                                                        GtkDirectionType direction)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	if (direction == GTK_DIR_UP) {
		GtkListBox* _tmp0_;
		gboolean _tmp1_;
		gboolean _tmp2_;
		_tmp0_ = self->priv->user_list_box;
		_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
		_tmp2_ = _tmp1_;
		if (_tmp2_) {
			GtkListBox* _tmp3_;
			_tmp3_ = self->priv->user_list_box;
			gtk_widget_child_focus ((GtkWidget*) _tmp3_, direction);
			result = GDK_EVENT_STOP;
			return result;
		} else {
			GtkListBox* _tmp4_;
			gboolean _tmp5_;
			gboolean _tmp6_;
			_tmp4_ = self->priv->new_list_box;
			_tmp5_ = gtk_widget_get_visible ((GtkWidget*) _tmp4_);
			_tmp6_ = _tmp5_;
			if (_tmp6_) {
				GtkListBox* _tmp7_;
				_tmp7_ = self->priv->new_list_box;
				gtk_widget_child_focus ((GtkWidget*) _tmp7_, direction);
				result = GDK_EVENT_STOP;
				return result;
			}
		}
	}
	result = GDK_EVENT_PROPAGATE;
	return result;
}

static gboolean
_user_lists_widget_subscribed_list_box_keynav_failed_cb_gtk_widget_keynav_failed (GtkWidget* _sender,
                                                                                  GtkDirectionType direction,
                                                                                  gpointer self)
{
	gboolean result;
	result = user_lists_widget_subscribed_list_box_keynav_failed_cb ((UserListsWidget*) self, direction);
	return result;
}

static void
user_lists_widget_revealer_child_revealed_cb (UserListsWidget* self,
                                              GObject* source,
                                              GParamSpec* spec)
{
	GtkRevealer* revealer = NULL;
	GtkRevealer* _tmp0_;
	GtkRevealer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source != NULL);
	g_return_if_fail (spec != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (source, gtk_revealer_get_type (), GtkRevealer));
	revealer = _tmp0_;
	_tmp1_ = revealer;
	_tmp2_ = gtk_revealer_get_child_revealed (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		GtkRevealer* _tmp4_;
		_tmp4_ = revealer;
		gtk_widget_show ((GtkWidget*) _tmp4_);
	} else {
		GtkRevealer* _tmp5_;
		_tmp5_ = revealer;
		gtk_widget_hide ((GtkWidget*) _tmp5_);
	}
	_g_object_unref0 (revealer);
}

static void
_user_lists_widget_revealer_child_revealed_cb_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self)
{
	user_lists_widget_revealer_child_revealed_cb ((UserListsWidget*) self, _sender, pspec);
}

MainWindow*
user_lists_widget_get_main_window (UserListsWidget* self)
{
	MainWindow* result;
	MainWindow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_main_window;
	result = _tmp0_;
	return result;
}

void
user_lists_widget_set_main_window (UserListsWidget* self,
                                   MainWindow* value)
{
	MainWindow* old_value;
	g_return_if_fail (self != NULL);
	old_value = user_lists_widget_get_main_window (self);
	if (old_value != value) {
		self->priv->_main_window = value;
		g_object_notify_by_pspec ((GObject *) self, user_lists_widget_properties[USER_LISTS_WIDGET_MAIN_WINDOW_PROPERTY]);
	}
}

Account*
user_lists_widget_get_account (UserListsWidget* self)
{
	Account* result;
	Account* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_account;
	result = _tmp0_;
	return result;
}

void
user_lists_widget_set_account (UserListsWidget* self,
                               Account* value)
{
	Account* old_value;
	g_return_if_fail (self != NULL);
	old_value = user_lists_widget_get_account (self);
	if (old_value != value) {
		self->priv->_account = value;
		g_object_notify_by_pspec ((GObject *) self, user_lists_widget_properties[USER_LISTS_WIDGET_ACCOUNT_PROPERTY]);
	}
}

static void
_default_header_func_gtk_list_box_update_header_func (GtkListBoxRow* row,
                                                      GtkListBoxRow* before,
                                                      gpointer self)
{
	default_header_func (row, before);
}

static gint
_list_list_entry_sort_func_gtk_list_box_sort_func (GtkListBoxRow* row1,
                                                   GtkListBoxRow* row2,
                                                   gpointer self)
{
	gint result;
	result = list_list_entry_sort_func (row1, row2);
	return result;
}

static GObject *
user_lists_widget_constructor (GType type,
                               guint n_construct_properties,
                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	UserListsWidget * self;
	GtkListBox* _tmp0_;
	GtkListBox* _tmp1_;
	GtkListBox* _tmp2_;
	GtkListBox* _tmp3_;
	parent_class = G_OBJECT_CLASS (user_lists_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_LISTS_WIDGET, UserListsWidget);
	_tmp0_ = self->priv->user_list_box;
	gtk_list_box_set_header_func (_tmp0_, _default_header_func_gtk_list_box_update_header_func, NULL, NULL);
	_tmp1_ = self->priv->user_list_box;
	gtk_list_box_set_sort_func (_tmp1_, _list_list_entry_sort_func_gtk_list_box_sort_func, NULL, NULL);
	_tmp2_ = self->priv->subscribed_list_box;
	gtk_list_box_set_header_func (_tmp2_, _default_header_func_gtk_list_box_update_header_func, NULL, NULL);
	_tmp3_ = self->priv->subscribed_list_box;
	gtk_list_box_set_sort_func (_tmp3_, _list_list_entry_sort_func_gtk_list_box_sort_func, NULL, NULL);
	return obj;
}

static void
user_lists_widget_class_init (UserListsWidgetClass * klass,
                              gpointer klass_data)
{
	user_lists_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &UserListsWidget_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_user_lists_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_user_lists_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = user_lists_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = user_lists_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LISTS_WIDGET_MAIN_WINDOW_PROPERTY, user_lists_widget_properties[USER_LISTS_WIDGET_MAIN_WINDOW_PROPERTY] = g_param_spec_object ("main-window", "main-window", "main-window", TYPE_MAIN_WINDOW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_LISTS_WIDGET_ACCOUNT_PROPERTY, user_lists_widget_properties[USER_LISTS_WIDGET_ACCOUNT_PROPERTY] = g_param_spec_object ("account", "account", "account", TYPE_ACCOUNT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/uk/co/ibboard/cawbird/ui/user-lists-widget.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "user_list_label", FALSE, UserListsWidget_private_offset + G_STRUCT_OFFSET (UserListsWidgetPrivate, user_list_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "user_list_box", FALSE, UserListsWidget_private_offset + G_STRUCT_OFFSET (UserListsWidgetPrivate, user_list_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "user_list_frame", FALSE, UserListsWidget_private_offset + G_STRUCT_OFFSET (UserListsWidgetPrivate, user_list_frame));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "subscribed_list_label", FALSE, UserListsWidget_private_offset + G_STRUCT_OFFSET (UserListsWidgetPrivate, subscribed_list_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "subscribed_list_box", FALSE, UserListsWidget_private_offset + G_STRUCT_OFFSET (UserListsWidgetPrivate, subscribed_list_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "subscribed_list_frame", FALSE, UserListsWidget_private_offset + G_STRUCT_OFFSET (UserListsWidgetPrivate, subscribed_list_frame));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "new_list_entry", FALSE, UserListsWidget_private_offset + G_STRUCT_OFFSET (UserListsWidgetPrivate, new_list_entry));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "user_lists_revealer", FALSE, UserListsWidget_private_offset + G_STRUCT_OFFSET (UserListsWidgetPrivate, user_lists_revealer));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "upper_separator", FALSE, UserListsWidget_private_offset + G_STRUCT_OFFSET (UserListsWidgetPrivate, upper_separator));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "new_list_box", FALSE, UserListsWidget_private_offset + G_STRUCT_OFFSET (UserListsWidgetPrivate, new_list_box));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "row_activated", G_CALLBACK(_user_lists_widget_row_activated_gtk_list_box_row_activated));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "new_list_create_activated_cb", G_CALLBACK(_user_lists_widget_new_list_create_activated_cb_new_list_entry_create_activated));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "new_list_box_keynav_failed_cb", G_CALLBACK(_user_lists_widget_new_list_box_keynav_failed_cb_gtk_widget_keynav_failed));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "user_list_box_keynav_failed_cb", G_CALLBACK(_user_lists_widget_user_list_box_keynav_failed_cb_gtk_widget_keynav_failed));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "subscribed_list_box_keynav_failed_cb", G_CALLBACK(_user_lists_widget_subscribed_list_box_keynav_failed_cb_gtk_widget_keynav_failed));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "revealer_child_revealed_cb", G_CALLBACK(_user_lists_widget_revealer_child_revealed_cb_g_object_notify));
}

static void
user_lists_widget_instance_init (UserListsWidget * self,
                                 gpointer klass)
{
	self->priv = user_lists_widget_get_instance_private (self);
	self->priv->show_create_entry = TRUE;
	g_type_ensure (TYPE_NEW_LIST_ENTRY);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
user_lists_widget_finalize (GObject * obj)
{
	UserListsWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_LISTS_WIDGET, UserListsWidget);
	G_OBJECT_CLASS (user_lists_widget_parent_class)->finalize (obj);
}

static GType
user_lists_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (UserListsWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_lists_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserListsWidget), 0, (GInstanceInitFunc) user_lists_widget_instance_init, NULL };
	GType user_lists_widget_type_id;
	user_lists_widget_type_id = g_type_register_static (gtk_box_get_type (), "UserListsWidget", &g_define_type_info, 0);
	UserListsWidget_private_offset = g_type_add_instance_private (user_lists_widget_type_id, sizeof (UserListsWidgetPrivate));
	return user_lists_widget_type_id;
}

GType
user_lists_widget_get_type (void)
{
	static volatile gsize user_lists_widget_type_id__volatile = 0;
	if (g_once_init_enter (&user_lists_widget_type_id__volatile)) {
		GType user_lists_widget_type_id;
		user_lists_widget_type_id = user_lists_widget_get_type_once ();
		g_once_init_leave (&user_lists_widget_type_id__volatile, user_lists_widget_type_id);
	}
	return user_lists_widget_type_id__volatile;
}

static void
_vala_user_lists_widget_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec)
{
	UserListsWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_LISTS_WIDGET, UserListsWidget);
	switch (property_id) {
		case USER_LISTS_WIDGET_MAIN_WINDOW_PROPERTY:
		g_value_set_object (value, user_lists_widget_get_main_window (self));
		break;
		case USER_LISTS_WIDGET_ACCOUNT_PROPERTY:
		g_value_set_object (value, user_lists_widget_get_account (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_user_lists_widget_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec)
{
	UserListsWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_LISTS_WIDGET, UserListsWidget);
	switch (property_id) {
		case USER_LISTS_WIDGET_MAIN_WINDOW_PROPERTY:
		user_lists_widget_set_main_window (self, g_value_get_object (value));
		break;
		case USER_LISTS_WIDGET_ACCOUNT_PROPERTY:
		user_lists_widget_set_account (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

