/* AccountDialog.c generated by valac 0.54.3, the Vala compiler
 * generated from AccountDialog.vala, do not modify */

/*  This file is part of Cawbird, a Gtk+ linux Twitter client forked from Corebird.
 *  Copyright (C) 2013 Timm Bäder (Corebird)
 *
 *  Cawbird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Cawbird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with cawbird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "cawbird.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gio/gio.h>
#include <rest/oauth-proxy.h>
#include <gdk/gdk.h>
#include <rest/rest-proxy-call.h>
#include <rest/rest-proxy.h>
#include <cairo-gobject.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define TYPE_COMPLETION_TEXT_VIEW (completion_text_view_get_type ())
#define COMPLETION_TEXT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETION_TEXT_VIEW, CompletionTextView))
#define COMPLETION_TEXT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETION_TEXT_VIEW, CompletionTextViewClass))
#define IS_COMPLETION_TEXT_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETION_TEXT_VIEW))
#define IS_COMPLETION_TEXT_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETION_TEXT_VIEW))
#define COMPLETION_TEXT_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETION_TEXT_VIEW, CompletionTextViewClass))

typedef struct _CompletionTextView CompletionTextView;
typedef struct _CompletionTextViewClass CompletionTextViewClass;

#define TYPE_CROP_WIDGET (crop_widget_get_type ())
#define CROP_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CROP_WIDGET, CropWidget))
#define CROP_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CROP_WIDGET, CropWidgetClass))
#define IS_CROP_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CROP_WIDGET))
#define IS_CROP_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CROP_WIDGET))
#define CROP_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CROP_WIDGET, CropWidgetClass))

typedef struct _CropWidget CropWidget;
typedef struct _CropWidgetClass CropWidgetClass;
enum  {
	ACCOUNT_DIALOG_0_PROPERTY,
	ACCOUNT_DIALOG_NUM_PROPERTIES
};
static GParamSpec* account_dialog_properties[ACCOUNT_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block92Data Block92Data;
typedef struct _Block93Data Block93Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block94Data Block94Data;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
typedef struct _Block95Data Block95Data;

struct _AccountDialogPrivate {
	GtkEntry* name_entry;
	AvatarBannerWidget* avatar_banner_widget;
	GtkStack* delete_stack;
	GtkSwitch* autostart_switch;
	GtkEntry* website_entry;
	CompletionTextView* description_text_view;
	CropWidget* crop_widget;
	GtkStack* content_stack;
	GtkBox* info_box;
	GtkLabel* error_label;
	GtkButton* save_button;
	GtkLabel* description_length_label;
	Account* account;
	gchar* old_user_name;
	gchar* old_description;
	gchar* old_website;
	GdkPixbuf* new_avatar;
	GdkPixbuf* new_banner;
	gint old_width;
	gint old_height;
	gboolean account_was_not_initied;
};

struct _Block92Data {
	int _ref_count_;
	AccountDialog* self;
	Account* account;
};

struct _Block93Data {
	int _ref_count_;
	AccountDialog* self;
	RestProxyCall* call;
};

struct _Block94Data {
	int _ref_count_;
	AccountDialog* self;
	RestProxyCall* call;
};

struct _Block95Data {
	int _ref_count_;
	AccountDialog* self;
	RestProxyCall* call;
};

static gint AccountDialog_private_offset;
static gpointer account_dialog_parent_class = NULL;

VALA_EXTERN GType completion_text_view_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType crop_widget_get_type (void) G_GNUC_CONST ;
#define ACCOUNT_DIALOG_MAX_DESCRIPTION_LENGTH 160
#define ACCOUNT_DIALOG_PAGE_NORMAL "normal"
#define ACCOUNT_DIALOG_PAGE_DELETE "delete"
static Block92Data* block92_data_ref (Block92Data* _data92_);
static void block92_data_unref (void * _userdata_);
VALA_EXTERN void completion_text_view_set_account (CompletionTextView* self,
                                       Account* account);
static void account_dialog_set_transient_data (AccountDialog* self,
                                        const gchar* website,
                                        const gchar* description);
static void __lambda175_ (AccountDialog* self,
                   GdkPixbuf* p);
static void ___lambda175__avatar_banner_widget_avatar_changed (AvatarBannerWidget* _sender,
                                                        GdkPixbuf* new_avatar,
                                                        gpointer self);
static void __lambda176_ (AccountDialog* self,
                   GdkPixbuf* b);
static void ___lambda176__avatar_banner_widget_banner_changed (AvatarBannerWidget* _sender,
                                                        GdkPixbuf* new_banner,
                                                        gpointer self);
static void ___lambda177_ (Block92Data* _data92_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda177__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static gboolean account_dialog_escape_pressed_cb (AccountDialog* self);
static gboolean _account_dialog_escape_pressed_cb_gtk_accel_group_activate (GtkAccelGroup* accel_group,
                                                                     GObject* acceleratable,
                                                                     guint keyval,
                                                                     GdkModifierType modifier,
                                                                     gpointer self);
static void account_dialog_update_description_length (AccountDialog* self);
static void _account_dialog_update_description_length_g_object_notify (GObject* _sender,
                                                                GParamSpec* pspec,
                                                                gpointer self);
static void account_dialog_real_destroy (GtkWidget* base);
static void account_dialog_delete_button_clicked_cb (AccountDialog* self);
static void _account_dialog_delete_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static void account_dialog_save_data (AccountDialog* self);
static Block93Data* block93_data_ref (Block93Data* _data93_);
static void block93_data_unref (void * _userdata_);
static void ___lambda178_ (Block93Data* _data93_,
                    GObject* obj,
                    GAsyncResult* res);
VALA_EXTERN void utils_show_error_dialog (GError* e,
                              GtkWindow* transient_for,
                              const gchar* file,
                              gint line);
static void ____lambda178__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block94Data* block94_data_ref (Block94Data* _data94_);
static void block94_data_unref (void * _userdata_);
static void ___lambda179_ (Block94Data* _data94_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda179__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static Block95Data* block95_data_ref (Block95Data* _data95_);
static void block95_data_unref (void * _userdata_);
static void ___lambda180_ (Block95Data* _data95_,
                    GObject* obj,
                    GAsyncResult* res);
static void ____lambda180__gasync_ready_callback (GObject* source_object,
                                           GAsyncResult* res,
                                           gpointer self);
static void account_dialog_delete_confirm_button_clicked_cb (AccountDialog* self);
static void _account_dialog_delete_confirm_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                          gpointer self);
static void account_dialog_delete_cancel_button_clicked_cb (AccountDialog* self);
static void _account_dialog_delete_cancel_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                         gpointer self);
static void account_dialog_autostart_switch_activate_cb (AccountDialog* self);
static void _account_dialog_autostart_switch_activate_cb_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void account_dialog_show_crop_image_selector (AccountDialog* self);
VALA_EXTERN gdouble crop_widget_get_desired_aspect_ratio (CropWidget* self);
VALA_EXTERN void crop_widget_set_image (CropWidget* self,
                            GdkPixbuf* image);
static void account_dialog_avatar_clicked_cb (AccountDialog* self);
VALA_EXTERN void crop_widget_set_desired_aspect_ratio (CropWidget* self,
                                           gdouble value);
VALA_EXTERN void crop_widget_set_min_size (CropWidget* self,
                               gint min_width);
static void _account_dialog_avatar_clicked_cb_avatar_banner_widget_avatar_clicked (AvatarBannerWidget* _sender,
                                                                            gpointer self);
static void account_dialog_banner_clicked_cb (AccountDialog* self);
static void _account_dialog_banner_clicked_cb_avatar_banner_widget_banner_clicked (AvatarBannerWidget* _sender,
                                                                            gpointer self);
static void account_dialog_cancel_button_clicked_cb (AccountDialog* self);
static void _account_dialog_cancel_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                  gpointer self);
static void account_dialog_save_button_clicked_cb (AccountDialog* self);
VALA_EXTERN GdkPixbuf* crop_widget_get_cropped_image (CropWidget* self);
static void _account_dialog_save_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                gpointer self);
static void account_dialog_finalize (GObject * obj);
static GType account_dialog_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
account_dialog_get_instance_private (AccountDialog* self)
{
	return G_STRUCT_MEMBER_P (self, AccountDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block92Data*
block92_data_ref (Block92Data* _data92_)
{
	g_atomic_int_inc (&_data92_->_ref_count_);
	return _data92_;
}

static void
block92_data_unref (void * _userdata_)
{
	Block92Data* _data92_;
	_data92_ = (Block92Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data92_->_ref_count_)) {
		AccountDialog* self;
		self = _data92_->self;
		_g_object_unref0 (_data92_->account);
		_g_object_unref0 (self);
		g_slice_free (Block92Data, _data92_);
	}
}

static void
__lambda175_ (AccountDialog* self,
              GdkPixbuf* p)
{
	GdkPixbuf* _tmp0_;
	g_return_if_fail (p != NULL);
	_tmp0_ = _g_object_ref0 (p);
	_g_object_unref0 (self->priv->new_avatar);
	self->priv->new_avatar = _tmp0_;
}

static void
___lambda175__avatar_banner_widget_avatar_changed (AvatarBannerWidget* _sender,
                                                   GdkPixbuf* new_avatar,
                                                   gpointer self)
{
	__lambda175_ ((AccountDialog*) self, new_avatar);
}

static void
__lambda176_ (AccountDialog* self,
              GdkPixbuf* b)
{
	GdkPixbuf* _tmp0_;
	g_return_if_fail (b != NULL);
	_tmp0_ = _g_object_ref0 (b);
	_g_object_unref0 (self->priv->new_banner);
	self->priv->new_banner = _tmp0_;
}

static void
___lambda176__avatar_banner_widget_banner_changed (AvatarBannerWidget* _sender,
                                                   GdkPixbuf* new_banner,
                                                   gpointer self)
{
	__lambda176_ ((AccountDialog*) self, new_banner);
}

static void
___lambda177_ (Block92Data* _data92_,
               GObject* obj,
               GAsyncResult* res)
{
	AccountDialog* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	self = _data92_->self;
	g_return_if_fail (res != NULL);
	_tmp0_ = _data92_->account->website;
	_tmp1_ = _data92_->account->description;
	account_dialog_set_transient_data (self, _tmp0_, _tmp1_);
}

static void
____lambda177__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
	___lambda177_ (self, source_object, res);
	block92_data_unref (self);
}

static gboolean
_account_dialog_escape_pressed_cb_gtk_accel_group_activate (GtkAccelGroup* accel_group,
                                                            GObject* acceleratable,
                                                            guint keyval,
                                                            GdkModifierType modifier,
                                                            gpointer self)
{
	gboolean result;
	result = account_dialog_escape_pressed_cb ((AccountDialog*) self);
	return result;
}

static void
_account_dialog_update_description_length_g_object_notify (GObject* _sender,
                                                           GParamSpec* pspec,
                                                           gpointer self)
{
	account_dialog_update_description_length ((AccountDialog*) self);
}

AccountDialog*
account_dialog_construct (GType object_type,
                          Account* account)
{
	AccountDialog * self = NULL;
	Block92Data* _data92_;
	Account* _tmp0_;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	AvatarBannerWidget* _tmp3_;
	CompletionTextView* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkSwitch* _tmp7_;
	gchar** startup_accounts = NULL;
	GSettings* _tmp8_;
	GSettings* _tmp9_;
	gchar** _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gint startup_accounts_length1;
	gint _startup_accounts_size_;
	gchar** _tmp13_;
	gint _tmp13__length1;
	GtkSwitch* _tmp18_;
	AvatarBannerWidget* _tmp19_;
	AvatarBannerWidget* _tmp20_;
	OAuthProxy* _tmp21_;
	GtkAccelGroup* ag = NULL;
	GtkAccelGroup* _tmp22_;
	CompletionTextView* _tmp23_;
	GtkTextBuffer* _tmp24_;
	GtkTextBuffer* _tmp25_;
	g_return_val_if_fail (account != NULL, NULL);
	_data92_ = g_slice_new0 (Block92Data);
	_data92_->_ref_count_ = 1;
	_tmp0_ = _g_object_ref0 (account);
	_g_object_unref0 (_data92_->account);
	_data92_->account = _tmp0_;
	self = (AccountDialog*) g_object_new (object_type, NULL);
	_data92_->self = g_object_ref (self);
	self->priv->account = _data92_->account;
	_tmp1_ = self->priv->name_entry;
	_tmp2_ = _data92_->account->name;
	gtk_entry_set_text (_tmp1_, _tmp2_);
	_tmp3_ = self->priv->avatar_banner_widget;
	avatar_banner_widget_set_account (_tmp3_, _data92_->account);
	_tmp4_ = self->priv->description_text_view;
	completion_text_view_set_account (_tmp4_, _data92_->account);
	_tmp5_ = _data92_->account->website;
	_tmp6_ = _data92_->account->description;
	account_dialog_set_transient_data (self, _tmp5_, _tmp6_);
	_tmp7_ = self->priv->autostart_switch;
	g_object_freeze_notify ((GObject*) _tmp7_);
	_tmp8_ = settings_get ();
	_tmp9_ = _tmp8_;
	_tmp11_ = _tmp10_ = g_settings_get_strv (_tmp9_, "startup-accounts");
	_tmp12_ = _tmp11_;
	_tmp12__length1 = _vala_array_length (_tmp10_);
	_g_object_unref0 (_tmp9_);
	startup_accounts = _tmp12_;
	startup_accounts_length1 = _tmp12__length1;
	_startup_accounts_size_ = startup_accounts_length1;
	_tmp13_ = startup_accounts;
	_tmp13__length1 = startup_accounts_length1;
	{
		gchar** acc_collection = NULL;
		gint acc_collection_length1 = 0;
		gint _acc_collection_size_ = 0;
		gint acc_it = 0;
		acc_collection = _tmp13_;
		acc_collection_length1 = _tmp13__length1;
		for (acc_it = 0; acc_it < acc_collection_length1; acc_it = acc_it + 1) {
			const gchar* acc = NULL;
			acc = acc_collection[acc_it];
			{
				const gchar* _tmp14_;
				Account* _tmp15_;
				const gchar* _tmp16_;
				_tmp14_ = acc;
				_tmp15_ = self->priv->account;
				_tmp16_ = _tmp15_->screen_name;
				if (g_strcmp0 (_tmp14_, _tmp16_) == 0) {
					GtkSwitch* _tmp17_;
					_tmp17_ = self->priv->autostart_switch;
					gtk_switch_set_active (_tmp17_, TRUE);
					break;
				}
			}
		}
	}
	_tmp18_ = self->priv->autostart_switch;
	g_object_thaw_notify ((GObject*) _tmp18_);
	_tmp19_ = self->priv->avatar_banner_widget;
	g_signal_connect_object (_tmp19_, "avatar-changed", (GCallback) ___lambda175__avatar_banner_widget_avatar_changed, self, 0);
	_tmp20_ = self->priv->avatar_banner_widget;
	g_signal_connect_object (_tmp20_, "banner-changed", (GCallback) ___lambda176__avatar_banner_widget_banner_changed, self, 0);
	_tmp21_ = _data92_->account->proxy;
	if (_tmp21_ == NULL) {
		self->priv->account_was_not_initied = TRUE;
		account_init_proxy (_data92_->account);
		account_query_user_info (_data92_->account, ____lambda177__gasync_ready_callback, block92_data_ref (_data92_));
	}
	_tmp22_ = gtk_accel_group_new ();
	ag = _tmp22_;
	gtk_accel_group_connect (ag, GDK_KEY_Escape, 0, GTK_ACCEL_LOCKED, (GClosure*) ((_account_dialog_escape_pressed_cb_gtk_accel_group_activate == NULL) ? NULL : g_cclosure_new ((GCallback) _account_dialog_escape_pressed_cb_gtk_accel_group_activate, g_object_ref (self), (GClosureNotify) g_object_unref)));
	_tmp23_ = self->priv->description_text_view;
	_tmp24_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp23_);
	_tmp25_ = _tmp24_;
	g_signal_connect_object ((GObject*) _tmp25_, "notify::text", (GCallback) _account_dialog_update_description_length_g_object_notify, self, 0);
	gtk_window_add_accel_group ((GtkWindow*) self, ag);
	account_dialog_update_description_length (self);
	_g_object_unref0 (ag);
	startup_accounts = (_vala_array_free (startup_accounts, startup_accounts_length1, (GDestroyNotify) g_free), NULL);
	block92_data_unref (_data92_);
	_data92_ = NULL;
	return self;
}

AccountDialog*
account_dialog_new (Account* account)
{
	return account_dialog_construct (TYPE_ACCOUNT_DIALOG, account);
}

static void
account_dialog_update_description_length (AccountDialog* self)
{
	gint length = 0;
	CompletionTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	GtkLabel* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->description_text_view;
	_tmp1_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp0_);
	_tmp2_ = _tmp1_;
	g_object_get (_tmp2_, "text", &_tmp3_, NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = _tmp4_;
	_tmp6_ = strlen (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _tmp7_;
	_g_free0 (_tmp5_);
	length = _tmp8_;
	_tmp9_ = self->priv->description_length_label;
	_tmp10_ = g_strdup_printf ("%d/160", length);
	_tmp11_ = _tmp10_;
	gtk_label_set_label (_tmp9_, _tmp11_);
	_g_free0 (_tmp11_);
	if (length > ACCOUNT_DIALOG_MAX_DESCRIPTION_LENGTH) {
		GtkButton* _tmp12_;
		_tmp12_ = self->priv->save_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, FALSE);
	} else {
		GtkButton* _tmp13_;
		_tmp13_ = self->priv->save_button;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, TRUE);
	}
}

static void
account_dialog_real_destroy (GtkWidget* base)
{
	AccountDialog * self;
	Account* _tmp0_;
	self = (AccountDialog*) base;
	_tmp0_ = self->priv->account;
	if (_tmp0_ != NULL) {
		if (self->priv->account_was_not_initied) {
			Account* _tmp1_;
			_tmp1_ = self->priv->account;
			account_uninit (_tmp1_);
		}
		self->priv->account = NULL;
	}
	GTK_WIDGET_CLASS (account_dialog_parent_class)->destroy ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
}

static gboolean
account_dialog_escape_pressed_cb (AccountDialog* self)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	gtk_widget_destroy ((GtkWidget*) self);
	result = GDK_EVENT_STOP;
	return result;
}

static void
account_dialog_set_transient_data (AccountDialog* self,
                                   const gchar* website,
                                   const gchar* description)
{
	const gchar* _tmp0_ = NULL;
	Account* _tmp1_;
	const gchar* _tmp2_;
	GtkEntry* _tmp3_;
	Account* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	Account* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_ = NULL;
	Account* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_ = NULL;
	Account* _tmp16_;
	const gchar* _tmp17_;
	CompletionTextView* _tmp18_;
	GtkTextBuffer* _tmp19_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->account;
	_tmp2_ = _tmp1_->website;
	_tmp0_ = _tmp2_;
	if (_tmp0_ == NULL) {
		_tmp0_ = "";
	}
	_tmp3_ = self->priv->website_entry;
	gtk_entry_set_text (_tmp3_, _tmp0_);
	_tmp4_ = self->priv->account;
	_tmp5_ = _tmp4_->name;
	_tmp6_ = g_strdup (_tmp5_);
	_g_free0 (self->priv->old_user_name);
	self->priv->old_user_name = _tmp6_;
	_tmp8_ = self->priv->account;
	_tmp9_ = _tmp8_->website;
	_tmp7_ = _tmp9_;
	if (_tmp7_ == NULL) {
		_tmp7_ = "";
	}
	_tmp10_ = g_strdup (_tmp7_);
	_g_free0 (self->priv->old_website);
	self->priv->old_website = _tmp10_;
	_tmp12_ = self->priv->account;
	_tmp13_ = _tmp12_->description;
	_tmp11_ = _tmp13_;
	if (_tmp11_ == NULL) {
		_tmp11_ = "";
	}
	_tmp14_ = g_strdup (_tmp11_);
	_g_free0 (self->priv->old_description);
	self->priv->old_description = _tmp14_;
	_tmp16_ = self->priv->account;
	_tmp17_ = _tmp16_->description;
	_tmp15_ = _tmp17_;
	if (_tmp15_ == NULL) {
		_tmp15_ = "";
	}
	_tmp18_ = self->priv->description_text_view;
	_tmp19_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp18_);
	gtk_text_buffer_set_text (_tmp19_, _tmp15_, -1);
}

static void
account_dialog_delete_button_clicked_cb (AccountDialog* self)
{
	GtkStack* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->delete_stack;
	gtk_stack_set_visible_child_name (_tmp0_, ACCOUNT_DIALOG_PAGE_DELETE);
}

static void
_account_dialog_delete_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
	account_dialog_delete_button_clicked_cb ((AccountDialog*) self);
}

static Block93Data*
block93_data_ref (Block93Data* _data93_)
{
	g_atomic_int_inc (&_data93_->_ref_count_);
	return _data93_;
}

static void
block93_data_unref (void * _userdata_)
{
	Block93Data* _data93_;
	_data93_ = (Block93Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data93_->_ref_count_)) {
		AccountDialog* self;
		self = _data93_->self;
		_g_object_unref0 (_data93_->call);
		_g_object_unref0 (self);
		g_slice_free (Block93Data, _data93_);
	}
}

static void
___lambda178_ (Block93Data* _data93_,
               GObject* obj,
               GAsyncResult* res)
{
	AccountDialog* self;
	GError* _inner_error0_ = NULL;
	self = _data93_->self;
	g_return_if_fail (res != NULL);
	{
		RestProxyCall* _tmp0_;
		_tmp0_ = _data93_->call;
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		g_debug ("AccountDialog.vala:167: Profile successfully updated");
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		RestProxyCall* _tmp3_;
		GError* _tmp4_;
		GError* _tmp5_;
		GError* _tmp6_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = e;
		_tmp2_ = _tmp1_->message;
		g_warning ("AccountDialog.vala:169: %s", _tmp2_);
		_tmp3_ = _data93_->call;
		_tmp4_ = e;
		_tmp5_ = tweet_utils_failed_request_to_error (_tmp3_, _tmp4_);
		_tmp6_ = _tmp5_;
		utils_show_error_dialog (_tmp6_, (GtkWindow*) self, NULL, 0);
		_g_error_free0 (_tmp6_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
____lambda178__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
	___lambda178_ (self, source_object, res);
	block93_data_unref (self);
}

static Block94Data*
block94_data_ref (Block94Data* _data94_)
{
	g_atomic_int_inc (&_data94_->_ref_count_);
	return _data94_;
}

static void
block94_data_unref (void * _userdata_)
{
	Block94Data* _data94_;
	_data94_ = (Block94Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data94_->_ref_count_)) {
		AccountDialog* self;
		self = _data94_->self;
		_g_object_unref0 (_data94_->call);
		_g_object_unref0 (self);
		g_slice_free (Block94Data, _data94_);
	}
}

static void
___lambda179_ (Block94Data* _data94_,
               GObject* obj,
               GAsyncResult* res)
{
	AccountDialog* self;
	cairo_surface_t* s = NULL;
	GdkPixbuf* _tmp5_;
	cairo_surface_t* _tmp6_;
	Account* _tmp7_;
	cairo_surface_t* _tmp8_;
	GError* _inner_error0_ = NULL;
	self = _data94_->self;
	g_return_if_fail (res != NULL);
	{
		RestProxyCall* _tmp0_;
		_tmp0_ = _data94_->call;
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		g_debug ("AccountDialog.vala:200: Avatar successfully updated");
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		RestProxyCall* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = _data94_->call;
		_tmp2_ = e;
		_tmp3_ = tweet_utils_failed_request_to_error (_tmp1_, _tmp2_);
		_tmp4_ = _tmp3_;
		utils_show_error_dialog (_tmp4_, (GtkWindow*) self, NULL, 0);
		_g_error_free0 (_tmp4_);
		_g_error_free0 (e);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp5_ = self->priv->new_avatar;
	_tmp6_ = gdk_cairo_surface_create_from_pixbuf (_tmp5_, 1, NULL);
	s = _tmp6_;
	_tmp7_ = self->priv->account;
	_tmp8_ = s;
	account_set_new_avatar (_tmp7_, _tmp8_);
	_cairo_surface_destroy0 (s);
}

static void
____lambda179__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
	___lambda179_ (self, source_object, res);
	block94_data_unref (self);
}

static Block95Data*
block95_data_ref (Block95Data* _data95_)
{
	g_atomic_int_inc (&_data95_->_ref_count_);
	return _data95_;
}

static void
block95_data_unref (void * _userdata_)
{
	Block95Data* _data95_;
	_data95_ = (Block95Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data95_->_ref_count_)) {
		AccountDialog* self;
		self = _data95_->self;
		_g_object_unref0 (_data95_->call);
		_g_object_unref0 (self);
		g_slice_free (Block95Data, _data95_);
	}
}

static void
___lambda180_ (Block95Data* _data95_,
               GObject* obj,
               GAsyncResult* res)
{
	AccountDialog* self;
	GError* _inner_error0_ = NULL;
	self = _data95_->self;
	g_return_if_fail (res != NULL);
	{
		RestProxyCall* _tmp0_;
		_tmp0_ = _data95_->call;
		rest_proxy_call_invoke_finish (_tmp0_, res, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		g_debug ("AccountDialog.vala:232: Banner successfully updated");
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		RestProxyCall* _tmp1_;
		GError* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp1_ = _data95_->call;
		_tmp2_ = e;
		_tmp3_ = tweet_utils_failed_request_to_error (_tmp1_, _tmp2_);
		_tmp4_ = _tmp3_;
		utils_show_error_dialog (_tmp4_, (GtkWindow*) self, NULL, 0);
		_g_error_free0 (_tmp4_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
____lambda180__gasync_ready_callback (GObject* source_object,
                                      GAsyncResult* res,
                                      gpointer self)
{
	___lambda180_ (self, source_object, res);
	block95_data_unref (self);
}

static void
account_dialog_save_data (AccountDialog* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	GtkEntry* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gboolean needs_save = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean needs_init = FALSE;
	gboolean _tmp21_ = FALSE;
	GdkPixbuf* _tmp62_;
	GdkPixbuf* _tmp80_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp2_ = self->priv->old_user_name;
	_tmp3_ = self->priv->name_entry;
	_tmp4_ = gtk_entry_get_text (_tmp3_);
	_tmp5_ = _tmp4_;
	if (g_strcmp0 (_tmp2_, _tmp5_) != 0) {
		_tmp1_ = TRUE;
	} else {
		const gchar* _tmp6_;
		CompletionTextView* _tmp7_;
		GtkTextBuffer* _tmp8_;
		GtkTextBuffer* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		_tmp6_ = self->priv->old_description;
		_tmp7_ = self->priv->description_text_view;
		_tmp8_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp7_);
		_tmp9_ = _tmp8_;
		g_object_get (_tmp9_, "text", &_tmp10_, NULL);
		_tmp11_ = _tmp10_;
		_tmp12_ = _tmp11_;
		_tmp1_ = g_strcmp0 (_tmp6_, _tmp12_) != 0;
		_g_free0 (_tmp12_);
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		const gchar* _tmp13_;
		GtkEntry* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		_tmp13_ = self->priv->old_website;
		_tmp14_ = self->priv->website_entry;
		_tmp15_ = gtk_entry_get_text (_tmp14_);
		_tmp16_ = _tmp15_;
		_tmp0_ = g_strcmp0 (_tmp13_, _tmp16_) != 0;
	}
	needs_save = _tmp0_;
	if (needs_save) {
		_tmp18_ = TRUE;
	} else {
		GdkPixbuf* _tmp19_;
		_tmp19_ = self->priv->new_avatar;
		_tmp18_ = _tmp19_ != NULL;
	}
	if (_tmp18_) {
		_tmp17_ = TRUE;
	} else {
		GdkPixbuf* _tmp20_;
		_tmp20_ = self->priv->new_banner;
		_tmp17_ = _tmp20_ != NULL;
	}
	needs_init = _tmp17_;
	if (needs_init) {
		Account* _tmp22_;
		OAuthProxy* _tmp23_;
		_tmp22_ = self->priv->account;
		_tmp23_ = _tmp22_->proxy;
		_tmp21_ = _tmp23_ == NULL;
	} else {
		_tmp21_ = FALSE;
	}
	if (_tmp21_) {
		Account* _tmp24_;
		_tmp24_ = self->priv->account;
		account_init_proxy (_tmp24_);
	}
	if (needs_save) {
		Block93Data* _data93_;
		Account* _tmp25_;
		OAuthProxy* _tmp26_;
		RestProxyCall* _tmp27_;
		RestProxyCall* _tmp28_;
		RestProxyCall* _tmp29_;
		RestProxyCall* _tmp30_;
		GtkEntry* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		RestProxyCall* _tmp34_;
		GtkEntry* _tmp35_;
		const gchar* _tmp36_;
		const gchar* _tmp37_;
		RestProxyCall* _tmp38_;
		CompletionTextView* _tmp39_;
		GtkTextBuffer* _tmp40_;
		GtkTextBuffer* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		RestProxyCall* _tmp45_;
		Account* _tmp46_;
		GtkEntry* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		Account* _tmp51_;
		CompletionTextView* _tmp52_;
		GtkTextBuffer* _tmp53_;
		GtkTextBuffer* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		Account* _tmp57_;
		GtkEntry* _tmp58_;
		const gchar* _tmp59_;
		const gchar* _tmp60_;
		gchar* _tmp61_;
		_data93_ = g_slice_new0 (Block93Data);
		_data93_->_ref_count_ = 1;
		_data93_->self = g_object_ref (self);
		g_debug ("AccountDialog.vala:157: Saving data...");
		_tmp25_ = self->priv->account;
		_tmp26_ = _tmp25_->proxy;
		_tmp27_ = rest_proxy_new_call ((RestProxy*) _tmp26_);
		_data93_->call = _tmp27_;
		_tmp28_ = _data93_->call;
		rest_proxy_call_set_function (_tmp28_, "1.1/account/update_profile.json");
		_tmp29_ = _data93_->call;
		rest_proxy_call_set_method (_tmp29_, "POST");
		_tmp30_ = _data93_->call;
		_tmp31_ = self->priv->website_entry;
		_tmp32_ = gtk_entry_get_text (_tmp31_);
		_tmp33_ = _tmp32_;
		rest_proxy_call_add_param (_tmp30_, "url", _tmp33_);
		_tmp34_ = _data93_->call;
		_tmp35_ = self->priv->name_entry;
		_tmp36_ = gtk_entry_get_text (_tmp35_);
		_tmp37_ = _tmp36_;
		rest_proxy_call_add_param (_tmp34_, "name", _tmp37_);
		_tmp38_ = _data93_->call;
		_tmp39_ = self->priv->description_text_view;
		_tmp40_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp39_);
		_tmp41_ = _tmp40_;
		g_object_get (_tmp41_, "text", &_tmp42_, NULL);
		_tmp43_ = _tmp42_;
		_tmp44_ = _tmp43_;
		rest_proxy_call_add_param (_tmp38_, "description", _tmp44_);
		_g_free0 (_tmp44_);
		_tmp45_ = _data93_->call;
		rest_proxy_call_invoke_async (_tmp45_, NULL, ____lambda178__gasync_ready_callback, block93_data_ref (_data93_));
		_tmp46_ = self->priv->account;
		_tmp47_ = self->priv->name_entry;
		_tmp48_ = gtk_entry_get_text (_tmp47_);
		_tmp49_ = _tmp48_;
		_tmp50_ = g_strdup (_tmp49_);
		_g_free0 (_tmp46_->name);
		_tmp46_->name = _tmp50_;
		_tmp51_ = self->priv->account;
		_tmp52_ = self->priv->description_text_view;
		_tmp53_ = gtk_text_view_get_buffer ((GtkTextView*) _tmp52_);
		_tmp54_ = _tmp53_;
		g_object_get (_tmp54_, "text", &_tmp55_, NULL);
		_tmp56_ = _tmp55_;
		_g_free0 (_tmp51_->description);
		_tmp51_->description = _tmp56_;
		_tmp57_ = self->priv->account;
		_tmp58_ = self->priv->website_entry;
		_tmp59_ = gtk_entry_get_text (_tmp58_);
		_tmp60_ = _tmp59_;
		_tmp61_ = g_strdup (_tmp60_);
		_g_free0 (_tmp57_->website);
		_tmp57_->website = _tmp61_;
		block93_data_unref (_data93_);
		_data93_ = NULL;
	}
	_tmp62_ = self->priv->new_avatar;
	if (_tmp62_ != NULL) {
		Block94Data* _data94_;
		guint8* buffer = NULL;
		gint buffer_length1 = 0;
		gint _buffer_size_ = 0;
		gchar* b64 = NULL;
		guint8* _tmp68_;
		gint _tmp68__length1;
		gchar* _tmp69_;
		Account* _tmp70_;
		OAuthProxy* _tmp71_;
		RestProxyCall* _tmp72_;
		RestProxyCall* _tmp73_;
		RestProxyCall* _tmp74_;
		RestProxyCall* _tmp75_;
		RestProxyCall* _tmp76_;
		RestProxyCall* _tmp77_;
		const gchar* _tmp78_;
		RestProxyCall* _tmp79_;
		_data94_ = g_slice_new0 (Block94Data);
		_data94_->_ref_count_ = 1;
		_data94_->self = g_object_ref (self);
		g_debug ("AccountDialog.vala:181: Updating avatar...");
		{
			GdkPixbuf* _tmp63_;
			guint8* _tmp64_ = NULL;
			gsize _tmp65_ = 0;
			_tmp63_ = self->priv->new_avatar;
			gdk_pixbuf_save_to_buffer (_tmp63_, &_tmp64_, &_tmp65_, "png", &_inner_error0_, NULL, NULL);
			buffer = (g_free (buffer), NULL);
			buffer = _tmp64_;
			buffer_length1 = _tmp65_;
			_buffer_size_ = buffer_length1;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp66_;
			const gchar* _tmp67_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp66_ = e;
			_tmp67_ = _tmp66_->message;
			g_warning ("AccountDialog.vala:186: %s", _tmp67_);
			_g_error_free0 (e);
			buffer = (g_free (buffer), NULL);
			block94_data_unref (_data94_);
			_data94_ = NULL;
			return;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			buffer = (g_free (buffer), NULL);
			block94_data_unref (_data94_);
			_data94_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp68_ = buffer;
		_tmp68__length1 = buffer_length1;
		_tmp69_ = g_base64_encode (_tmp68_, (gint) _tmp68__length1);
		b64 = _tmp69_;
		_tmp70_ = self->priv->account;
		_tmp71_ = _tmp70_->proxy;
		_tmp72_ = rest_proxy_new_call ((RestProxy*) _tmp71_);
		_data94_->call = _tmp72_;
		_tmp73_ = _data94_->call;
		rest_proxy_call_set_function (_tmp73_, "1.1/account/update_profile_image.json");
		_tmp74_ = _data94_->call;
		rest_proxy_call_set_method (_tmp74_, "POST");
		_tmp75_ = _data94_->call;
		rest_proxy_call_add_param (_tmp75_, "skip_status", "true");
		_tmp76_ = _data94_->call;
		rest_proxy_call_add_param (_tmp76_, "include_entities", "false");
		_tmp77_ = _data94_->call;
		_tmp78_ = b64;
		rest_proxy_call_add_param (_tmp77_, "image", _tmp78_);
		_tmp79_ = _data94_->call;
		rest_proxy_call_invoke_async (_tmp79_, NULL, ____lambda179__gasync_ready_callback, block94_data_ref (_data94_));
		_g_free0 (b64);
		buffer = (g_free (buffer), NULL);
		block94_data_unref (_data94_);
		_data94_ = NULL;
	}
	_tmp80_ = self->priv->new_banner;
	if (_tmp80_ != NULL) {
		Block95Data* _data95_;
		guint8* buffer = NULL;
		gint buffer_length1 = 0;
		gint _buffer_size_ = 0;
		gchar* b64 = NULL;
		guint8* _tmp86_;
		gint _tmp86__length1;
		gchar* _tmp87_;
		Account* _tmp88_;
		OAuthProxy* _tmp89_;
		RestProxyCall* _tmp90_;
		RestProxyCall* _tmp91_;
		RestProxyCall* _tmp92_;
		RestProxyCall* _tmp93_;
		const gchar* _tmp94_;
		RestProxyCall* _tmp95_;
		_data95_ = g_slice_new0 (Block95Data);
		_data95_->_ref_count_ = 1;
		_data95_->self = g_object_ref (self);
		g_debug ("AccountDialog.vala:213: Updating banner...");
		{
			GdkPixbuf* _tmp81_;
			guint8* _tmp82_ = NULL;
			gsize _tmp83_ = 0;
			_tmp81_ = self->priv->new_banner;
			gdk_pixbuf_save_to_buffer (_tmp81_, &_tmp82_, &_tmp83_, "png", &_inner_error0_, NULL, NULL);
			buffer = (g_free (buffer), NULL);
			buffer = _tmp82_;
			buffer_length1 = _tmp83_;
			_buffer_size_ = buffer_length1;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp84_;
			const gchar* _tmp85_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp84_ = e;
			_tmp85_ = _tmp84_->message;
			g_warning ("AccountDialog.vala:219: %s", _tmp85_);
			_g_error_free0 (e);
			buffer = (g_free (buffer), NULL);
			block95_data_unref (_data95_);
			_data95_ = NULL;
			return;
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			buffer = (g_free (buffer), NULL);
			block95_data_unref (_data95_);
			_data95_ = NULL;
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		_tmp86_ = buffer;
		_tmp86__length1 = buffer_length1;
		_tmp87_ = g_base64_encode (_tmp86_, (gint) _tmp86__length1);
		b64 = _tmp87_;
		_tmp88_ = self->priv->account;
		_tmp89_ = _tmp88_->proxy;
		_tmp90_ = rest_proxy_new_call ((RestProxy*) _tmp89_);
		_data95_->call = _tmp90_;
		_tmp91_ = _data95_->call;
		rest_proxy_call_set_function (_tmp91_, "1.1/account/update_profile_banner.json");
		_tmp92_ = _data95_->call;
		rest_proxy_call_set_method (_tmp92_, "POST");
		_tmp93_ = _data95_->call;
		_tmp94_ = b64;
		rest_proxy_call_add_param (_tmp93_, "banner", _tmp94_);
		_tmp95_ = _data95_->call;
		rest_proxy_call_invoke_async (_tmp95_, NULL, ____lambda180__gasync_ready_callback, block95_data_ref (_data95_));
		_g_free0 (b64);
		buffer = (g_free (buffer), NULL);
		block95_data_unref (_data95_);
		_data95_ = NULL;
	}
}

static void
account_dialog_delete_confirm_button_clicked_cb (AccountDialog* self)
{
	gint64 acc_id = 0LL;
	Account* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	SqlDatabase* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar** startup_accounts = NULL;
	GSettings* _tmp24_;
	GSettings* _tmp25_;
	gchar** _tmp26_;
	gchar** _tmp27_;
	gchar** _tmp28_;
	gint _tmp28__length1;
	gint startup_accounts_length1;
	gint _startup_accounts_size_;
	Cawbird* cb = NULL;
	GApplication* _tmp54_;
	Cawbird* _tmp55_;
	GList* windows = NULL;
	Cawbird* _tmp56_;
	GList* _tmp57_;
	GtkWindow* account_window = NULL;
	gint n_main_windows = 0;
	GList* _tmp58_;
	GtkWindow* _tmp72_;
	Account* acc_to_remove = NULL;
	Account* _tmp101_;
	Account* _tmp102_;
	Cawbird* _tmp103_;
	const gchar* _tmp104_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->account;
	acc_id = _tmp0_->id;
	_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, acc_id);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_strconcat ("accounts/", _tmp2_, ".db", NULL);
	_tmp4_ = _tmp3_;
	_tmp5_ = dirs_config (_tmp4_);
	_tmp6_ = _tmp5_;
	g_remove (_tmp6_);
	_g_free0 (_tmp6_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	_tmp7_ = g_strdup_printf ("%" G_GINT64_FORMAT, acc_id);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_strconcat ("accounts/", _tmp8_, ".png", NULL);
	_tmp10_ = _tmp9_;
	_tmp11_ = dirs_config (_tmp10_);
	_tmp12_ = _tmp11_;
	g_remove (_tmp12_);
	_g_free0 (_tmp12_);
	_g_free0 (_tmp10_);
	_g_free0 (_tmp8_);
	_tmp13_ = g_strdup_printf ("%" G_GINT64_FORMAT, acc_id);
	_tmp14_ = _tmp13_;
	_tmp15_ = g_strconcat ("accounts/", _tmp14_, "_small.png", NULL);
	_tmp16_ = _tmp15_;
	_tmp17_ = dirs_config (_tmp16_);
	_tmp18_ = _tmp17_;
	g_remove (_tmp18_);
	_g_free0 (_tmp18_);
	_g_free0 (_tmp16_);
	_g_free0 (_tmp14_);
	_tmp19_ = cawbird_db;
	_tmp20_ = g_strdup_printf ("%" G_GINT64_FORMAT, acc_id);
	_tmp21_ = _tmp20_;
	_tmp22_ = g_strconcat ("DELETE FROM `accounts` WHERE `id`='", _tmp21_, "';", NULL);
	_tmp23_ = _tmp22_;
	sql_database_exec (_tmp19_, _tmp23_, NULL, NULL);
	_g_free0 (_tmp23_);
	_g_free0 (_tmp21_);
	_tmp24_ = settings_get ();
	_tmp25_ = _tmp24_;
	_tmp27_ = _tmp26_ = g_settings_get_strv (_tmp25_, "startup-accounts");
	_tmp28_ = _tmp27_;
	_tmp28__length1 = _vala_array_length (_tmp26_);
	_g_object_unref0 (_tmp25_);
	startup_accounts = _tmp28_;
	startup_accounts_length1 = _tmp28__length1;
	_startup_accounts_size_ = startup_accounts_length1;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp29_ = FALSE;
			_tmp29_ = TRUE;
			while (TRUE) {
				gchar** _tmp31_;
				gint _tmp31__length1;
				gchar** _tmp32_;
				gint _tmp32__length1;
				const gchar* _tmp33_;
				Account* _tmp34_;
				const gchar* _tmp35_;
				if (!_tmp29_) {
					gint _tmp30_;
					_tmp30_ = i;
					i = _tmp30_ + 1;
				}
				_tmp29_ = FALSE;
				_tmp31_ = startup_accounts;
				_tmp31__length1 = startup_accounts_length1;
				if (!(i < _tmp31__length1)) {
					break;
				}
				_tmp32_ = startup_accounts;
				_tmp32__length1 = startup_accounts_length1;
				_tmp33_ = _tmp32_[i];
				_tmp34_ = self->priv->account;
				_tmp35_ = _tmp34_->screen_name;
				if (g_strcmp0 (_tmp33_, _tmp35_) == 0) {
					gchar** sa_new = NULL;
					gchar** _tmp36_;
					gint _tmp36__length1;
					gchar** _tmp37_;
					gint sa_new_length1;
					gint _sa_new_size_;
					GSettings* _tmp51_;
					GSettings* _tmp52_;
					gchar** _tmp53_;
					gint _tmp53__length1;
					_tmp36_ = startup_accounts;
					_tmp36__length1 = startup_accounts_length1;
					_tmp37_ = g_new0 (gchar*, (_tmp36__length1 - 1) + 1);
					sa_new = _tmp37_;
					sa_new_length1 = _tmp36__length1 - 1;
					_sa_new_size_ = sa_new_length1;
					{
						gint x = 0;
						x = 0;
						{
							gboolean _tmp38_ = FALSE;
							_tmp38_ = TRUE;
							while (TRUE) {
								gchar** _tmp40_;
								gint _tmp40__length1;
								gchar** _tmp41_;
								gint _tmp41__length1;
								const gchar* _tmp42_;
								gchar* _tmp43_;
								if (!_tmp38_) {
									gint _tmp39_;
									_tmp39_ = i;
									i = _tmp39_ + 1;
								}
								_tmp38_ = FALSE;
								if (!(x < i)) {
									break;
								}
								_tmp40_ = sa_new;
								_tmp40__length1 = sa_new_length1;
								_tmp41_ = startup_accounts;
								_tmp41__length1 = startup_accounts_length1;
								_tmp42_ = _tmp41_[x];
								_tmp43_ = g_strdup (_tmp42_);
								_g_free0 (_tmp40_[x]);
								_tmp40_[x] = _tmp43_;
							}
						}
					}
					{
						gint x = 0;
						x = i + 1;
						{
							gboolean _tmp44_ = FALSE;
							_tmp44_ = TRUE;
							while (TRUE) {
								gchar** _tmp46_;
								gint _tmp46__length1;
								gchar** _tmp47_;
								gint _tmp47__length1;
								gchar** _tmp48_;
								gint _tmp48__length1;
								const gchar* _tmp49_;
								gchar* _tmp50_;
								if (!_tmp44_) {
									gint _tmp45_;
									_tmp45_ = x;
									x = _tmp45_ + 1;
								}
								_tmp44_ = FALSE;
								_tmp46_ = startup_accounts;
								_tmp46__length1 = startup_accounts_length1;
								if (!(x < _tmp46__length1)) {
									break;
								}
								_tmp47_ = sa_new;
								_tmp47__length1 = sa_new_length1;
								_tmp48_ = startup_accounts;
								_tmp48__length1 = startup_accounts_length1;
								_tmp49_ = _tmp48_[x];
								_tmp50_ = g_strdup (_tmp49_);
								_g_free0 (_tmp47_[x]);
								_tmp47_[x] = _tmp50_;
							}
						}
					}
					_tmp51_ = settings_get ();
					_tmp52_ = _tmp51_;
					_tmp53_ = sa_new;
					_tmp53__length1 = sa_new_length1;
					g_settings_set_strv (_tmp52_, "startup-accounts", _tmp53_);
					_g_object_unref0 (_tmp52_);
					sa_new = (_vala_array_free (sa_new, sa_new_length1, (GDestroyNotify) g_free), NULL);
				}
			}
		}
	}
	_tmp54_ = g_application_get_default ();
	_tmp55_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, TYPE_CAWBIRD, Cawbird));
	cb = _tmp55_;
	_tmp56_ = cb;
	_tmp57_ = gtk_application_get_windows ((GtkApplication*) _tmp56_);
	windows = _tmp57_;
	account_window = NULL;
	n_main_windows = 0;
	_tmp58_ = windows;
	{
		GList* win_collection = NULL;
		GList* win_it = NULL;
		win_collection = _tmp58_;
		for (win_it = win_collection; win_it != NULL; win_it = win_it->next) {
			GtkWindow* _tmp59_;
			GtkWindow* win = NULL;
			_tmp59_ = _g_object_ref0 ((GtkWindow*) win_it->data);
			win = _tmp59_;
			{
				GtkWindow* _tmp60_;
				_tmp60_ = win;
				if (IS_MAIN_WINDOW (_tmp60_)) {
					gint _tmp61_;
					MainWindow* main_win = NULL;
					GtkWindow* _tmp62_;
					MainWindow* _tmp63_;
					gboolean _tmp64_ = FALSE;
					MainWindow* _tmp65_;
					Account* _tmp66_;
					_tmp61_ = n_main_windows;
					n_main_windows = _tmp61_ + 1;
					_tmp62_ = win;
					_tmp63_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, TYPE_MAIN_WINDOW, MainWindow));
					main_win = _tmp63_;
					_tmp65_ = main_win;
					_tmp66_ = _tmp65_->account;
					if (_tmp66_ != NULL) {
						MainWindow* _tmp67_;
						Account* _tmp68_;
						Account* _tmp69_;
						_tmp67_ = main_win;
						_tmp68_ = _tmp67_->account;
						_tmp69_ = self->priv->account;
						_tmp64_ = _tmp68_->id == _tmp69_->id;
					} else {
						_tmp64_ = FALSE;
					}
					if (_tmp64_) {
						GtkWindow* _tmp70_;
						GtkWindow* _tmp71_;
						_tmp70_ = win;
						_tmp71_ = _g_object_ref0 (_tmp70_);
						_g_object_unref0 (account_window);
						account_window = _tmp71_;
					}
					_g_object_unref0 (main_win);
				}
				_g_object_unref0 (win);
			}
		}
	}
	g_debug ("AccountDialog.vala:284: Open main windows: %d", n_main_windows);
	_tmp72_ = account_window;
	if (_tmp72_ != NULL) {
		if (n_main_windows > 1) {
			GtkWindow* _tmp73_;
			_tmp73_ = account_window;
			gtk_widget_destroy ((GtkWidget*) _tmp73_);
		} else {
			Account* first_acct = NULL;
			Account* first_startup_acct = NULL;
			GSettings* _tmp74_;
			GSettings* _tmp75_;
			gchar** _tmp76_;
			gchar** _tmp77_;
			gchar* startup_acct = NULL;
			gchar** _tmp78_;
			gint _tmp78__length1;
			Account* _tmp97_ = NULL;
			Account* _tmp98_;
			GtkWindow* _tmp100_;
			first_acct = NULL;
			first_startup_acct = NULL;
			_tmp74_ = settings_get ();
			_tmp75_ = _tmp74_;
			_tmp77_ = _tmp76_ = g_settings_get_strv (_tmp75_, "startup-accounts");
			startup_accounts = (_vala_array_free (startup_accounts, startup_accounts_length1, (GDestroyNotify) g_free), NULL);
			startup_accounts = _tmp77_;
			startup_accounts_length1 = _vala_array_length (_tmp76_);
			_startup_accounts_size_ = startup_accounts_length1;
			_g_object_unref0 (_tmp75_);
			startup_acct = NULL;
			_tmp78_ = startup_accounts;
			_tmp78__length1 = startup_accounts_length1;
			if (_tmp78__length1 > 0) {
				gchar** _tmp79_;
				gint _tmp79__length1;
				const gchar* _tmp80_;
				gchar* _tmp81_;
				_tmp79_ = startup_accounts;
				_tmp79__length1 = startup_accounts_length1;
				_tmp80_ = _tmp79_[0];
				_tmp81_ = g_strdup (_tmp80_);
				_g_free0 (startup_acct);
				startup_acct = _tmp81_;
			}
			{
				guint i = 0U;
				i = (guint) 0;
				{
					gboolean _tmp82_ = FALSE;
					_tmp82_ = TRUE;
					while (TRUE) {
						Account* acct = NULL;
						Account* _tmp84_;
						Account* _tmp85_;
						const gchar* _tmp86_;
						Account* _tmp87_;
						const gchar* _tmp88_;
						if (!_tmp82_) {
							guint _tmp83_;
							_tmp83_ = i;
							i = _tmp83_ + 1;
						}
						_tmp82_ = FALSE;
						if (!(i < account_get_n ())) {
							break;
						}
						_tmp84_ = account_get_nth (i);
						acct = _tmp84_;
						_tmp85_ = acct;
						_tmp86_ = _tmp85_->screen_name;
						_tmp87_ = self->priv->account;
						_tmp88_ = _tmp87_->screen_name;
						if (g_strcmp0 (_tmp86_, _tmp88_) == 0) {
							_g_object_unref0 (acct);
							continue;
						} else {
							Account* _tmp89_;
							const gchar* _tmp90_;
							const gchar* _tmp91_;
							_tmp89_ = acct;
							_tmp90_ = _tmp89_->screen_name;
							_tmp91_ = startup_acct;
							if (g_strcmp0 (_tmp90_, _tmp91_) == 0) {
								Account* _tmp92_;
								Account* _tmp93_;
								_tmp92_ = acct;
								_tmp93_ = _g_object_ref0 (_tmp92_);
								_g_object_unref0 (first_startup_acct);
								first_startup_acct = _tmp93_;
							} else {
								Account* _tmp94_;
								_tmp94_ = first_acct;
								if (_tmp94_ == NULL) {
									Account* _tmp95_;
									Account* _tmp96_;
									_tmp95_ = acct;
									_tmp96_ = _g_object_ref0 (_tmp95_);
									_g_object_unref0 (first_acct);
									first_acct = _tmp96_;
								}
							}
						}
						_g_object_unref0 (acct);
					}
				}
			}
			_tmp98_ = first_startup_acct;
			_tmp97_ = _tmp98_;
			if (_tmp97_ == NULL) {
				Account* _tmp99_;
				_tmp99_ = first_acct;
				_tmp97_ = _tmp99_;
			}
			_tmp100_ = account_window;
			main_window_change_account (G_TYPE_CHECK_INSTANCE_CAST (_tmp100_, TYPE_MAIN_WINDOW, MainWindow), _tmp97_);
			_g_free0 (startup_acct);
			_g_object_unref0 (first_startup_acct);
			_g_object_unref0 (first_acct);
		}
	}
	_tmp101_ = account_query_account_by_id (acc_id);
	_tmp102_ = _g_object_ref0 (_tmp101_);
	acc_to_remove = _tmp102_;
	_tmp103_ = cb;
	g_signal_emit_by_name (_tmp103_, "account-removed", acc_to_remove);
	_tmp104_ = acc_to_remove->screen_name;
	account_remove_account (_tmp104_);
	gtk_widget_destroy ((GtkWidget*) self);
	_g_object_unref0 (acc_to_remove);
	_g_object_unref0 (account_window);
	_g_object_unref0 (cb);
	startup_accounts = (_vala_array_free (startup_accounts, startup_accounts_length1, (GDestroyNotify) g_free), NULL);
}

static void
_account_dialog_delete_confirm_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                     gpointer self)
{
	account_dialog_delete_confirm_button_clicked_cb ((AccountDialog*) self);
}

static void
account_dialog_delete_cancel_button_clicked_cb (AccountDialog* self)
{
	GtkStack* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->delete_stack;
	gtk_stack_set_visible_child_name (_tmp0_, ACCOUNT_DIALOG_PAGE_NORMAL);
}

static void
_account_dialog_delete_cancel_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                                    gpointer self)
{
	account_dialog_delete_cancel_button_clicked_cb ((AccountDialog*) self);
}

static void
account_dialog_autostart_switch_activate_cb (AccountDialog* self)
{
	gboolean active = FALSE;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gchar** startup_accounts = NULL;
	GSettings* _tmp3_;
	GSettings* _tmp4_;
	gchar** _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gint startup_accounts_length1;
	gint _startup_accounts_size_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->autostart_switch;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	active = _tmp2_;
	_tmp3_ = settings_get ();
	_tmp4_ = _tmp3_;
	_tmp6_ = _tmp5_ = g_settings_get_strv (_tmp4_, "startup-accounts");
	_tmp7_ = _tmp6_;
	_tmp7__length1 = _vala_array_length (_tmp5_);
	_g_object_unref0 (_tmp4_);
	startup_accounts = _tmp7_;
	startup_accounts_length1 = _tmp7__length1;
	_startup_accounts_size_ = startup_accounts_length1;
	if (active) {
		gchar** _tmp8_;
		gint _tmp8__length1;
		gchar** new_startup_accounts = NULL;
		gchar** _tmp12_;
		gint _tmp12__length1;
		gchar** _tmp13_;
		gint new_startup_accounts_length1;
		gint _new_startup_accounts_size_;
		gint i = 0;
		gchar** _tmp14_;
		gint _tmp14__length1;
		gchar** _tmp19_;
		gint _tmp19__length1;
		gchar** _tmp20_;
		gint _tmp20__length1;
		Account* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		GSettings* _tmp24_;
		GSettings* _tmp25_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		_tmp8_ = startup_accounts;
		_tmp8__length1 = startup_accounts_length1;
		{
			gchar** acc_collection = NULL;
			gint acc_collection_length1 = 0;
			gint _acc_collection_size_ = 0;
			gint acc_it = 0;
			acc_collection = _tmp8_;
			acc_collection_length1 = _tmp8__length1;
			for (acc_it = 0; acc_it < acc_collection_length1; acc_it = acc_it + 1) {
				const gchar* acc = NULL;
				acc = acc_collection[acc_it];
				{
					const gchar* _tmp9_;
					Account* _tmp10_;
					const gchar* _tmp11_;
					_tmp9_ = acc;
					_tmp10_ = self->priv->account;
					_tmp11_ = _tmp10_->screen_name;
					if (g_strcmp0 (_tmp9_, _tmp11_) == 0) {
						startup_accounts = (_vala_array_free (startup_accounts, startup_accounts_length1, (GDestroyNotify) g_free), NULL);
						return;
					}
				}
			}
		}
		_tmp12_ = startup_accounts;
		_tmp12__length1 = startup_accounts_length1;
		_tmp13_ = g_new0 (gchar*, (_tmp12__length1 + 1) + 1);
		new_startup_accounts = _tmp13_;
		new_startup_accounts_length1 = _tmp12__length1 + 1;
		_new_startup_accounts_size_ = new_startup_accounts_length1;
		i = 0;
		_tmp14_ = startup_accounts;
		_tmp14__length1 = startup_accounts_length1;
		{
			gchar** s_collection = NULL;
			gint s_collection_length1 = 0;
			gint _s_collection_size_ = 0;
			gint s_it = 0;
			s_collection = _tmp14_;
			s_collection_length1 = _tmp14__length1;
			for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
				const gchar* s = NULL;
				s = s_collection[s_it];
				{
					gchar** _tmp15_;
					gint _tmp15__length1;
					const gchar* _tmp16_;
					gchar* _tmp17_;
					gint _tmp18_;
					_tmp15_ = new_startup_accounts;
					_tmp15__length1 = new_startup_accounts_length1;
					_tmp16_ = s;
					_tmp17_ = g_strdup (_tmp16_);
					_g_free0 (_tmp15_[i]);
					_tmp15_[i] = _tmp17_;
					_tmp18_ = i;
					i = _tmp18_ + 1;
				}
			}
		}
		_tmp19_ = new_startup_accounts;
		_tmp19__length1 = new_startup_accounts_length1;
		_tmp20_ = new_startup_accounts;
		_tmp20__length1 = new_startup_accounts_length1;
		_tmp21_ = self->priv->account;
		_tmp22_ = _tmp21_->screen_name;
		_tmp23_ = g_strdup (_tmp22_);
		_g_free0 (_tmp19_[_tmp20__length1 - 1]);
		_tmp19_[_tmp20__length1 - 1] = _tmp23_;
		_tmp24_ = settings_get ();
		_tmp25_ = _tmp24_;
		_tmp26_ = new_startup_accounts;
		_tmp26__length1 = new_startup_accounts_length1;
		g_settings_set_strv (_tmp25_, "startup-accounts", _tmp26_);
		_g_object_unref0 (_tmp25_);
		new_startup_accounts = (_vala_array_free (new_startup_accounts, new_startup_accounts_length1, (GDestroyNotify) g_free), NULL);
	} else {
		gchar** new_startup_accounts = NULL;
		gchar** _tmp27_;
		gint _tmp27__length1;
		gchar** _tmp28_;
		gint new_startup_accounts_length1;
		gint _new_startup_accounts_size_;
		gint i = 0;
		gchar** _tmp29_;
		gint _tmp29__length1;
		GSettings* _tmp37_;
		GSettings* _tmp38_;
		gchar** _tmp39_;
		gint _tmp39__length1;
		_tmp27_ = startup_accounts;
		_tmp27__length1 = startup_accounts_length1;
		_tmp28_ = g_new0 (gchar*, (_tmp27__length1 - 1) + 1);
		new_startup_accounts = _tmp28_;
		new_startup_accounts_length1 = _tmp27__length1 - 1;
		_new_startup_accounts_size_ = new_startup_accounts_length1;
		i = 0;
		_tmp29_ = startup_accounts;
		_tmp29__length1 = startup_accounts_length1;
		{
			gchar** acc_collection = NULL;
			gint acc_collection_length1 = 0;
			gint _acc_collection_size_ = 0;
			gint acc_it = 0;
			acc_collection = _tmp29_;
			acc_collection_length1 = _tmp29__length1;
			for (acc_it = 0; acc_it < acc_collection_length1; acc_it = acc_it + 1) {
				const gchar* acc = NULL;
				acc = acc_collection[acc_it];
				{
					const gchar* _tmp30_;
					Account* _tmp31_;
					const gchar* _tmp32_;
					_tmp30_ = acc;
					_tmp31_ = self->priv->account;
					_tmp32_ = _tmp31_->screen_name;
					if (g_strcmp0 (_tmp30_, _tmp32_) != 0) {
						gchar** _tmp33_;
						gint _tmp33__length1;
						const gchar* _tmp34_;
						gchar* _tmp35_;
						gint _tmp36_;
						_tmp33_ = new_startup_accounts;
						_tmp33__length1 = new_startup_accounts_length1;
						_tmp34_ = acc;
						_tmp35_ = g_strdup (_tmp34_);
						_g_free0 (_tmp33_[i]);
						_tmp33_[i] = _tmp35_;
						_tmp36_ = i;
						i = _tmp36_ + 1;
					}
				}
			}
		}
		_tmp37_ = settings_get ();
		_tmp38_ = _tmp37_;
		_tmp39_ = new_startup_accounts;
		_tmp39__length1 = new_startup_accounts_length1;
		g_settings_set_strv (_tmp38_, "startup-accounts", _tmp39_);
		_g_object_unref0 (_tmp38_);
		new_startup_accounts = (_vala_array_free (new_startup_accounts, new_startup_accounts_length1, (GDestroyNotify) g_free), NULL);
	}
	startup_accounts = (_vala_array_free (startup_accounts, startup_accounts_length1, (GDestroyNotify) g_free), NULL);
}

static void
_account_dialog_autostart_switch_activate_cb_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
	account_dialog_autostart_switch_activate_cb ((AccountDialog*) self);
}

static void
account_dialog_show_crop_image_selector (AccountDialog* self)
{
	GtkFileChooserNative* filechooser = NULL;
	GtkFileChooserNative* _tmp0_;
	GtkFileFilter* filter = NULL;
	GtkFileFilter* _tmp1_;
	GtkFileFilter* _tmp2_;
	GtkFileFilter* _tmp3_;
	GtkFileChooserNative* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileChooserNative* _tmp6_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_file_chooser_native_new (_ ("Select Banner Image"), (GtkWindow*) self, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Open"), _ ("Cancel"));
	filechooser = _tmp0_;
	_tmp1_ = gtk_file_filter_new ();
	g_object_ref_sink (_tmp1_);
	filter = _tmp1_;
	_tmp2_ = filter;
	gtk_file_filter_add_mime_type (_tmp2_, "image/png");
	_tmp3_ = filter;
	gtk_file_filter_add_mime_type (_tmp3_, "image/jpeg");
	_tmp4_ = filechooser;
	_tmp5_ = filter;
	gtk_file_chooser_set_filter ((GtkFileChooser*) _tmp4_, _tmp5_);
	_tmp6_ = filechooser;
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp6_) == ((gint) GTK_RESPONSE_ACCEPT)) {
		gchar* selected_file = NULL;
		GtkFileChooserNative* _tmp7_;
		gchar* _tmp8_;
		GdkPixbuf* image = NULL;
		gint min_width = 0;
		gint min_height = 0;
		CropWidget* _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		gboolean _tmp18_ = FALSE;
		GdkPixbuf* _tmp19_;
		_tmp7_ = filechooser;
		_tmp8_ = gtk_file_chooser_get_filename ((GtkFileChooser*) _tmp7_);
		selected_file = _tmp8_;
		image = NULL;
		{
			GdkPixbuf* _tmp9_ = NULL;
			const gchar* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
			_tmp10_ = selected_file;
			_tmp11_ = gdk_pixbuf_new_from_file (_tmp10_, &_inner_error0_);
			_tmp9_ = _tmp11_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
			_tmp12_ = _tmp9_;
			_tmp9_ = NULL;
			_g_object_unref0 (image);
			image = _tmp12_;
			_g_object_unref0 (_tmp9_);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp13_;
			const gchar* _tmp14_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp13_ = e;
			_tmp14_ = _tmp13_->message;
			g_warning ("AccountDialog.vala:381: %s", _tmp14_);
			_g_error_free0 (e);
			_g_object_unref0 (image);
			_g_free0 (selected_file);
			_g_object_unref0 (filter);
			_g_object_unref0 (filechooser);
			return;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (image);
			_g_free0 (selected_file);
			_g_object_unref0 (filter);
			_g_object_unref0 (filechooser);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		min_width = 200;
		min_height = 100;
		_tmp15_ = self->priv->crop_widget;
		_tmp16_ = crop_widget_get_desired_aspect_ratio (_tmp15_);
		_tmp17_ = _tmp16_;
		if (_tmp17_ == 1.0) {
			min_width = 48;
			min_height = 48;
		}
		_tmp19_ = image;
		if (gdk_pixbuf_get_width (_tmp19_) >= min_width) {
			GdkPixbuf* _tmp20_;
			_tmp20_ = image;
			_tmp18_ = gdk_pixbuf_get_height (_tmp20_) >= min_height;
		} else {
			_tmp18_ = FALSE;
		}
		if (_tmp18_) {
			CropWidget* _tmp21_;
			GdkPixbuf* _tmp22_;
			GtkButton* _tmp23_;
			_tmp21_ = self->priv->crop_widget;
			_tmp22_ = image;
			crop_widget_set_image (_tmp21_, _tmp22_);
			_tmp23_ = self->priv->save_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp23_, TRUE);
		} else {
			gchar* error_str = NULL;
			gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			const gchar* _tmp29_;
			gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			const gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			gchar* _tmp38_;
			GtkLabel* _tmp39_;
			const gchar* _tmp40_;
			GtkStack* _tmp41_;
			GtkLabel* _tmp42_;
			GtkButton* _tmp43_;
			_tmp24_ = g_strdup ("");
			error_str = _tmp24_;
			_tmp25_ = error_str;
			_tmp26_ = g_strconcat (_ ("Image does not meet minimum size requirements:"), "\n", NULL);
			_tmp27_ = _tmp26_;
			_tmp28_ = g_strconcat (_tmp25_, _tmp27_, NULL);
			_g_free0 (error_str);
			error_str = _tmp28_;
			_g_free0 (_tmp27_);
			_tmp29_ = error_str;
			_tmp30_ = g_strdup_printf (ngettext ("Minimum width: %d pixel", "Minimum width: %d pixels", (gulong) min_width), min_width);
			_tmp31_ = _tmp30_;
			_tmp32_ = g_strconcat (_tmp31_, "\n", NULL);
			_tmp33_ = _tmp32_;
			_tmp34_ = g_strconcat (_tmp29_, _tmp33_, NULL);
			_g_free0 (error_str);
			error_str = _tmp34_;
			_g_free0 (_tmp33_);
			_g_free0 (_tmp31_);
			_tmp35_ = error_str;
			_tmp36_ = g_strdup_printf (ngettext ("Minimum height: %d pixel", "Minimum height: %d pixels", (gulong) min_height), min_height);
			_tmp37_ = _tmp36_;
			_tmp38_ = g_strconcat (_tmp35_, _tmp37_, NULL);
			_g_free0 (error_str);
			error_str = _tmp38_;
			_g_free0 (_tmp37_);
			_tmp39_ = self->priv->error_label;
			_tmp40_ = error_str;
			gtk_label_set_label (_tmp39_, _tmp40_);
			_tmp41_ = self->priv->content_stack;
			_tmp42_ = self->priv->error_label;
			gtk_stack_set_visible_child (_tmp41_, (GtkWidget*) _tmp42_);
			_tmp43_ = self->priv->save_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp43_, FALSE);
			_g_free0 (error_str);
		}
		_g_object_unref0 (image);
		_g_free0 (selected_file);
	} else {
		GtkStack* _tmp44_;
		GtkBox* _tmp45_;
		_tmp44_ = self->priv->content_stack;
		_tmp45_ = self->priv->info_box;
		gtk_stack_set_visible_child (_tmp44_, (GtkWidget*) _tmp45_);
	}
	_g_object_unref0 (filter);
	_g_object_unref0 (filechooser);
}

static void
account_dialog_avatar_clicked_cb (AccountDialog* self)
{
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	CropWidget* _tmp2_;
	CropWidget* _tmp3_;
	CropWidget* _tmp4_;
	CropWidget* _tmp5_;
	GtkStack* _tmp6_;
	CropWidget* _tmp7_;
	GtkButton* _tmp8_;
	g_return_if_fail (self != NULL);
	gtk_window_get_size ((GtkWindow*) self, &_tmp0_, &_tmp1_);
	self->priv->old_width = _tmp0_;
	self->priv->old_height = _tmp1_;
	gtk_window_resize ((GtkWindow*) self, 400, 400);
	_tmp2_ = self->priv->crop_widget;
	crop_widget_set_image (_tmp2_, NULL);
	_tmp3_ = self->priv->crop_widget;
	gtk_widget_set_size_request ((GtkWidget*) _tmp3_, -1, 400);
	_tmp4_ = self->priv->crop_widget;
	crop_widget_set_desired_aspect_ratio (_tmp4_, 1.0);
	_tmp5_ = self->priv->crop_widget;
	crop_widget_set_min_size (_tmp5_, 48);
	_tmp6_ = self->priv->content_stack;
	_tmp7_ = self->priv->crop_widget;
	gtk_stack_set_visible_child (_tmp6_, (GtkWidget*) _tmp7_);
	account_dialog_show_crop_image_selector (self);
	_tmp8_ = self->priv->save_button;
	gtk_button_set_label (_tmp8_, _ ("Pick"));
}

static void
_account_dialog_avatar_clicked_cb_avatar_banner_widget_avatar_clicked (AvatarBannerWidget* _sender,
                                                                       gpointer self)
{
	account_dialog_avatar_clicked_cb ((AccountDialog*) self);
}

static void
account_dialog_banner_clicked_cb (AccountDialog* self)
{
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	CropWidget* _tmp2_;
	CropWidget* _tmp3_;
	CropWidget* _tmp4_;
	CropWidget* _tmp5_;
	GtkStack* _tmp6_;
	CropWidget* _tmp7_;
	GtkButton* _tmp8_;
	g_return_if_fail (self != NULL);
	gtk_window_get_size ((GtkWindow*) self, &_tmp0_, &_tmp1_);
	self->priv->old_width = _tmp0_;
	self->priv->old_height = _tmp1_;
	gtk_window_resize ((GtkWindow*) self, 700, 350);
	_tmp2_ = self->priv->crop_widget;
	gtk_widget_set_size_request ((GtkWidget*) _tmp2_, 700, 350);
	_tmp3_ = self->priv->crop_widget;
	crop_widget_set_image (_tmp3_, NULL);
	_tmp4_ = self->priv->crop_widget;
	crop_widget_set_desired_aspect_ratio (_tmp4_, 2.0);
	_tmp5_ = self->priv->crop_widget;
	crop_widget_set_min_size (_tmp5_, 200);
	_tmp6_ = self->priv->content_stack;
	_tmp7_ = self->priv->crop_widget;
	gtk_stack_set_visible_child (_tmp6_, (GtkWidget*) _tmp7_);
	account_dialog_show_crop_image_selector (self);
	_tmp8_ = self->priv->save_button;
	gtk_button_set_label (_tmp8_, _ ("Pick"));
}

static void
_account_dialog_banner_clicked_cb_avatar_banner_widget_banner_clicked (AvatarBannerWidget* _sender,
                                                                       gpointer self)
{
	account_dialog_banner_clicked_cb ((AccountDialog*) self);
}

static void
account_dialog_cancel_button_clicked_cb (AccountDialog* self)
{
	gboolean _tmp0_ = FALSE;
	GtkStack* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	CropWidget* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->content_stack;
	_tmp2_ = gtk_stack_get_visible_child (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = self->priv->crop_widget;
	if (_tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget)) {
		_tmp0_ = TRUE;
	} else {
		GtkStack* _tmp5_;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
		GtkLabel* _tmp8_;
		_tmp5_ = self->priv->content_stack;
		_tmp6_ = gtk_stack_get_visible_child (_tmp5_);
		_tmp7_ = _tmp6_;
		_tmp8_ = self->priv->error_label;
		_tmp0_ = _tmp7_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget);
	}
	if (_tmp0_) {
		GtkStack* _tmp9_;
		GtkBox* _tmp10_;
		GtkButton* _tmp11_;
		gtk_window_resize ((GtkWindow*) self, self->priv->old_width, self->priv->old_height);
		self->priv->old_width = 0;
		self->priv->old_height = 0;
		_tmp9_ = self->priv->content_stack;
		_tmp10_ = self->priv->info_box;
		gtk_stack_set_visible_child (_tmp9_, (GtkWidget*) _tmp10_);
		_tmp11_ = self->priv->save_button;
		gtk_button_set_label (_tmp11_, _ ("Save"));
	} else {
		gtk_widget_destroy ((GtkWidget*) self);
	}
}

static void
_account_dialog_cancel_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self)
{
	account_dialog_cancel_button_clicked_cb ((AccountDialog*) self);
}

static void
account_dialog_save_button_clicked_cb (AccountDialog* self)
{
	GtkStack* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	CropWidget* _tmp3_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->content_stack;
	_tmp1_ = gtk_stack_get_visible_child (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = self->priv->crop_widget;
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget)) {
		GdkPixbuf* new_pixbuf = NULL;
		CropWidget* _tmp4_;
		GdkPixbuf* _tmp5_;
		CropWidget* _tmp6_;
		gdouble _tmp7_;
		gdouble _tmp8_;
		GtkButton* _tmp20_;
		GtkStack* _tmp21_;
		GtkBox* _tmp22_;
		_tmp4_ = self->priv->crop_widget;
		_tmp5_ = crop_widget_get_cropped_image (_tmp4_);
		new_pixbuf = _tmp5_;
		_tmp6_ = self->priv->crop_widget;
		_tmp7_ = crop_widget_get_desired_aspect_ratio (_tmp6_);
		_tmp8_ = _tmp7_;
		if (_tmp8_ == 1.0) {
			AvatarBannerWidget* _tmp9_;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
			_tmp9_ = self->priv->avatar_banner_widget;
			_tmp10_ = new_pixbuf;
			avatar_banner_widget_set_avatar (_tmp9_, _tmp10_);
			_tmp11_ = new_pixbuf;
			_tmp12_ = _g_object_ref0 (_tmp11_);
			_g_object_unref0 (self->priv->new_avatar);
			self->priv->new_avatar = _tmp12_;
		} else {
			CropWidget* _tmp13_;
			gdouble _tmp14_;
			gdouble _tmp15_;
			_tmp13_ = self->priv->crop_widget;
			_tmp14_ = crop_widget_get_desired_aspect_ratio (_tmp13_);
			_tmp15_ = _tmp14_;
			if (_tmp15_ == 2.0) {
				AvatarBannerWidget* _tmp16_;
				GdkPixbuf* _tmp17_;
				GdkPixbuf* _tmp18_;
				GdkPixbuf* _tmp19_;
				_tmp16_ = self->priv->avatar_banner_widget;
				_tmp17_ = new_pixbuf;
				avatar_banner_widget_set_banner (_tmp16_, _tmp17_);
				_tmp18_ = new_pixbuf;
				_tmp19_ = _g_object_ref0 (_tmp18_);
				_g_object_unref0 (self->priv->new_banner);
				self->priv->new_banner = _tmp19_;
			} else {
				g_assert_not_reached ();
			}
		}
		_tmp20_ = self->priv->save_button;
		gtk_button_set_label (_tmp20_, _ ("Save"));
		_tmp21_ = self->priv->content_stack;
		_tmp22_ = self->priv->info_box;
		gtk_stack_set_visible_child (_tmp21_, (GtkWidget*) _tmp22_);
		_g_object_unref0 (new_pixbuf);
	} else {
		account_dialog_save_data (self);
		gtk_widget_destroy ((GtkWidget*) self);
	}
}

static void
_account_dialog_save_button_clicked_cb_gtk_button_clicked (GtkButton* _sender,
                                                           gpointer self)
{
	account_dialog_save_button_clicked_cb ((AccountDialog*) self);
}

static void
account_dialog_class_init (AccountDialogClass * klass,
                           gpointer klass_data)
{
	account_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &AccountDialog_private_offset);
	((GtkWidgetClass *) klass)->destroy = (void (*) (GtkWidget*)) account_dialog_real_destroy;
	G_OBJECT_CLASS (klass)->finalize = account_dialog_finalize;
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/uk/co/ibboard/cawbird/ui/account-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "name_entry", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, name_entry));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "avatar_banner_widget", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, avatar_banner_widget));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "delete_stack", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, delete_stack));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "autostart_switch", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, autostart_switch));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "website_entry", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, website_entry));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "description_text_view", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, description_text_view));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "crop_widget", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, crop_widget));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "content_stack", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, content_stack));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "info_box", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, info_box));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "error_label", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, error_label));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "save_button", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, save_button));
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "description_length_label", FALSE, AccountDialog_private_offset + G_STRUCT_OFFSET (AccountDialogPrivate, description_length_label));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "delete_button_clicked_cb", G_CALLBACK(_account_dialog_delete_button_clicked_cb_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "delete_confirm_button_clicked_cb", G_CALLBACK(_account_dialog_delete_confirm_button_clicked_cb_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "delete_cancel_button_clicked_cb", G_CALLBACK(_account_dialog_delete_cancel_button_clicked_cb_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "autostart_switch_activate_cb", G_CALLBACK(_account_dialog_autostart_switch_activate_cb_g_object_notify));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "avatar_clicked_cb", G_CALLBACK(_account_dialog_avatar_clicked_cb_avatar_banner_widget_avatar_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "banner_clicked_cb", G_CALLBACK(_account_dialog_banner_clicked_cb_avatar_banner_widget_banner_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "cancel_button_clicked_cb", G_CALLBACK(_account_dialog_cancel_button_clicked_cb_gtk_button_clicked));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "save_button_clicked_cb", G_CALLBACK(_account_dialog_save_button_clicked_cb_gtk_button_clicked));
}

static void
account_dialog_instance_init (AccountDialog * self,
                              gpointer klass)
{
	self->priv = account_dialog_get_instance_private (self);
	self->priv->new_avatar = NULL;
	self->priv->new_banner = NULL;
	self->priv->old_width = 0;
	self->priv->old_height = 0;
	self->priv->account_was_not_initied = FALSE;
	g_type_ensure (TYPE_AVATAR_BANNER_WIDGET);
	g_type_ensure (TYPE_COMPLETION_TEXT_VIEW);
	g_type_ensure (TYPE_CROP_WIDGET);
	gtk_widget_init_template (GTK_WIDGET (self));
}

static void
account_dialog_finalize (GObject * obj)
{
	AccountDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ACCOUNT_DIALOG, AccountDialog);
	_g_free0 (self->priv->old_user_name);
	_g_free0 (self->priv->old_description);
	_g_free0 (self->priv->old_website);
	_g_object_unref0 (self->priv->new_avatar);
	_g_object_unref0 (self->priv->new_banner);
	G_OBJECT_CLASS (account_dialog_parent_class)->finalize (obj);
}

static GType
account_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (AccountDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) account_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountDialog), 0, (GInstanceInitFunc) account_dialog_instance_init, NULL };
	GType account_dialog_type_id;
	account_dialog_type_id = g_type_register_static (gtk_window_get_type (), "AccountDialog", &g_define_type_info, 0);
	AccountDialog_private_offset = g_type_add_instance_private (account_dialog_type_id, sizeof (AccountDialogPrivate));
	return account_dialog_type_id;
}

GType
account_dialog_get_type (void)
{
	static volatile gsize account_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&account_dialog_type_id__volatile)) {
		GType account_dialog_type_id;
		account_dialog_type_id = account_dialog_get_type_once ();
		g_once_init_leave (&account_dialog_type_id__volatile, account_dialog_type_id);
	}
	return account_dialog_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

